// Protractor configuration file, see link for more information
// https://github.com/angular/protractor/blob/master/lib/config.ts

const { SpecReporter } = require('jasmine-spec-reporter');
var date = new Date();
var resultsFolderName = date.getUTCDate() + "-" + (date.getUTCMonth() + 1) + "-" + date.getUTCFullYear() + "-" + date.getUTCHours();
var screenShotsFolder = process.cwd() + '/testResults/' + resultsFolderName + '/screenshots/';
var testResultsPath = process.cwd() + '/testResults/' + resultsFolderName + '/';


exports.config = {
    seleniumAddress: 'http://localhost:4444/wd/hub',
    allScriptsTimeout: 100000, 
    
    suites: {
        all : ['./e2e/login-page/login.spec.ts',
                './e2e/dispatch-page/dispatch.spec.ts',
                //'./e2e/menu/menu.spec.ts',
                //'./e2e/dispatch-page/dispatchKPI.spec.ts']
                //'./e2e/helpdesk-page/helpDesk.spec.ts',
                //'./e2e/helpdesk-page/hdKPI.spec.ts',
                // './e2e/clinics-page/clinics.spec.ts']
                './e2e/logout-page/logout.spec.ts']
    },
    capabilities: {
        browserName: 'chrome',
        shardTestFiles: false,
        chromeOptions: {
        //args: ['--headless', 'window-size=1920,1080'],
        }
},
    directConnect: true,
    baseUrl: 'https://sprinthub-sandbox-staging.azureedge.net/',
    SELENIUM_PROMISE_MANAGER: false,
    framework: 'jasmine',
    jasmineNodeOpts: {
        showColors: true,
        defaultTimeoutInterval: 350000,
        print: function () { }
    },

onPrepare() {
    browser.driver.manage().window().maximize();
    browser.waitForAngularEnabled(false);
        require('ts-node').register({
            project: 'e2e/tsconfig.json'
        });
            var jasmineReporters = require('jasmine-reporters');
            jasmine.getEnv().addReporter(new SpecReporter({ spec: { displayStacktrace: true } }));
            jasmine.getEnv().addReporter(new jasmineReporters.JUnitXmlReporter({
            consolidateAll: true,
            savePath: testResultsPath,
            filePrefix: 'xmlresults'
            }));
    

    // create screenshots for failed tests
    var fs = require('fs-extra');

    fs.emptyDir(screenShotsFolder, function (err) {
      console.log(err);
    });
    jasmine.getEnv().addReporter({
      specDone: function (result) {
        if (result.status === 'failed') {
          browser.getCapabilities().then(function (caps) {
            var browserName = caps.get('browserName');

            browser.takeScreenshot().then(function (png) {
              var stream = fs.createWriteStream(screenShotsFolder + browserName + '-' + result.fullName + '.png');
              stream.write(new Buffer(png, 'base64'));
              stream.end();
            });
          });
        }
      }
    });
  },

  //HTMLReport called once tests are finished
  onComplete: function () {
    var browserName, browserVersion;
    var capsPromise = browser.getCapabilities();

    capsPromise.then(function (caps) {
      browserName = caps.get('browserName');
      browserVersion = caps.get('version');

      var HTMLReport = require('protractor-html-reporter');

      testConfig = {
        reportTitle: 'Automation Test Result ' + browser.baseUrl,
        outputPath: testResultsPath,
        screenshotPath: screenShotsFolder,
        testBrowser: browserName,
        browserVersion: browserVersion,
        modifiedSuiteName: false,
        screenshotsOnlyOnFailure: true
      };
      new HTMLReport().from(testResultsPath + 'xmlresults.xml', testConfig);
    });
  }  
};

