import { Component, Injector, ViewEncapsulation, ViewChild } from '@angular/core';
import { ActivatedRoute, Router, RouterLink } from '@angular/router';
import { TagsServiceProxy, TagDto, TagTypeServiceProxy, CreateOrEditTagDto, OrderServiceProxy} from '@shared/service-proxies/service-proxies';
import { NotifyService } from '@abp/notify/notify.service';
import { AppComponentBase } from '@shared/common/app-component-base';
import { TokenAuthServiceProxy } from '@shared/service-proxies/service-proxies';
import { appModuleAnimation } from '@shared/animations/routerTransition';
import { Table } from 'primeng/components/table/table';
import { Paginator } from 'primeng/components/paginator/paginator';
import { LazyLoadEvent } from 'primeng/components/common/lazyloadevent';
import { FileDownloadService } from '@shared/utils/file-download.service';
import { Location } from '@angular/common';
import * as _ from 'lodash';
import * as moment from 'moment';
import { AppConsts } from '@shared/AppConsts';
import { AppSessionService } from '@shared/common/session/app-session.service';
import { DomHelper } from '@shared/helpers/DomHelper';

@Component({
    templateUrl: './public-tracking-page-order.component.html',
    encapsulation: ViewEncapsulation.None,
    styleUrls: ['public-tracking-page-order.component.less'],
    animations: [appModuleAnimation()]
})
export class PublicTrackingPageComponent extends AppComponentBase {

    tagName: string
    link: any
    cssTrigger = false
    tenancyName : string;
    remoteServiceBaseUrl: string = AppConsts.remoteServiceBaseUrl
    constructor(
        injector: Injector,
        private _orderDetailAppService : OrderServiceProxy,
        private router: Router,
        private location: Location,
        
        
    ) {
        super(injector);
    }

    ngOnInit(){
        // w-adjust
        var element = document.querySelectorAll('.kt-login__aside')
        console.log("here")
        element[0].classList.remove('b-none');
        element[0].classList.add('w-adjust');
        this.tenancyName = this.appSession.tenancyName
    }

    getOrderDetails(){
        this.spinnerService.show();
        this._orderDetailAppService.getTrackingId(this.tagName)
                                    .pipe()
                                    .subscribe(result=>{
                                        if(result.orderId != null){
                                            console.log(result)
                                            // this.link= '/account/tracking-page-order-detail/'+result.orderId
                                            this.router.navigate(['/account/tracking-page-order-detail/'+result.tagName+'/'+true])
                                            // this.router.navigate(['/app/sprintship/controller-order-details/'+result.orderId]);
                                            var element = document.querySelectorAll('.kt-login__aside ')
                                            element[0].classList.remove('w-adjust');
                                            element[0].classList.add('b-none');
                                            this.spinnerService.hide();
                                        }
                                        else{
                                            this.spinnerService.hide();
                                            // abp.message.warn(this.l('TrackingIDProblemTitle'), this.l('TrackingIDProblemMessage', this.tenancyName));
                                                this.message.warn(
                                                    
                                                    this.l('TrackingIDProblemMessage', [this.tenancyName]) ,this.l("TrackingIDProblemTitle")
                                                );
                                        } 
                                    })
    }

    goBack() {
        this.location.back();
        // document.querySelectorAll("kt-login__aside")
        var element = document.querySelectorAll('.kt-login__aside ')
        element[0].classList.remove('w-adjust');
        element[0].classList.remove('b-none');

        // console.log(document.querySelectorAll('.kt-login__aside '))
      } 

     

    
}
