﻿import { Component, ViewChild, Injector, Output, EventEmitter } from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { GetBackgroundProcessForViewDto, BackgroundProcessDto } from '@shared/service-proxies/service-proxies';
import { AppComponentBase } from '@shared/common/app-component-base';

@Component({
    selector: 'viewBackgroundProcessModal',
    templateUrl: './view-backgroundProcess-modal.component.html'
})
export class ViewBackgroundProcessModalComponent extends AppComponentBase {

    @ViewChild('createOrEditModal', { static: true }) modal: ModalDirective;
    @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();

    active = false;
    saving = false;

    item: GetBackgroundProcessForViewDto;


    constructor(
        injector: Injector
    ) {
        super(injector);
        this.item = new GetBackgroundProcessForViewDto();
        this.item.backgroundProcess = new BackgroundProcessDto();
    }

    show(item: GetBackgroundProcessForViewDto): void {
        this.item = item;
        this.active = true;
        this.modal.show();
    }

    close(): void {
        this.active = false;
        this.modal.hide();
    }
}
