import { Component, ViewChild, Injector, Output, EventEmitter } from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { GetExportMappingForViewDto, ExportMappingDto , ExportType, DataType} from '@shared/service-proxies/service-proxies';
import { AppComponentBase } from '@shared/common/app-component-base';

@Component({
    selector: 'viewExportMappingModal',
    templateUrl: './view-ExportMapping-modal.component.html'
})
export class ViewExportMappingModalComponent extends AppComponentBase {

    @ViewChild('createOrEditModal', { static: true }) modal: ModalDirective;
    @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();

    active = false;
    saving = false;

    item: GetExportMappingForViewDto;
    ExportType = ExportType;
    dataType = DataType;


    constructor(
        injector: Injector
    ) {
        super(injector);
        this.item = new GetExportMappingForViewDto();
        this.item.exportMapping = new ExportMappingDto();
    }

    show(item: GetExportMappingForViewDto): void {
        this.item = item;
        this.active = true;
        this.modal.show();
    }

    close(): void {
        this.active = false;
        this.modal.hide();
    }
}
