import { Component, ViewChild, Injector, Output, EventEmitter } from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { GetImportFieldForViewDto, ImportFieldDto } from '@shared/service-proxies/service-proxies';
import { AppComponentBase } from '@shared/common/app-component-base';

@Component({
    selector: 'viewImportFieldModal',
    templateUrl: './view-importField-modal.component.html'
})
export class ViewImportFieldModalComponent extends AppComponentBase {

    @ViewChild('createOrEditModal', { static: true }) modal: ModalDirective;
    @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();

    active = false;
    saving = false;

    item: GetImportFieldForViewDto;


    constructor(
        injector: Injector
    ) {
        super(injector);
        this.item = new GetImportFieldForViewDto();
        this.item.importField = new ImportFieldDto();
    }

    show(item: GetImportFieldForViewDto): void {
        this.item = item;
        this.active = true;
        this.modal.show();
    }

    close(): void {
        this.active = false;
        this.modal.hide();
    }
}
