﻿import { Component, ViewChild, Injector, Output, EventEmitter } from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { GetImportMappingForViewDto, ImportMappingDto , ImportType, DataType} from '@shared/service-proxies/service-proxies';
import { AppComponentBase } from '@shared/common/app-component-base';

@Component({
    selector: 'viewImportMappingModal',
    templateUrl: './view-importMapping-modal.component.html'
})
export class ViewImportMappingModalComponent extends AppComponentBase {

    @ViewChild('createOrEditModal', { static: true }) modal: ModalDirective;
    @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();

    active = false;
    saving = false;

    item: GetImportMappingForViewDto;
    importType = ImportType;
    dataType = DataType;


    constructor(
        injector: Injector
    ) {
        super(injector);
        this.item = new GetImportMappingForViewDto();
        this.item.importMapping = new ImportMappingDto();
    }

    show(item: GetImportMappingForViewDto): void {
        this.item = item;
        this.active = true;
        this.modal.show();
    }

    close(): void {
        this.active = false;
        this.modal.hide();
    }
}
