import { Component, ViewChild, Injector, Output, EventEmitter } from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { GetImportMapForViewDto, ImportMapDto } from '@shared/service-proxies/service-proxies';
import { AppComponentBase } from '@shared/common/app-component-base';

@Component({
    selector: 'viewImportMapModal',
    templateUrl: './view-importMap-modal.component.html'
})
export class ViewImportMapModalComponent extends AppComponentBase {

    @ViewChild('createOrEditModal', { static: true }) modal: ModalDirective;
    @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();

    active = false;
    saving = false;

    item: GetImportMapForViewDto;


    constructor(
        injector: Injector
    ) {
        super(injector);
        this.item = new GetImportMapForViewDto();
        this.item.importMap = new ImportMapDto();
    }

    show(item: GetImportMapForViewDto): void {
        this.item = item;
        this.active = true;
        this.modal.show();
    }

    close(): void {
        this.active = false;
        this.modal.hide();
    }
}
