import { Component, ViewChild, Injector, Output, EventEmitter } from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { GetImportTableForViewDto, ImportTableDto } from '@shared/service-proxies/service-proxies';
import { AppComponentBase } from '@shared/common/app-component-base';

@Component({
    selector: 'viewImportTableModal',
    templateUrl: './view-importTable-modal.component.html'
})
export class ViewImportTableModalComponent extends AppComponentBase {

    @ViewChild('createOrEditModal', { static: true }) modal: ModalDirective;
    @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();

    active = false;
    saving = false;

    item: GetImportTableForViewDto;


    constructor(
        injector: Injector
    ) {
        super(injector);
        this.item = new GetImportTableForViewDto();
        this.item.importTable = new ImportTableDto();
    }

    show(item: GetImportTableForViewDto): void {
        this.item = item;
        this.active = true;
        this.modal.show();
    }

    close(): void {
        this.active = false;
        this.modal.hide();
    }
}
