﻿import { Component, ViewChild, Injector, Output, EventEmitter } from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { GetRouteHandOffDefinitionForViewDto, RouteHandOffDefinitionDto } from '@shared/service-proxies/service-proxies';
import { AppComponentBase } from '@shared/common/app-component-base';

@Component({
    selector: 'viewRouteHandOffDefinitionModal',
    templateUrl: './view-routeHandOffDefinition-modal.component.html'
})
export class ViewRouteHandOffDefinitionModalComponent extends AppComponentBase {

    @ViewChild('createOrEditModal', { static: true }) modal: ModalDirective;
    @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();

    active = false;
    saving = false;

    item: GetRouteHandOffDefinitionForViewDto;


    constructor(
        injector: Injector
    ) {
        super(injector);
        this.item = new GetRouteHandOffDefinitionForViewDto();
        this.item.routeHandOffDefinition = new RouteHandOffDefinitionDto();
    }

    show(item: GetRouteHandOffDefinitionForViewDto): void {
        this.item = item;
        this.active = true;
        this.modal.show();
    }

    close(): void {
        this.active = false;
        this.modal.hide();
    }
}
