﻿import { Component, ViewChild, Injector, Output, EventEmitter } from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { GetRouteHandOffScheduleDetailForViewDto, RouteHandOffScheduleDetailDto } from '@shared/service-proxies/service-proxies';
import { AppComponentBase } from '@shared/common/app-component-base';

@Component({
    selector: 'viewRouteHandOffScheduleDetailModal',
    templateUrl: './view-routeHandOffScheduleDetail-modal.component.html'
})
export class ViewRouteHandOffScheduleDetailModalComponent extends AppComponentBase {

    @ViewChild('createOrEditModal', { static: true }) modal: ModalDirective;
    @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();

    active = false;
    saving = false;

    item: GetRouteHandOffScheduleDetailForViewDto;


    constructor(
        injector: Injector
    ) {
        super(injector);
        this.item = new GetRouteHandOffScheduleDetailForViewDto();
        this.item.routeHandOffScheduleDetail = new RouteHandOffScheduleDetailDto();
    }

    show(item: GetRouteHandOffScheduleDetailForViewDto): void {
        this.item = item;
        this.active = true;
        this.modal.show();
    }

    close(): void {
        this.active = false;
        this.modal.hide();
    }
}
