﻿import { NgModule } from '@angular/core';
import { RouterModule } from '@angular/router';
//import { RouteTemplateOrderExtrasComponent } from './routeTemplateOrderExtras/routeTemplateOrderExtras/routeTemplateOrderExtras.component';


import { OrderSourceConnectionsComponent } from './orderSourceConnections/orderSourceConnections.component';
import { OrderSourcesComponent } from './orderSources/orderSources.component';
import { Route4MeSettingsComponent } from './route4Me/route4MeSettings/route4MeSettings.component';
import { BackgroundProcessesComponent } from './backgroundProcesses/backgroundProcesses/backgroundProcesses.component';
//import { OrderTypesComponent } from './orderTypes/orderTypes/orderTypes.component';
import { ImportMapsComponent } from './importMaps/importMaps/importMaps.component';
import { ImportFieldsComponent } from './importFields/importFields/importFields.component';
import { ImportTablesComponent } from './importTables/importTables/importTables.component';
import { UserPreferencesComponent } from './preferences/userPreferences/userPreferences.component';
import { ClientPreferencesComponent } from './preferences/clientPreferences/clientPreferences.component';
import { PreferencesComponent } from './preferences/preferences/preferences.component';
import { RouteDefinitionsComponent } from './laboratory/routeDefinitions/routeDefinitions.component';

import { RouteTypesComponent } from './laboratory/routeTypes/routeTypes.component';
import { RouteScheduleDetailsComponent } from './laboratory/routeScheduleDetails/routeScheduleDetails.component';
import { RouteSchedulesComponent } from './laboratory/routeSchedules/routeSchedules.component';
import { RouteStopsComponent } from './laboratory/routeStops/routeStops.component';
import { ClinicsComponent } from './laboratory/clinics/clinics.component';
import { CreateEditClinicComponent } from './laboratory/clinics/create-or-edit-clinic.component';
import { ClinicScheduleComponent } from './laboratory/clinics/clinic-schedule.component';
import { DashboardComponent } from './dashboard/dashboard.component';
import { ClinicHistoryComponent } from './laboratory/clinics/clinic-history.component';
import { ReportDesignerComponent } from './report/report-designer.component';
import { ReportComponent } from './report/report.component';
import { ReportLogComponent } from './report/reportLogs/report-logs.component';
import { ReportViewerComponent } from './report/report-viewer.component';
import { ReportBasicComponent } from './report/report-basic.component';
import { ReportScheduleModalComponent } from './report/reportSchedule/report-schedule-modal.component';
import { ImportLogsComponent } from '@app/admin/logging/importLogs/importLogs.component';
import { HolidaysComponent } from './locations/holidays/holidays.component';
import { ImportMappingsComponent } from './importMappings/importMappings/import-mapping.component';
import { OrderSourceMappingsComponent } from './orderSources/view-ordersource-mapping.component';
import { RouteHandOffDefinitionsComponent } from './laboratory/routeHandOffDefinitions/line-haul-route.component';
import { RouteHandOffScheduleDetailsComponent } from './laboratory/routeHandOffDefinitions/line-haul-route-schedule.component';
import { ReportScheduleComponent } from './report/reportSchedule/report-schedule.component';
import { ExportMappingsComponent } from './exportMappings/export-mapping.component';
import { OrderSourceExportMappingsComponent } from './orderSources/view-ordersource-exportMapping.component';
import { ClinicGroupsUnitComponent } from './laboratory/clinic-groups/clinic-groups-unit.component';
@NgModule({
    imports: [
        RouterModule.forChild([
            {
                path: '',
                children: [
                    //{ path: 'routeTemplateOrderExtras/routeTemplateOrderExtras', component: RouteTemplateOrderExtrasComponent, data: { permission: 'Pages.RouteTemplateOrderExtras' }  },
                    
                    { path: 'sources-connections/:id', component: OrderSourceConnectionsComponent, data: { permission: 'Pages.OrderSourceConnections' }  },
                    { path: 'order-sources', component: OrderSourcesComponent, data: { permission: 'Pages.OrderSources' }  },
                    { path: 'importLogs', component: ImportLogsComponent, data: { permission: 'Pages.Administration.ImportLogs' }  },
                    { path: 'import-mapping', component: ImportMappingsComponent, data: { permission: 'Pages.ImportMappings' }  },
                    { path: 'view-mappings/:id', component: OrderSourceMappingsComponent, data: { permission: 'Pages.OrderSources'} },
                    { path: 'export-mapping', component: ExportMappingsComponent, data: { permission: 'Pages.ExportMappings' }  },
                    { path: 'view-export-mappings/:id', component: OrderSourceExportMappingsComponent, data: { permission: 'Pages.OrderSources'} },
                    { path: 'locations/holidays', component: HolidaysComponent, data: { permission: 'Pages.Holidays' }  },
                    { path: 'route4Me/route4MeSettings', component: Route4MeSettingsComponent, data: { permission: 'Pages.Route4MeSettings' }  },
                    { path: 'backgroundProcesses/backgroundProcesses', component: BackgroundProcessesComponent, data: { permission: 'Pages.BackgroundProcesses' }  },
                    //{ path: 'orderTypes/orderTypes', component: OrderTypesComponent, data: { permission: 'Pages.OrderTypes' }  },
                    { path: 'importMaps/importMaps', component: ImportMapsComponent, data: { permission: 'Pages.ImportMaps' }  },
                    { path: 'importFields/importFields', component: ImportFieldsComponent, data: { permission: 'Pages.ImportFields' }  },
                    { path: 'importTables/importTables', component: ImportTablesComponent, data: { permission: 'Pages.ImportTables' }  },
                    { path: 'preferences/userPreferences', component: UserPreferencesComponent, data: { permission: 'Pages.UserPreferences' }  },
                    { path: 'preferences/clientPreferences', component: ClientPreferencesComponent, data: { permission: 'Pages.ClientPreferences' }  },
                    { path: 'preferences/preferences', component: PreferencesComponent, data: { permission: 'Pages.Preferences' }  },
                    // { path: 'laboratory/routeDefinitions', component: RouteDefinitionsComponent, data: { permission: 'Pages.RouteDefinitions' }  },
                    { path: 'laboratory/line-haul-route', component: RouteHandOffDefinitionsComponent, data: { permission: 'Pages.RouteHandOffDefinitions' } },
                    { path: 'laboratory/line-haul-route-schedule/:id', component: RouteHandOffScheduleDetailsComponent, data: { permission: 'Pages.RouteHandOffScheduleDetails' }  },
                    { path: 'laboratory/routeTypes', component: RouteTypesComponent, data: { permission: 'Pages.RouteTypes' }  },
                    { path: 'laboratory/routeScheduleDetails', component: RouteScheduleDetailsComponent, data: { permission: 'Pages.RouteScheduleDetails' }  },
                    { path: 'laboratory/routeSchedules', component: RouteSchedulesComponent, data: { permission: 'Pages.RouteSchedules' }  },
                    // { path: 'laboratory/routeStops', component: RouteStopsComponent, data: { permission: 'Pages.RouteStops' }  },
                    { path: 'laboratory/clinics', component: ClinicsComponent, data: { permission: 'Pages.Clinics' }  },
                    { path: 'laboratory/clinics/:id', component: CreateEditClinicComponent, data: { permission: 'Pages.Clinics' } },
                    { path: 'laboratory/clinics-create', component: CreateEditClinicComponent, data: { permission: 'Pages.Clinics' } },
                    { path: 'laboratory/clinics-schedule/:id', component: ClinicScheduleComponent, data: { permission: 'Pages.Clinics' } },
                    { path: 'laboratory/clinic-groups', component: ClinicGroupsUnitComponent, data: { permission: 'Pages.Clinics' }  },
                    { path: 'dashboard', component: DashboardComponent, data: { permission: 'Pages.Tenant.Dashboard' } },
                    { path: 'laboratory/clinic-history/:id', component: ClinicHistoryComponent, data: { permission: 'Pages.Clinics' } },
                    { path: 'report-designer', component: ReportDesignerComponent, data: { permission: 'Pages.Shipping.Pages.Create.Manager' } },
                    { path: 'report-basic', component: ReportBasicComponent, data: { permission: 'Pages.Shipping.Pages.Create' } },
                    { path: 'report-designer-edit/:name', component: ReportDesignerComponent, data: { permission: 'Pages.Shipping.Pages.Edit.Manager' } },
                    { path: 'report-viewer/:name', component: ReportViewerComponent, data: { permission: 'Pages.Shipping.PagesReports' } },
                    { path: 'report', component: ReportComponent, data: { permission: 'Pages.Shipping.PagesReports' } },
                    { path: 'report-logs', component: ReportLogComponent, data: { permission: 'Pages.Shipping.PagesReports' } },
                    { path: 'report/report-schedule', component: ReportScheduleModalComponent , data: { permission: 'Pages.Shipping.PagesReports' } },
                    { path: 'reportSchedule/:id', component: ReportScheduleComponent , data: { permission: 'Pages.Shipping.PagesReports' } }
                ]
            }
        ])
    ],
    exports: [
        RouterModule
    ]
})
export class MainRoutingModule { }
