﻿import { CommonModule } from '@angular/common';
import { NgModule } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { AppCommonModule } from '@app/shared/common/app-common.module';
import { RouteTemplateOrderExtrasComponent } from './routeTemplateOrderExtras/routeTemplateOrderExtras/routeTemplateOrderExtras.component';
import { ViewRouteTemplateOrderExtrasModalComponent } from './routeTemplateOrderExtras/routeTemplateOrderExtras/view-routeTemplateOrderExtras-modal.component';
import { CreateOrEditRouteTemplateOrderExtrasModalComponent } from './routeTemplateOrderExtras/routeTemplateOrderExtras/create-or-edit-routeTemplateOrderExtras-modal.component';


import { OrderSourceMappingsComponent } from './orderSources/view-ordersource-mapping.component';

import { OrderSourceConnectionsComponent } from './orderSourceConnections/orderSourceConnections.component';
import { ViewOrderSourceConnectionModalComponent } from './orderSourceConnections/view-orderSourceConnection-modal.component';
import { CreateOrEditOrderSourceConnectionModalComponent } from './orderSourceConnections/create-or-edit-orderSourceConnection-modal.component';

import { HolidaysComponent } from './locations/holidays/holidays.component';
import { ViewHolidayModalComponent } from './locations/holidays/view-holiday-modal.component';
import { CreateOrEditHolidayModalComponent } from './locations/holidays/create-or-edit-holiday-modal.component';

import { RouteHandOffScheduleDetailsComponent } from './laboratory/routeHandOffDefinitions/line-haul-route-schedule.component';
import { ViewRouteHandOffScheduleDetailModalComponent } from './laboratory/routeHandOffDefinitions/view-routeHandOffScheduleDetail-modal.component';
import { CreateOrEditRouteHandOffScheduleDetailModalComponent } from './laboratory/routeHandOffDefinitions/create-or-edit-routeHandOffScheduleDetail-modal.component';
import { RouteHandOffScheduleDetailRouteTemplateLookupTableModalComponent } from './laboratory/routeHandOffDefinitions/routeHandOffScheduleDetail-routeTemplate-lookup-table-modal.component';
import { AssignManagerToLocationLineHaulModalComponent } from './laboratory/routeHandOffDefinitions/assign-manager-to-location-linehaul-modal.component';
import { AssignRouteToManagerLineHaulModalComponent } from './laboratory/routeHandOffDefinitions/assign-route-to-manager-linehaul-modal.component';

import { RouteHandOffDefinitionsComponent } from './laboratory/routeHandOffDefinitions/line-haul-route.component';
import { ViewRouteHandOffDefinitionModalComponent } from './laboratory/routeHandOffDefinitions/view-routeHandOffDefinition-modal.component';
import { CreateOrEditRouteHandOffDefinitionModalComponent } from './laboratory/routeHandOffDefinitions/create-or-edit-routeHandOffDefinition-modal.component';
import { RouteHandOffDefinitionRouteTemplateLookupTableModalComponent } from './laboratory/routeHandOffDefinitions/routeHandOffDefinition-routeTemplate-lookup-table-modal.component';
import { RouteHandOffDefinitionRouteTypeLookupTableModalComponent } from './laboratory/routeHandOffDefinitions/routeHandOffDefinition-routeType-lookup-table-modal.component';

import { Route4MeSettingsComponent } from './route4Me/route4MeSettings/route4MeSettings.component';
import { ViewRoute4MeSettingModalComponent } from './route4Me/route4MeSettings/view-route4MeSetting-modal.component';
import { CreateOrEditRoute4MeSettingModalComponent } from './route4Me/route4MeSettings/create-or-edit-route4MeSetting-modal.component';

import { ImportMappingsComponent } from './importMappings/importMappings/import-mapping.component';
import { ViewImportMappingModalComponent } from './importMappings/importMappings/view-importMapping-modal.component';
import { CreateOrEditImportMappingModalComponent } from './importMappings/importMappings/create-or-edit-importMapping-modal.component';

import { BackgroundProcessesComponent } from './backgroundProcesses/backgroundProcesses/backgroundProcesses.component';
import { ViewBackgroundProcessModalComponent } from './backgroundProcesses/backgroundProcesses/view-backgroundProcess-modal.component';
import { CreateOrEditBackgroundProcessModalComponent } from './backgroundProcesses/backgroundProcesses/create-or-edit-backgroundProcess-modal.component';

import { ImportMapsComponent } from './importMaps/importMaps/importMaps.component';
import { ViewImportMapModalComponent } from './importMaps/importMaps/view-importMap-modal.component';
import { CreateOrEditImportMapModalComponent } from './importMaps/importMaps/create-or-edit-importMap-modal.component';
import { ImportMapImportFieldLookupTableModalComponent } from './importMaps/importMaps/importMap-importField-lookup-table-modal.component';

import { ImportFieldsComponent } from './importFields/importFields/importFields.component';
import { ViewImportFieldModalComponent } from './importFields/importFields/view-importField-modal.component';
import { CreateOrEditImportFieldModalComponent } from './importFields/importFields/create-or-edit-importField-modal.component';
import { ImportFieldImportTableLookupTableModalComponent } from './importFields/importFields/importField-importTable-lookup-table-modal.component';

import { ImportTablesComponent } from './importTables/importTables/importTables.component';
import { ViewImportTableModalComponent } from './importTables/importTables/view-importTable-modal.component';
import { CreateOrEditImportTableModalComponent } from './importTables/importTables/create-or-edit-importTable-modal.component';


import { UserPreferencesComponent } from './preferences/userPreferences/userPreferences.component';
import { ViewUserPreferenceModalComponent } from './preferences/userPreferences/view-userPreference-modal.component';
import { CreateOrEditUserPreferenceModalComponent } from './preferences/userPreferences/create-or-edit-userPreference-modal.component';

import { ClientPreferencesComponent } from './preferences/clientPreferences/clientPreferences.component';
import { ViewClientPreferenceModalComponent } from './preferences/clientPreferences/view-clientPreference-modal.component';
import { CreateOrEditClientPreferenceModalComponent } from './preferences/clientPreferences/create-or-edit-clientPreference-modal.component';

import { PreferencesComponent } from './preferences/preferences/preferences.component';
import { ViewPreferenceModalComponent } from './preferences/preferences/view-preference-modal.component';
import { CreateOrEditPreferenceModalComponent } from './preferences/preferences/create-or-edit-preference-modal.component';

import { RouteDefinitionsComponent } from './laboratory/routeDefinitions/routeDefinitions.component';
import { ViewRouteDefinitionModalComponent } from './laboratory/routeDefinitions/view-routeDefinition-modal.component';
import { CreateOrEditRouteDefinitionModalComponent } from './laboratory/routeDefinitions/create-or-edit-routeDefinition-modal.component';
import { RouteDefinitionRouteTypeLookupTableModalComponent } from './laboratory/routeDefinitions/routeDefinition-routeType-lookup-table-modal.component';


import { RouteStopsComponent } from './laboratory/routeStops/routeStops.component';
import { ViewRouteStopModalComponent } from './laboratory/routeStops/view-routeStop-modal.component';
import { CreateOrEditRouteStopModalComponent } from './laboratory/routeStops/create-or-edit-routeStop-modal.component';
import { RouteStopContactLookupTableModalComponent } from './laboratory/routeStops/routeStop-contact-lookup-table-modal.component';



import { RouteTypesComponent } from './laboratory/routeTypes/routeTypes.component';
import { ViewRouteTypeModalComponent } from './laboratory/routeTypes/view-routeType-modal.component';
import { CreateOrEditRouteTypeModalComponent } from './laboratory/routeTypes/create-or-edit-routeType-modal.component';

import { RouteScheduleDetailsComponent } from './laboratory/routeScheduleDetails/routeScheduleDetails.component';
import { ViewRouteScheduleDetailModalComponent } from './laboratory/routeScheduleDetails/view-routeScheduleDetail-modal.component';
import { CreateOrEditRouteScheduleDetailModalComponent } from './laboratory/routeScheduleDetails/create-or-edit-routeScheduleDetail-modal.component';

import { RouteSchedulesComponent } from './laboratory/routeSchedules/routeSchedules.component';
import { ViewRouteScheduleModalComponent } from './laboratory/routeSchedules/view-routeSchedule-modal.component';
import { CreateOrEditRouteScheduleModalComponent } from './laboratory/routeSchedules/create-or-edit-routeSchedule-modal.component';


import { ClinicsComponent } from './laboratory/clinics/clinics.component';
import { ViewClinicModalComponent } from './laboratory/clinics/view-clinic-modal.component';
import { CreateOrEditClinicModalComponent } from './laboratory/clinics/create-or-edit-clinic-modal.component';
import { ClinicScheduleComponent } from './laboratory/clinics/clinic-schedule.component';


import { AutoCompleteModule } from 'primeng/autocomplete';
import { PaginatorModule } from 'primeng/paginator';
import { EditorModule } from 'primeng/editor';
import { InputMaskModule } from 'primeng/inputmask'; import { FileUploadModule } from 'primeng/fileupload';
import { TableModule } from 'primeng/table';

import { UtilsModule } from '@shared/utils/utils.module';
import { CountoModule } from 'angular2-counto';
import { ModalModule, TabsModule, TooltipModule, BsDropdownModule, PopoverModule, BsModalRef, TimepickerModule } from 'ngx-bootstrap';
import { TimePickerModule } from '@progress/kendo-angular-dateinputs';
import { DashboardComponent } from './dashboard/dashboard.component';

import { MainRoutingModule } from './main-routing.module';
import { NgxChartsModule } from '@swimlane/ngx-charts';
import { GooglePlaceModule } from 'ngx-google-places-autocomplete';

import { BsDatepickerModule, BsDatepickerConfig, BsDaterangepickerConfig, BsLocaleService } from 'ngx-bootstrap/datepicker';
import { NgxBootstrapDatePickerConfigService } from 'assets/ngx-bootstrap/ngx-bootstrap-datepicker-config.service';
import { FlyOutComponent } from '@app/shared/layout/flyout/flyout.component';
import { AgmCoreModule, LAZY_MAPS_API_CONFIG } from '@agm/core';
import { FlyOutLocationModalComponent } from '@app/shared/layout/flyout/location/location-modal.component';
import { FlyOutPackageTypeModalComponent } from '@app/shared/layout/flyout/package-type/package-type-modal.component';
import { FlyOutFleetModalComponent } from '@app/shared/layout/flyout/fleet/fleet-modal.component';
import { FlyOutContactsModalComponent } from '@app/shared/layout/flyout/contacts/contacts-modal.component';
import { AddressFormComponent } from '@app/shared/layout/form/address-form.component';
import { ContactFormComponent } from '@app/shared/layout/form/contact.form.component';
import { FlyOutDriverModalComponent } from '@app/shared/layout/flyout/driver/driver-modal.component';
import { ContactFormMainComponent } from '@app/shared/layout/formMain/contact.form.component';
import { AddressFormMainComponent } from '@app/shared/layout/formMain/address-form.component';
// import { ColorPickerModule } from 'primeng/components/colorpicker/colorpicker';
import { ColorPickerModule } from 'ngx-color-picker';
import { ClinicScheduleFlyOutComponent } from '@app/shared/layout/flyout/clinic-schedule/clinic-schedule-flyout.component';
import { QRCodeModule } from 'angular2-qrcode';

import { CreateEditClinicComponent } from './laboratory/clinics/create-or-edit-clinic.component';
import { UserPreferencesFlyoutComponent } from '@app/shared/layout/flyout/user-preferences/user-preferences-flyout.component';
import { ReactiveFormsModule } from '@angular/forms';
import { CallBackModalComponent } from '@app/sprintship/controller/modals/call_back_modal.component';
import { ClinicCallInModalComponent } from '@app/sprintship/controller/modals/clinic_callin_modal.component';
import { CallInModalComponent } from '@app/sprintship/controller/modals/call_in_modal.component';

import { ImportRouteScheduleTracking } from './laboratory/clinics/route-schedule-import-tracking';
import { ClinicHistoryComponent } from './laboratory/clinics/clinic-history.component';
import { AttachmentComponent } from './laboratory/clinics/attachment.component';
import { MissedPickUpModalComponent } from './laboratory/clinics/missed-pickup.component';
// import { AssignRouteToManagerModalComponent } from './laboratory/routeDefinitions/assign-route-to-manager.modal.component';

import { AssignRouteToManagerModalComponent } from './laboratory/routeDefinitions/assign-route-to-manager.modal.component';
import { NgxDropzoneModule } from 'ngx-dropzone';
import { AssignManagerToLocationModalComponent } from './laboratory/routeDefinitions/assign-manager-to-location.modal.component';

NgxBootstrapDatePickerConfigService.registerNgxBootstrapDatePickerLocales();

import { ImportReportModalComponent } from './report/importReport/import-report-modal.component';
import { ReportDesignerComponent } from './report/report-designer.component';
import { DxReportViewerModule, DxReportDesignerModule } from 'devexpress-reporting-angular';
// import { DxDataGridModule } from "devextreme-angular";
import { ReportComponent } from './report/report.component';
import { ReportLogComponent } from './report/reportLogs/report-logs.component';
import { ReportViewerComponent } from './report/report-viewer.component';
import { ReportBasicComponent } from './report/report-basic.component';
import { HistorySendEmailComponent } from './laboratory/clinics/sendorderdetail-modal';
import { ReportScheduleModalComponent } from './report/reportSchedule/report-schedule-modal.component';
import { ImportLogsComponent } from '@app/admin/logging/importLogs/importLogs.component';
import { ViewImportLogModalComponent } from '@app/admin/logging/importLogs/view-importLog-modal.component';
import { CreateOrEditImportLogModalComponent } from '@app/admin/logging/importLogs/create-or-edit-importLog-modal.component';
import { OrderSourcesComponent } from './orderSources/orderSources.component';
import { ViewOrderSourceModalComponent } from './orderSources/view-orderSource-modal.component';
import { CreateOrEditOrderSourceModalComponent } from './orderSources/create-or-edit-orderSource-modal.component';
import { HolidayAddLocationComponent } from './locations/holidays/holiday-add-location/holiday-add-location.component';
import { CalendarAddRouteComponent } from './locations/holidays/calendar-add-route/calendar-add-route.component';
import { ReportScheduleComponent } from './report/reportSchedule/report-schedule.component';
import { CreateReportScheduleModalComponent } from './report/reportSchedule/create-report-schedule-modal.component';
import { EditReportScheduleModalComponent } from './report/reportSchedule/edit-report-schedule-modal.component';
import { ViewReportScheduleModalComponent } from './report/reportSchedule/view-report-schedule-modal.component';
import { OrderSourceExportMappingsComponent } from './orderSources/view-ordersource-exportMapping.component';
import { CreateOrEditExportMappingModalComponent } from './exportMappings/create-or-edit-exportMapping-modal.component';
import { ExportMappingsComponent } from './exportMappings/export-mapping.component';
import { ViewExportMappingModalComponent } from './exportMappings/view-exportMapping-modal.component';
import { ExportOrderEDIModalComponent } from './exportMappings/export-order-edi.component';
import { AppConsts } from '@shared/AppConsts';
import { GoogleMapsConfig } from 'AppPreBootstrap';
import { ClinicGroupsUnitComponent } from './laboratory/clinic-groups/clinic-groups-unit.component';
import { ClinicGroupTreeComponent } from './laboratory/clinic-groups/clinic-groups-tree.component';
import { CreateOrEditCustomerGroupsModal } from './laboratory/clinic-groups/create-or-edit-customer-groups.component';
import { ClinicCustomerGroup } from './laboratory/clinic-groups/clinic-groups-customer.component';
import { AddCustomerModalComponent } from './laboratory/clinic-groups/add-customer.component';

import { TreeModule } from 'primeng/tree';
import { ContextMenuModule } from 'primeng/contextmenu';
import { ClinicGroupsSettings } from './laboratory/clinic-groups/clinic-groups-settings.component';
import { AddSettingModalComponent } from './laboratory/clinic-groups/add-settings.component';

@NgModule({
  imports: [
    FileUploadModule,
    ReactiveFormsModule,
    NgxDropzoneModule,
    AutoCompleteModule,
    PaginatorModule,
    EditorModule,
    InputMaskModule, TableModule,
    ColorPickerModule,
    CommonModule,
    FormsModule,
    ModalModule.forRoot(),
    TabsModule,
    TooltipModule,
    AppCommonModule,
    UtilsModule,
    MainRoutingModule,
    CountoModule,
    NgxChartsModule,
    QRCodeModule,
    GooglePlaceModule,
    BsDatepickerModule.forRoot(),
    BsDropdownModule.forRoot(),
    TimepickerModule.forRoot(),
    TimePickerModule,
    DxReportViewerModule,
    DxReportDesignerModule,
    // DxDataGridModule,
    PopoverModule.forRoot(),
    AgmCoreModule.forRoot(),
    TreeModule,
    ContextMenuModule
  ],
  declarations: [
		RouteTemplateOrderExtrasComponent,

		ViewRouteTemplateOrderExtrasModalComponent,
		CreateOrEditRouteTemplateOrderExtrasModalComponent,
    AddSettingModalComponent,
    ClinicGroupsSettings,
    AddCustomerModalComponent,
    ClinicCustomerGroup,
    CreateOrEditCustomerGroupsModal,
    ClinicGroupTreeComponent,
    ClinicGroupsUnitComponent,
    OrderSourceMappingsComponent,
    OrderSourcesComponent,
		ViewOrderSourceModalComponent,
    CreateOrEditOrderSourceModalComponent,
    OrderSourceConnectionsComponent,
		ViewOrderSourceConnectionModalComponent,
    CreateOrEditOrderSourceConnectionModalComponent,
    ImportLogsComponent,
		ViewImportLogModalComponent,
		CreateOrEditImportLogModalComponent,
    CreateOrEditImportMappingModalComponent,
    RouteHandOffScheduleDetailsComponent,
    ViewRouteHandOffScheduleDetailModalComponent,
    CreateOrEditRouteHandOffScheduleDetailModalComponent,
    RouteHandOffScheduleDetailRouteTemplateLookupTableModalComponent,
    RouteHandOffDefinitionsComponent,
    ViewRouteHandOffDefinitionModalComponent,
    CreateOrEditRouteHandOffDefinitionModalComponent,
    RouteHandOffDefinitionRouteTemplateLookupTableModalComponent,
    RouteHandOffDefinitionRouteTypeLookupTableModalComponent,
    AssignManagerToLocationLineHaulModalComponent,
    AssignRouteToManagerLineHaulModalComponent,
    ViewImportMappingModalComponent,
    ImportMappingsComponent,
    ExportMappingsComponent,
		ViewExportMappingModalComponent,
		CreateOrEditExportMappingModalComponent,
    OrderSourceExportMappingsComponent,
    ExportOrderEDIModalComponent,
		HolidaysComponent,
		ViewHolidayModalComponent,
    CreateOrEditHolidayModalComponent,
    HolidayAddLocationComponent,
    Route4MeSettingsComponent,
    ViewRoute4MeSettingModalComponent, 
    CreateOrEditRoute4MeSettingModalComponent,
    BackgroundProcessesComponent,
    ViewBackgroundProcessModalComponent, 
    CreateOrEditBackgroundProcessModalComponent,
    ImportMapsComponent,
    ViewImportMapModalComponent, 
    CreateOrEditImportMapModalComponent,
    ImportMapImportFieldLookupTableModalComponent,
    ImportFieldsComponent,
    ViewImportFieldModalComponent, 
    CreateOrEditImportFieldModalComponent,
    ImportFieldImportTableLookupTableModalComponent,
    ImportTablesComponent,
    ViewImportTableModalComponent, 
    CreateOrEditImportTableModalComponent,
    UserPreferencesComponent,
    ViewUserPreferenceModalComponent, 
    CreateOrEditUserPreferenceModalComponent,
    ClientPreferencesComponent,
    ViewClientPreferenceModalComponent, 
    CreateOrEditClientPreferenceModalComponent,
    PreferencesComponent,
    ViewPreferenceModalComponent, 
    CreateOrEditPreferenceModalComponent,
    RouteDefinitionsComponent,
    ViewRouteDefinitionModalComponent, 
    CreateOrEditRouteDefinitionModalComponent,
    RouteDefinitionRouteTypeLookupTableModalComponent,
    RouteStopsComponent,
    ViewRouteStopModalComponent, 
    CreateOrEditRouteStopModalComponent,
    RouteStopContactLookupTableModalComponent,
    RouteTypesComponent,
    ViewRouteTypeModalComponent, 
    CreateOrEditRouteTypeModalComponent,
    RouteScheduleDetailsComponent,
    ViewRouteScheduleDetailModalComponent, 
    CreateOrEditRouteScheduleDetailModalComponent,
    RouteSchedulesComponent,
    ViewRouteScheduleModalComponent, 
    CreateOrEditRouteScheduleModalComponent,
    ClinicsComponent,
    ViewClinicModalComponent, 
    CreateOrEditClinicModalComponent,
    ClinicScheduleComponent,
    DashboardComponent,
    FlyOutComponent,
    FlyOutLocationModalComponent,
    FlyOutPackageTypeModalComponent,
    FlyOutFleetModalComponent,
    FlyOutDriverModalComponent,
    FlyOutContactsModalComponent,
    ContactFormMainComponent,
    // AddressFormMainComponent,
    AddressFormMainComponent,
    AddressFormComponent,
    CreateEditClinicComponent,
    ClinicScheduleFlyOutComponent,
    CallBackModalComponent,
    ClinicCallInModalComponent,
    CallInModalComponent,
    ImportRouteScheduleTracking,
    ClinicHistoryComponent,
    AttachmentComponent,
    MissedPickUpModalComponent,
    AssignRouteToManagerModalComponent,
    AssignManagerToLocationModalComponent,
    ReportDesignerComponent,
    ReportComponent,
    ReportLogComponent,
    ReportViewerComponent,
    ReportBasicComponent,
    HistorySendEmailComponent,
    ReportScheduleModalComponent,
    CalendarAddRouteComponent,
    ReportScheduleComponent,
    CreateReportScheduleModalComponent,
    EditReportScheduleModalComponent,
    ViewReportScheduleModalComponent,
    ImportReportModalComponent
  ],
  exports: [
    CallInModalComponent,
    AddressFormComponent,
    ImportRouteScheduleTracking
    // AssignRouteToManagerModalComponent
  ],
  providers: [
    { provide: BsDatepickerConfig, useFactory: NgxBootstrapDatePickerConfigService.getDatepickerConfig },
    { provide: BsDaterangepickerConfig, useFactory: NgxBootstrapDatePickerConfigService.getDaterangepickerConfig },
    { provide: BsLocaleService, useFactory: NgxBootstrapDatePickerConfigService.getDatepickerLocale },
    { provide: LAZY_MAPS_API_CONFIG, useClass: GoogleMapsConfig}
  ]
})
export class MainModule { }
