﻿import { Component, ViewChild, Injector, Output, EventEmitter } from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { GetOrderSourceConnectionForViewDto, OrderSourceConnectionDto,ConnectionType, ConnectionDto } from '@shared/service-proxies/service-proxies';
import { AppComponentBase } from '@shared/common/app-component-base';
@Component({
    selector: 'viewOrderSourceConnectionModal',
    templateUrl: './view-orderSourceConnection-modal.component.html'
})
export class ViewOrderSourceConnectionModalComponent extends AppComponentBase {

    @ViewChild('createOrEditModal', { static: true }) modal: ModalDirective;
    @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();

    active = false;
    saving = false;
    connectionType = ConnectionType

    item: GetOrderSourceConnectionForViewDto;


    constructor(
        injector: Injector
    ) {
        super(injector);
        this.item = new GetOrderSourceConnectionForViewDto();
        this.item.orderSourceConnection = new OrderSourceConnectionDto();
        this.item.orderSourceConnection.connection = new ConnectionDto();
    }

    show(item: GetOrderSourceConnectionForViewDto): void {
        this.item = item;
        this.active = true;
        this.modal.show();
    }

    close(): void {
        this.active = false;
        this.modal.hide();
    }
}
