import { Component, ViewChild, Injector, Output, EventEmitter } from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { GetClientPreferenceForViewDto, ClientPreferenceDto } from '@shared/service-proxies/service-proxies';
import { AppComponentBase } from '@shared/common/app-component-base';

@Component({
    selector: 'viewClientPreferenceModal',
    templateUrl: './view-clientPreference-modal.component.html'
})
export class ViewClientPreferenceModalComponent extends AppComponentBase {

    @ViewChild('createOrEditModal', { static: true }) modal: ModalDirective;
    @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();

    active = false;
    saving = false;

    item: GetClientPreferenceForViewDto;


    constructor(
        injector: Injector
    ) {
        super(injector);
        this.item = new GetClientPreferenceForViewDto();
        this.item.clientPreference = new ClientPreferenceDto();
    }

    show(item: GetClientPreferenceForViewDto): void {
        this.item = item;
        this.active = true;
        this.modal.show();
    }

    close(): void {
        this.active = false;
        this.modal.hide();
    }
}
