import { Component, ViewChild, Injector, Output, EventEmitter } from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { finalize } from 'rxjs/operators';
import {
    TimeZoneServiceProxy,
    OrderNotificationOrderStatusTypeLookupTableDto,
    UserListDto,
    OrganizationUnitDto,
    OrderNotificationSmsTemplateLookupTableDto,
    OrderNotificationOrderTypeLookupTableDto,
    OrderNotificationsServiceProxy, CreateOrEditOrderNotificationDto, OrderNotificationOrderNotificationTemplateLookupTableDto
    , OrganizationUnitServiceProxy, CreateOrEditOrganizationUnitOrderNotificationDto, OrganizationUnitOrderNotificationsServiceProxy, OrganizationUnitOrderNotificationDto, ReportScheduleServiceProxy, CreateOrEditReportScheduleDto, CreateOrEditReportRecipientDto, ReportSchedulerServiceProxy, LocationServiceProxy, LocationNameDto, ParameterValueNameDto, ReportScheduleParameterCheckerInput
} from '@shared/service-proxies/service-proxies';

import { AppComponentBase } from '@shared/common/app-component-base';
import * as moment from 'moment';
import { NUMBER_TYPE } from '@angular/compiler/src/output/output_ast';
import { ColorTransformCollection } from 'devexpress-richedit/lib/core/model/drawing/transform/color-transform-collection';
import { value } from 'devexpress-dashboard/model/index.metadata';
import { CommonLookupCheckboxModalComponent } from '@app/shared/common/lookup/common-lookup-checkbox-modal.component';
import { CommonLookupModalComponent } from '@app/shared/common/lookup/common-lookup-modal.component';
import { deepCloneObject } from 'devexpress-dashboard/viewer-parts/index.internal';
import * as _ from 'lodash';
declare var $: any;

@Component({
    selector: 'editReportScheduleModalComponent',
    templateUrl: './edit-report-schedule-modal.component.html',
    providers: [ReportScheduleServiceProxy, ReportSchedulerServiceProxy]
})
export class EditReportScheduleModalComponent extends AppComponentBase {

    @ViewChild('createOrEditModal', { static: true }) modal: ModalDirective;
    @ViewChild('parameterModal', {static: true}) parameterModal: CommonLookupModalComponent;
    @ViewChild('parameterMultiModal', {static: true}) parameterMultiModal: CommonLookupCheckboxModalComponent;

    @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();

    active = false;
    saving = false;
    delete: any;
    form: any;
    isEmail: boolean;
    isSMS: boolean;
    organizationUnitId: any;
    // allOrganizationUnits: any;
    orderNotification: CreateOrEditOrderNotificationDto = new CreateOrEditOrderNotificationDto();
    activeTabIndex: number = 0;
    orderNotificationTemplateDescription = '';
    orderStatusTypeDescription = '';
    smsTemplateDescription = '';
    orderTypeDescription = '';
    OrganizationalUnitNotification: any;
    organizationUnitOrderNotification: any;
    orgUnits: CreateOrEditOrganizationUnitOrderNotificationDto = new CreateOrEditOrganizationUnitOrderNotificationDto();
    allOrderNotificationTemplates: OrderNotificationOrderNotificationTemplateLookupTableDto[];
    allOrderStatusTypes: OrderNotificationOrderStatusTypeLookupTableDto[];
    allSmsTemplates: OrderNotificationSmsTemplateLookupTableDto[];
    allOrderTypes: OrderNotificationOrderTypeLookupTableDto[];
    allUsers: UserListDto[];
    allOrganizationUnits: OrganizationUnitDto[];
    addOrg: any;

    input: any;
    // input: CreateOrEditReportScheduleDto= new CreateOrEditReportScheduleDto();
    reportId: number;
    schedulerDescription: string;
    schedulerStartDate: Date;
    schedulerStartTime: any;
    repeat: number;
    startDay : number;
    exportType: any;
    schedulerIsActive: boolean;
    ftpIsActive : boolean;
    recipientInput: any
    reportScheduleRecipient: any;
    exists: boolean = false
    params: any
    reportScheduleId: number
    getLocationNames: LocationNameDto[];
    dropdownValidation : boolean = false
    repeatValidation : boolean = false
    startDayValidation : boolean = false
    exportTypeValidation : boolean = false
    parameterNameValue: ParameterValueNameDto = new ParameterValueNameDto();
    listParameterValueName : Array<{
        name: string,
        pname: string,
        pvalue: string,
        pMultiValue: boolean
    }> = new Array();
    timeZones: any;
    defaultTz: any;
    tz: any;
    ftpServerName: string;
    ftpUserName: string;
    ftpPassword: string;
    ftpFolderName: string;
    ftpIsSftp : boolean
    timeInterval: any;
    dynamicModel: Array<{}> = new Array
    constructor(
        injector: Injector,
        private _orderNotificationsServiceProxy: OrderNotificationsServiceProxy,
        private _reportScheduleServiceProxy : ReportScheduleServiceProxy,
        private _organizationUnitService: OrganizationUnitServiceProxy,
        private _organizationUnitOrderNotification: OrganizationUnitOrderNotificationsServiceProxy,
        private _scheduler: ReportSchedulerServiceProxy,
        private _locationServiceProxy: LocationServiceProxy,
        private _timeZoneServiceProxy: TimeZoneServiceProxy
    ) {
        super(injector);
    }

    ngOnInit(): void {
        $('.kt-select2').select2();
        $('.organization-unit').select2();
        $('.user').select2();
    }

    onShown(): void {
        let s = this;
        $('.kt-select2').select2();
        $('.organization-unit').select2();
        $('.user').select2();
        // if(this.listParameterValueName != null){
        //     setTimeout(() => {
        //         this.listParameterValueName.forEach(element => {
        //             $('#'+element.pname).val(element.pvalue)
        //             // console.log(element.pvalue+"onshown")
        //             $('.kt-select2').select2();
        //         });
        //     }, 2000);
        // }
        this.listParameterValueName = []
        
       
        $('#repeatInput').change(function() {
            s.repeatValidation=true
            s.repeat= $('#repeatInput').val();
            console.log(s.repeat)
            setTimeout(() => {
                $('#startDayInput').select2();
            }, 1000);
         });
         this.listParameterValueName=[]
    }

    show(reportScheduleId: number, reportId : number): void {

        let s = this;
        this.reportScheduleId = reportScheduleId
        this.reportId = reportId
        this.reportScheduleRecipient = []
        this.spinnerService.show();
        
        this.getEditReportSchedule(reportScheduleId);

        this._orderNotificationsServiceProxy.getAllUserForTableDropdown().subscribe(result => {
            this.allUsers = result;
        });

        this._orderNotificationsServiceProxy.getAllOrgUnitsForTableDropdown().subscribe(result => {
            this.allOrganizationUnits = result;
        });

        this._timeZoneServiceProxy.getTimeZoneForDropDown(
        ).subscribe(result => {
            this.timeZones = result.items;
        });

        this.getParamInit();
        this.getParamMultiInit();
        this.listParameterValueName=[]
        
    }

    getEditReportSchedule(reportScheduleId: number){
        this._reportScheduleServiceProxy.getReportScheduleForEdit(reportScheduleId)
        .subscribe(result=> {
            this.exportType=[]
            let startTime = result.startDate.toDate().toDateString() + ' ' + result.startTime;
            this.reportId = result.reportId
            this.schedulerDescription = result.description
            // this.schedulerStartDate = new Date(result.)
            this.schedulerStartDate = result.startDate.toDate()
            this.schedulerStartTime = moment(startTime).toDate();
            this.repeat = result.repeat;
            this.startDay = result.startDay
            this.exportType = result.exportType.split(",")
            this.schedulerIsActive = result.isActive
            this.ftpIsActive = result.ftpIsActive;
            this.ftpServerName= result.ftpServerName;
            this.ftpUserName= result.ftpUserName;
            this.ftpPassword= result.ftpPassword;
            this.ftpFolderName = result.ftpFolderName;
            this.ftpIsSftp = result.ftpIsSftp;
            this.defaultTz = result.timeZone; 
            this.timeInterval = result.timeInterval;
            // let _ = require("lodash");
            result.recipients.forEach(element => {
                this.reportScheduleRecipient.push(element)
            });
            this.listParameterValueName=[]
            this._reportScheduleServiceProxy.getReportParameters(this.reportId)
                                            .pipe()
                                            .subscribe(result2=>{
                                                this.params = result2
                                                this.listParameterValueName=[]
                                                let test = []
                                                for(let a = 0; a < this.params.length ; a++){
                                                    if(this.params[a].basicInput == false){
                                                                        this._reportScheduleServiceProxy
                                                                            .getReportDefaultParameterValues(this.reportId,this.params[a].name,undefined,true,undefined,0,1000)
                                                                            .pipe()
                                                                            .subscribe(parramResult => {
                                                                                let filteredValues = result.parameterNameValue.filter(o => o.parameterName === this.params[a].name)
                                                                                for(let b = 0 ; b < filteredValues.length ; b++){
                                                                                    var paramIndex = parramResult.items.map(function(e) { return e.value; }).indexOf(filteredValues[b].parameterValue)
                                                                                        if(paramIndex >-1){
                                                                                        this.listParameterValueName.push({
                                                                                                name: this.params[a].name,
                                                                                                pname:parramResult.items[paramIndex].name,
                                                                                                pvalue:filteredValues[b].parameterValue,
                                                                                                pMultiValue: this.params[a].multiValue})
                                                                                                test.push({
                                                                                                    name: this.params[a].name,
                                                                                                    pname:parramResult.items[paramIndex].name,
                                                                                                    pvalue:filteredValues[b].parameterValue,
                                                                                                    pMultiValue: this.params[a].multiValue})
                                                                                        }
                                                                                        
                                                                                        else{
                                                                                            this.listParameterValueName.push({
                                                                                                name: this.params[a].name,
                                                                                                pname:'',
                                                                                                pvalue:'',
                                                                                                pMultiValue: this.params[a].multiValue})
                                                                                                test.push({
                                                                                                    name: this.params[a].name,
                                                                                                    pname:'',
                                                                                                    pvalue:'',
                                                                                                    pMultiValue: this.params[a].multiValue})
                                                                                        }
                                                                                        
                                                                                }
                                                                            },
                                                                            error => {
                                                                                this.spinnerService.hide()
                                                                            }, 
                                                                            ()=> {
                                                                                this.spinnerService.hide()
                                                                                if(test.length == result.parameterNameValue.length){
                                                                                    let merged = _.uniqWith(test, (pre, cur) => {
                                                                                        if (pre.name === cur.name) {
                                                                                            cur.pname = cur.pname + ",  " + pre.pname;
                                                                                            cur.pvalue = cur.pvalue + ", " + pre.pvalue;
                                                                                            // this.params.forEach(element => {
                                                                                            //     console.log(this.params[a].name)
                                                                                                
                                                                                            // });
                                                                                            
                                                                                            
                                                                                            return true;
                                                                                        }
                                                                                        return false;
                                                                                    });
                                                                                    merged.forEach(element =>{
                                                                                        $('#'+element.name).val(element.pname)
                                                                                        this.dynamicModel[element.name] =element.pvalue
                                                                                    })
                                                                                    console.log(this.dynamicModel)
                                                                                }
                                                                            });  
                                                    }
                                                    else{
                                                        this.spinnerService.hide()
                                                        let that = this
                                                        var index = result.parameterNameValue.map(function(e) { return e.parameterName; }).indexOf(this.params[a].name)
                                                        setTimeout(() => {
                                                            $('#'+that.params[a].name).val(result.parameterNameValue[index].parameterValue)
                                                        }, 1000);
                                                    }
                                                }
                                            })   
            this.active = true;

            // this.spinnerService.hide()
            this.modal.show();
        })
    }

    updateUnits(id, data): void {
        this.reportScheduleRecipient[id].organizationUnitId = data;
        setTimeout(() => {
            $('.organization-unit').select2();
            $('.user').select2();
        }, 100);
    }

    updateUsers(id, data): void {
        this.reportScheduleRecipient[id].userId = data;

        setTimeout(() => {
            $('.organization-unit').select2();
            $('.user').select2();
        }, 100);

    }

    updateRecipientType(id, data): void {
        let s = this;
        // this.organizationUnitOrderNotification[id].code = data;
        this.reportScheduleRecipient[id].code = data;
        setTimeout(() => {
            $('.organization-unit').select2();
            $('.user').select2();

            $('.organization-unit').on('select2:select', function (e) {
                s.updateUnits($(e.currentTarget).attr('id'), $(e.currentTarget).val());
            });
            $('.user').on('select2:select', function (e) {
                s.updateUsers($(e.currentTarget).attr('id'), $(e.currentTarget).val());
            });
        }, 100);


    }

    updateIsActive(id, data): void {
        this.reportScheduleRecipient[id].isActive = data;
    }

    addRecipient(): void {
        let s = this;
        
        this.recipientInput = new CreateOrEditReportRecipientDto();
        this.recipientInput.emailAddress = ""
        this.recipientInput.isActive = false
        this.recipientInput.organizationUnitId = null
        this.recipientInput.userId = null
        this.recipientInput.code = null
        this.reportScheduleRecipient.push(this.recipientInput);
        setTimeout(() => {
            $('.organization-unit').select2();
            $('.user').select2();
        }, 10);
    }

    deleteRecipient(id: number): void {
        this.delete = this.reportScheduleRecipient[id];
        this._reportScheduleServiceProxy.deleteReportScheduleRecipient(this.delete.id)
                                        .subscribe(result => {
                                            this.notify.success(this.l('SuccessfullyDeleted'));
                                        });
        this.reportScheduleRecipient.splice(id, 1);
    }

    save(){
        this.saving = true;
        this.input = new CreateOrEditReportScheduleDto();
        this.input.reportId = this.reportId
        this.input.reportScheduleId = this.reportScheduleId
        this.input.description = this.schedulerDescription;
        this.input.startDate = this.schedulerStartDate;
        this.input.startDate = new Date(this.schedulerStartDate.setHours(this.schedulerStartDate.getHours() - this.schedulerStartDate.getTimezoneOffset() / 60));
        this.input.startTime = new Date(this.schedulerStartTime).toLocaleTimeString('en-US', { hour12: true, 
                                hour: "numeric", 
                                minute: "numeric",
                                second: "numeric"
                                }) as any;
        this.input.repeat = $('#repeatInput').val();
        this.input.startDay = $('#startDayInput').val();
        this.exportType = $('#exportTypeInput').val();
        this.input.exportType = this.exportType.join(",").replace(/[^a-zA-Z,]/g,"");

        this.input.isActive = this.schedulerIsActive;
        this.input.ftpIsActive = this.ftpIsActive;
        this.input.ftpServerName = this.ftpServerName
        this.input.ftpUserName = this.ftpUserName
        this.input.ftpPassword = this.ftpPassword
        this.input.ftpFolderName = this.ftpFolderName;
        this.input.ftpIsSftp = this.ftpIsSftp;

        // console.log(this.input)

        this.input.recipients = new CreateOrEditReportRecipientDto();
        this.input.recipients = this.reportScheduleRecipient;
        this.input.parameterNameValue = []
                                
        var tz = $('#timezone').val();
        this.input.timeZone = tz;

        this.input.timeInterval = this.timeInterval
        // this.params.forEach(element => {
            
        //     var parameterNameValue: ParameterValueNameDto = new ParameterValueNameDto();
        //     parameterNameValue.parameterName=element.toString();
        //     parameterNameValue.parameterValue=$('#'+element).val().toString();
            
        //     this.input.parameterNameValue.push(parameterNameValue)
        //     // console.log($('#'+element).val())
        // });
        if(this.params != undefined) {
            let that = this
            for(var a = 0 ; a < this.params.length ; a++){
                this.listParameterValueName.length
                var parameterNameValue: ParameterValueNameDto = new ParameterValueNameDto();
                parameterNameValue.parameterName=this.params[a].name.toString();
                parameterNameValue.parameterValue=this.dynamicModel[this.params[a].name] != undefined ? this.dynamicModel[this.params[a].name].toString() : this.params[a].basicInput == true ? $('#'+that.params[a].name).val() : '';
                parameterNameValue.multiValue = this.params[a].multiValue;

                this.input.parameterNameValue.push(parameterNameValue)
                console.log(this.input.parameterNameValue)
            }
        }
       
        var checkerInput : ReportScheduleParameterCheckerInput = new ReportScheduleParameterCheckerInput();
        checkerInput.reportId = this.reportId;
        checkerInput.parameterNameValue = this.input.parameterNameValue
        checkerInput.recipients = this.reportScheduleRecipient;
        checkerInput.reportScheduleId = this.reportScheduleId;
        checkerInput.repeat = $('#repeatInput').val();

        

        // this._reportScheduleServiceProxy.reportScheduleParameterChecker(checkerInput)
        //                                 .subscribe(result=>{
        //                                     if(result){
        //                                         this.message.warn(
        //                                             this.l('SchedulerParameterWarning')
        //                                         );
        //                                         this.saving= false
        //                                     }
        //                                     else{
        //                                         // this.message.warn(
        //                                         //     'false'
        //                                         // );
                                                this._reportScheduleServiceProxy.updateReportSchedule(this.input)
                                                    .subscribe(result=>{
                                                        this.notify.info(this.l('SavedSuccessfully'));
                                                        this.close();
                                                        this.modalSave.emit(null);
                                                    } ,
                                                    error =>{
                                                        this.saving= false
                                                    },
                                                    () =>{
                                                        this.saving=false
                                                    })
                                                
                                        //         // console.log("false")
                                        //     }
                                           
                                        // })
            
        
    }

    ngAfterViewInit(): void {
    }


    close(): void {
        // console.log("closed")
        this.active = false;
        this.modal.hide();
    }

    validateValue(event: number) {
        if(this.repeat == 6){
            if(event >=24){
                this.message.warn("Please enter value from 1 to 23")
                this.timeInterval = null
                
            }
        }
        if(this.repeat == 7){
            if(event >=60){
                this.message.warn("Please enter value from 1 to 59")
                this.timeInterval = null
            }
        }
      }

      getParamInit() {
        this.parameterModal.configure({
            title: this.l('Select Parameter Value' ),
            dataSource: (skipCount: number, maxResultCount: number, filter: string, tenantId?: number) => {
                return this._reportScheduleServiceProxy.getReportDefaultParameterValues(this.reportId,this.parameterModal.parameterName,filter,false,undefined,skipCount,maxResultCount);
            }
        });
    }

    getParamMultiInit() {
        this.parameterMultiModal.configure({
            title: this.l('Select Parameter Value' ),
            dataSource: (skipCount: number, maxResultCount: number, filter: string, tenantId?: number) => {
                return this._reportScheduleServiceProxy.getReportDefaultParameterValues(this.reportId,this.parameterMultiModal.parameterName,filter,false,undefined,skipCount,maxResultCount);
            }
        });
    }

    getParameterList(parameterName : string, reportId : number, multiValue : boolean){
        if(!multiValue){
            this.parameterModal.parameterName = parameterName
            this.parameterModal.show();
        }
        else{
            this.parameterMultiModal.parameterName = parameterName
            this.parameterMultiModal.selectedItems=[]
            this.parameterMultiModal.show();
        }
    }

      selectParameter(item){
        this.dynamicModel[item.paramName] = item.value.toString()
        $('#'+item.paramName).val(item.name)
        
    }

    selectMultiParameter(item){
        this.dynamicModel[item[0].paramName] = item.map(o=> o.value).toString()
        $('#'+item[0].paramName).val(item.map(o=> o.name).toString())
    }

    clearInput(paramName){
        this.dynamicModel[paramName] =undefined
        $('#'+paramName).val('')
    }
}
