﻿import { Component, ViewChild, Injector, Output, EventEmitter } from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { GetRoute4MeSettingForViewDto, Route4MeSettingDto } from '@shared/service-proxies/service-proxies';
import { AppComponentBase } from '@shared/common/app-component-base';

@Component({
    selector: 'viewRoute4MeSettingModal',
    templateUrl: './view-route4MeSetting-modal.component.html'
})
export class ViewRoute4MeSettingModalComponent extends AppComponentBase {

    @ViewChild('createOrEditModal', { static: true }) modal: ModalDirective;
    @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();

    active = false;
    saving = false;

    item: GetRoute4MeSettingForViewDto;


    constructor(
        injector: Injector
    ) {
        super(injector);
        this.item = new GetRoute4MeSettingForViewDto();
        this.item.route4MeSetting = new Route4MeSettingDto();
    }

    show(item: GetRoute4MeSettingForViewDto): void {
        this.item = item;
        this.active = true;
        this.modal.show();
    }

    close(): void {
        this.active = false;
        this.modal.hide();
    }
}
