﻿import { Component, ViewChild, Injector, Output, EventEmitter, OnInit, ElementRef} from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { finalize } from 'rxjs/operators';
import { RouteTemplateOrderExtrasServiceProxy, CreateOrEditRouteTemplateOrderExtrasDto } from '@shared/service-proxies/service-proxies';
import { AppComponentBase } from '@shared/common/app-component-base';
import * as moment from 'moment';




@Component({
    selector: 'createOrEditRouteTemplateOrderExtrasModal',
    templateUrl: './create-or-edit-routeTemplateOrderExtras-modal.component.html'
})
export class CreateOrEditRouteTemplateOrderExtrasModalComponent extends AppComponentBase implements OnInit{
   
    @ViewChild('createOrEditModal', { static: true }) modal: ModalDirective;

    @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();

    active = false;
    saving = false;

    routeTemplateOrderExtras: CreateOrEditRouteTemplateOrderExtrasDto = new CreateOrEditRouteTemplateOrderExtrasDto();




    constructor(
        injector: Injector,
        private _routeTemplateOrderExtrasServiceProxy: RouteTemplateOrderExtrasServiceProxy
    ) {
        super(injector);
    }
    
    show(routeTemplateOrderExtrasId?: number): void {
    

        if (!routeTemplateOrderExtrasId) {
            this.routeTemplateOrderExtras = new CreateOrEditRouteTemplateOrderExtrasDto();
            this.routeTemplateOrderExtras.id = routeTemplateOrderExtrasId;


            this.active = true;
            this.modal.show();
        } else {
            this._routeTemplateOrderExtrasServiceProxy.getRouteTemplateOrderExtrasForEdit(routeTemplateOrderExtrasId).subscribe(result => {
                this.routeTemplateOrderExtras = result.routeTemplateOrderExtras;



                this.active = true;
                this.modal.show();
            });
        }
        
        
    }

    save(): void {
            this.saving = true;
            
			
			
            this._routeTemplateOrderExtrasServiceProxy.createOrEdit(this.routeTemplateOrderExtras)
             .pipe(finalize(() => { this.saving = false;}))
             .subscribe(() => {
                this.notify.info(this.l('SavedSuccessfully'));
                this.close();
                this.modalSave.emit(null);
             });
    }













    close(): void {
        this.active = false;
        this.modal.hide();
    }
    
     ngOnInit(): void {
        
     }    
}
