import { Component, OnInit, Output, EventEmitter } from '@angular/core';
import { Injector } from '@angular/core';
import { AppComponentBase } from '@shared/common/app-component-base';

import {
    LocationServiceProxy,
    LocationListDto,
    LocationNameDto
} from '@shared/service-proxies/service-proxies';

import * as moment from 'moment';
declare var $: any;


@Component({
  selector: 'app-filter-location',
  templateUrl: './filter-location.component.html',
  styleUrls: ['./filter-location.component.css']
})
export class FilterLocationComponent extends AppComponentBase {
  locations: LocationNameDto[] = [];
  txtLocation: any;
  constructor(
     private _locationServiceProxy: LocationServiceProxy,
    injector: Injector) {
    super(injector)
    this.getLocations();
    
  }

  //ngOnInit() {
  //}

  publishName(name: string): void {
    abp.event.trigger('app.dashboardFilters.locationFilter.onNameChange', name);
  }


  getLocations() {

        let defaultLoc = localStorage.getItem('operatingLocationId');
        let that = this;
        this._locationServiceProxy.getLocationNames(undefined, undefined, undefined, undefined, undefined, undefined)
            .subscribe(result => {
                that.locations = result;

                if(this.txtLocation == undefined) {
                  this.txtLocation = defaultLoc;
                  
                }
            });
  }

  onChange($event) {
      //console.log(deviceValue);
      let text = $event.target.value;
      this.txtLocation = text;
      this.publishName(text);
  }
    
}
