import { Injectable } from '@angular/core';
import { BehaviorSubject } from 'rxjs';

@Injectable()
export class ProgressBarService {

    private toggle = new BehaviorSubject(false);
    currentToggle = this.toggle.asObservable();

    private message = new BehaviorSubject('');
    currentMessage = this.message.asObservable();

    constructor() {

    }

    toggleProgressBar(toggle: boolean) {
        this.toggle.next(toggle);
    }

    sendMessage(message: string) {
        this.message.next(message);
    }

}
