import { Component, ViewChild, Injector, Output, EventEmitter, OnInit } from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { finalize } from 'rxjs/operators';
import { OrderServiceProxy, EditOrdeContactDetail, AddressesServiceProxy, AddressInput, CreateOrEditAddressDto, UpdateOrderAddressInput, UpdateBatchDeliveryNotesInput } from '@shared/service-proxies/service-proxies';
import { AppComponentBase } from '@shared/common/app-component-base';
import * as moment from 'moment';
import { Address } from 'ngx-google-places-autocomplete/objects/address';
import { ILatLng } from '@app/sprintship/fleet-management/driver-proximities/driver-proximities.directive';
import { GooglePlaceDirective } from 'ngx-google-places-autocomplete';
declare var $: any;

@Component({
    selector: 'updateDeliveryNotesModal',
    templateUrl: './update-delivery-notes.component.html'
})
export class UpdateDeliveryNotesModalComponent extends AppComponentBase implements OnInit {

    @ViewChild('updateDeliveryNotesModal', { static: true }) modal: ModalDirective;
    @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();
    saving: any;
    active: any;
    notes: string ="";
    inputs = new UpdateBatchDeliveryNotesInput();
    orderId: any;
    orderIds: Array<any> = new Array<any>();
    constructor(
        injector: Injector,
        private _orderAppService: OrderServiceProxy,

    ) {
        super(injector);
    }

    ngOnInit() {
        this
    }

    show(orderId: any, note: string) {
        if(orderId != null){
            this.orderIds = [];
            this.orderIds.push(orderId);
        }
        if(this.orderIds.length == 0){
            this.message.error('No orders selected');
        }
        else{
            console.log('note'+orderId)
            this.notes = note;
            this.modal.show();
        }
        
    }

    onShown(): void {
        let that = this;
    }

    save(): void {
        this.saving = true;
        this.spinnerService.show();
        let orderNoteInput = new UpdateBatchDeliveryNotesInput();
        orderNoteInput.notes = this.notes;
        orderNoteInput.ids = this.orderIds;
        this._orderAppService.updateDeliveryNote(orderNoteInput).subscribe(res => {
            this.saving = false;
            this.notify.info(this.l('SavedSuccessfully'));
            this.modalSave.emit();
            this.close();
        });
    }

    close(): void {
        this.active = false;
        this.modal.hide();
    }
}
