import { Component, Injector, OnInit, ViewChild, ViewEncapsulation, Input, ViewChildren } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { AppConsts } from '@shared/AppConsts';
import { appModuleAnimation } from '@shared/animations/routerTransition';
import { AppComponentBase } from '@shared/common/app-component-base';
import { OrderServiceProxy, OrderListDto, ControllerOrderPackagesListServiceProxy, OrderStatusServiceProxy, OrderStatusListDto, OrderStatusTypeServiceProxy } from '@shared/service-proxies/service-proxies';
// ControllerOrderPackagesListDto, 
import * as moment from 'moment';
import { LazyLoadEvent } from 'primeng/components/common/lazyloadevent';
import { Paginator } from 'primeng/components/paginator/paginator';
import { Table } from 'primeng/components/table/table';
import { HttpClient } from '@angular/common/http';
import { finalize, count } from 'rxjs/operators';
import { formatDate } from "@angular/common";

@Component({
    selector: 'addOrderStatus',
    templateUrl: './add-order-status.component.html',
    encapsulation: ViewEncapsulation.None,
    animations: [appModuleAnimation()],
    providers: [ControllerOrderPackagesListServiceProxy]
})

export class AddOrderStatusComponent extends AppComponentBase  implements OnInit{
    @ViewChild('dataTable', {static: true}) dataTable: Table;
    @ViewChild('paginator', {static: true}) paginator: Paginator;
    @Input() filters: {
        locationFilter : number;
        startDate: Date;
        endDate: Date
    } = < any > {};
    filterText: string;

    orderPackageId : number;
    orderId:number
    orderPackageCustomer: string
    space=" ";
    latitude:number

    // orderPackage: ControllerOrderPackagesListDto = new ControllerOrderPackagesListDto();
    orderStatuses: Array<{}> = new Array();

    orderPackageDateAndTime: any
    orderStatusTypes: any
    formattedOrderPackageDateAndTime: any
    formattedOrderPackageStatusDateAndTime: any
    formattedOrderPackagePickupDetail: any
    formattedOrderPackageDeliveryDetail: any
    formattedOrderPackageStatusTime:any
    
  constructor(
        injector: Injector,
        private id:ActivatedRoute,
        private _controllerOrderPackageAppService: ControllerOrderPackagesListServiceProxy,
        private _orderStatusAppService: OrderStatusServiceProxy,
        private _orderStatusTypeAppService : OrderStatusTypeServiceProxy
        
    ) {
        super(injector);
    }

    ngOnInit(): void {
    this.id.paramMap.subscribe(params => {
            this.orderPackageId = Number(params.get('id'));
        });
        // this.getOrderPackageDetail();
        
    }

    // getOrderPackageDetail(): void{
    //     this._controllerOrderPackageAppService
    //         .getControllerOrderPackageDetails(
    //             this.orderPackageId
    //         ).pipe(finalize(() => this.spinnerService.hide())).subscribe(result => {
    //             this.orderId= result[0]['orderId'];
    //             this.orderPackage= result[0];
    //             console.log(this.orderPackage.order.pickupDetail)
    //             // this.orderPackageDateAndTime = result[0]['order']['orderStatus']['time']
    //             this.formattedOrderPackageDateAndTime=moment(this.orderPackageDateAndTime).utc().format('MM/DD/YYYY, h:mm a')
    //             this.formattedOrderPackagePickupDetail=moment(result[0]['order']['pickupDetail']['etaStart']).utc().format('MM/DD/YYYY, h:mm a')
    //             this.formattedOrderPackageDeliveryDetail=moment(result[0]['order']['deliveryDetail']['etaEnd']).utc().format('MM/DD/YYYY, h:mm a')
    //             this.getOrderStatus(this.orderId)
    //             // this.getOrderStatus(this.orderId);
    //         });
    //         // console.log(this.orderId)
    // }

    // getOrderStatus(orderId:number,event?: LazyLoadEvent): void{
    //     if (this.primengTableHelper.shouldResetPaging(event)) {
    //         this.paginator.changePage(0);
    //         return;
    //     }

    //     this.spinnerService.show();
    //     this._orderStatusAppService.getOrderStatus(
    //         undefined,
    //         undefined,
    //         orderId,
    //         undefined,
    //         undefined,
    //         undefined,
    //         this.primengTableHelper.getSorting(this.dataTable),
    //         this.primengTableHelper.getMaxResultCount(this.paginator, event),
    //         this.primengTableHelper.getSkipCount(this.paginator, event)
    //     ).pipe(finalize(() => this.spinnerService.hide())).subscribe(statusResult => {
    //         this.orderStatuses=statusResult.items;
    //         // this.formattedOrderPackageStatusTime=moment(statusResult.items['time']).utc().format('MM/DD/YYYY, h:mm a')
    //         console.log(moment(statusResult.items['time']).utc().format('MM/DD/YYYY, h:mm a'))
    //         console.log("break")
    //         console.log(moment(statusResult.items[0]['time']).utc().format('MM/DD/YYYY, h:mm a'))
    //         this.primengTableHelper.totalRecordsCount = statusResult.totalCount;
            
    //     });

    // }

    getOrderStatusType(): void{
        this._orderStatusTypeAppService.getOrderStatusType(
            undefined,
            undefined,
            undefined,
            undefined,
            undefined,
            undefined,
            undefined
        ).pipe(finalize(() => this.spinnerService.hide())).subscribe(result => {
            this.orderStatusTypes=result.items;   
        });
    }
    
}