import { Component, Injector, OnInit, ViewChild, ViewEncapsulation, Input,ViewContainerRef } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { AppConsts } from '@shared/AppConsts';
import { appModuleAnimation } from '@shared/animations/routerTransition';
import { AppComponentBase } from '@shared/common/app-component-base';

import * as moment from 'moment';
import { LazyLoadEvent } from 'primeng/components/common/lazyloadevent';
import { Paginator } from 'primeng/components/paginator/paginator';
import { Table } from 'primeng/components/table/table';
import { HttpClient } from '@angular/common/http';
import { finalize } from 'rxjs/operators';

@Component({
	selector: 'loading',
    templateUrl: './loading.component.html',
    encapsulation: ViewEncapsulation.None,
    styleUrls: ['./loading.component.less'],
    animations: [appModuleAnimation()]
})

export class LoadingComponent extends AppComponentBase implements OnInit {
    hide : boolean;

    @Input('with_button') with_button: boolean;

	constructor(
        injector: Injector,
        private viewContainerRef: ViewContainerRef
        
    ) {
        super(injector);
    }

    ngOnInit(): void {
       
    }
    getParentComponent() {
        return this.viewContainerRef['_data'].componentView.component.viewContainerRef['_view'].component
    }
    
}