import { Component, Injector, OnInit, ViewChild, ViewEncapsulation, Input } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { AppConsts } from '@shared/AppConsts';
import { appModuleAnimation } from '@shared/animations/routerTransition';
import { AppComponentBase } from '@shared/common/app-component-base';
import { AppAuthService } from '@app/shared/common/auth/app-auth.service';
import { RouteListDto, RouteServiceProxy } from '@shared/service-proxies/service-proxies';

import * as moment from 'moment';
import { LazyLoadEvent } from 'primeng/components/common/lazyloadevent';
import { Paginator } from 'primeng/components/paginator/paginator';
import { Table } from 'primeng/components/table/table';
import { HttpClient } from '@angular/common/http';
import { finalize } from 'rxjs/operators';

@Component({
	selector: 'notallowed',
    templateUrl: './notallowed.component.html',
    encapsulation: ViewEncapsulation.None,
    styleUrls: ['./croutes.component.less'],
    animations: [appModuleAnimation()]
})

export class NotAllowedComponent extends AppComponentBase implements OnInit {
    hide : boolean;


	constructor(
        injector: Injector,
        private _routeService: RouteServiceProxy,
        private _authService: AppAuthService
        
    ) {
        super(injector);
    }

    ngOnInit(): void {
       
    }
    myProfile() {
        abp.event.trigger('app.show.mySettingsModal');
    }
    logOut() {
        this._authService.logout();
    }
}

    