﻿import { Component, ViewChild, Injector, Output, EventEmitter } from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { GetDataRetentionForViewDto, DataRetentionDto , EntityEnum, Frequency} from '@shared/service-proxies/service-proxies';
import { AppComponentBase } from '@shared/common/app-component-base';

@Component({
    selector: 'viewDataRetentionModal',
    templateUrl: './view-dataRetention-modal.component.html'
})
export class ViewDataRetentionModalComponent extends AppComponentBase {

    @ViewChild('createOrEditModal', { static: true }) modal: ModalDirective;
    @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();

    active = false;
    saving = false;

    item: GetDataRetentionForViewDto;
    entityEnum = EntityEnum;
    frequency = Frequency;


    constructor(
        injector: Injector
    ) {
        super(injector);
        this.item = new GetDataRetentionForViewDto();
        this.item.dataRetention = new DataRetentionDto();
    }

    show(item: GetDataRetentionForViewDto): void {
        this.item = item;
        this.active = true;
        this.modal.show();
    }

    close(): void {
        this.active = false;
        this.modal.hide();
    }
}
