import { Component, ViewChild, Injector, ElementRef, Output, EventEmitter } from '@angular/core';
import { AppComponentBase } from '@shared/common/app-component-base';
import { IncidentListDto, IncidentServiceProxy, DriverIncidentsServiceProxy, GetAttachmentListDto } from '@shared/service-proxies/service-proxies';
import { IncidentImageListDto, IncidentImageServiceProxy } from '@shared/service-proxies/service-proxies';
import { ImageListDto, ImageServiceProxy } from '@shared/service-proxies/service-proxies';

import * as _ from 'lodash';
import { ModalDirective } from 'ngx-bootstrap';
import { finalize } from 'rxjs/operators';


@Component({
    selector: 'viewIncidentImagesModal',
    templateUrl: './view-incident-images.component.html'
})
export class ViewIncidentImagesModalComponent extends AppComponentBase {

  @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();

  @ViewChild(ModalDirective, {static: false}) public modal: ModalDirective;
  @ViewChild('nameInput', {static: false}) nameInput: ElementRef;

  //incident: UpdateIncidentInput = new UpdateIncidentInput();
  //geocode: UpdateGeocodeInput = new UpdateGeocodeInput();
  
  images: GetAttachmentListDto[] = [];
  
  
  imageId: any;
  incidentImageId: any;


  active: boolean = false;
  saving: boolean = false;

  constructor(
    injector: Injector,
    private _incidentService: IncidentServiceProxy,
    private _incidentImageService: IncidentImageServiceProxy,
    private _imageService: ImageServiceProxy,
    private _driverIncidentsService: DriverIncidentsServiceProxy

  ) {
    super(injector);
  }

  show(incidentId): void {
      this.active = true;
      this.spinnerService.show();
      this._driverIncidentsService.getAttachments(
      incidentId,
      ).subscribe(result => {
          this.spinnerService.hide();
          this.images = result;
          console.log(this.images);
          this.modal.show();
      });
      

  }

  onShown(): void {
   // this.nameInput.nativeElement.focus();
  }

  

  close(): void {
    this.modal.hide();
    this.active = false;
  }
}
