﻿import { Component, ViewChild, Injector, Output, EventEmitter } from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { GetDriverIncidentTypeForViewDto, DriverIncidentTypeDto } from '@shared/service-proxies/service-proxies';
import { AppComponentBase } from '@shared/common/app-component-base';

@Component({
    selector: 'viewDriverIncidentTypeModal',
    templateUrl: './view-driverIncidentType-modal.component.html'
})
export class ViewDriverIncidentTypeModalComponent extends AppComponentBase {

    @ViewChild('createOrEditModal', { static: true }) modal: ModalDirective;
    @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();

    active = false;
    saving = false;

    item: GetDriverIncidentTypeForViewDto;


    constructor(
        injector: Injector
    ) {
        super(injector);
        this.item = new GetDriverIncidentTypeForViewDto();
        this.item.driverIncidentType = new DriverIncidentTypeDto();
    }

    show(item: GetDriverIncidentTypeForViewDto): void {
        this.item = item;
        this.active = true;
        this.modal.show();
    }

    close(): void {
        this.active = false;
        this.modal.hide();
    }
}
