import { Component, Injector, ViewChild, OnInit } from '@angular/core';
import { appModuleAnimation } from '@shared/animations/routerTransition';
import { AppComponentBase } from '@shared/common/app-component-base';
import { OrganizationTreeComponent } from '@app/admin/organization-units/organization-tree.component';
import { FleetUsersComponent } from './fleet-users.component';
import { FleetVehiclesComponent } from './fleet-vehicles.component';
import { FleetRatesComponent } from './fleet-rates.component';
import { IFleetUnitInfo } from './fleets-unit-info';
import { FleetsTreeComponent } from './fleets-tree.component';
import { FeatureCheckerService } from '@abp/features/feature-checker.service';
@Component({
    templateUrl: './fleets-unit.component.html',
    animations: [appModuleAnimation()]
})
export class FleetsUnitComponent extends AppComponentBase {

    @ViewChild('fleetUsers', {static: true}) fleetUsers: FleetUsersComponent;
    @ViewChild('fleetVehicles', {static: true}) fleetVehicles: FleetVehiclesComponent;
    @ViewChild('fleetRates', {static: true}) fleetRates: FleetRatesComponent;
    @ViewChild('fleetsTree', {static: true}) fleetsTree: FleetsTreeComponent;
    organizationUnit: IFleetUnitInfo = null;
    showRates: boolean = true;

    constructor(
        injector: Injector,
        private _featureCheckerService: FeatureCheckerService
    ) {
        super(injector);
       
    }

    ngOnInit(): void {
      /*  if(this._featureCheckerService.isEnabled('App.RouteManagementFeauture.ClinicManagement')) 
        {
           $( document ).ready(function() {
               
               $("#rates-link" ).css("display", "none");
               
           });
           
           this.showRates = false;
        }*/
        
    }
    ouSelected(event: any): void {
        this.organizationUnit = event;
        this.fleetUsers.organizationUnit = event;
        this.fleetVehicles.organizationUnit = event;
        if(this.showRates) {
            this.fleetRates.organizationUnit = event;
        }
    }
}
