import { Component, ViewChild, Injector, ElementRef, Output, EventEmitter } from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import {
    VehicleServiceProxy, CreateVehicleInput, UserServiceProxy, RoleServiceProxy,
    DriversServiceProxy, UserListRoleDto, UserListDto, VehicleTypesServiceProxy, GetDriverListDto, GetUnassignedDrivers
} from '@shared/service-proxies/service-proxies';
import * as _ from 'lodash';
declare var $: any;
import { AppComponentBase } from '@shared/common/app-component-base';
import { finalize } from 'rxjs/operators';
import * as moment from 'moment';

@Component({
    selector: 'createVehicleModal',
    templateUrl: './create-vehicle-modal.component.html'
})

export class CreateVehicleModalComponent extends AppComponentBase {

    @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();

    @ViewChild('modal', { static: false }) public modal: ModalDirective;

    users: GetUnassignedDrivers[] = [];
    id: any;

    userInput: {
        id: number
    }
    active: boolean = false;
    saving: boolean = false;
    vehicle: CreateVehicleInput = new CreateVehicleInput();
    vehicleType: any;
    constructor(
        injector: Injector,
        private _vehicleService: VehicleServiceProxy,
        private _driverService: DriversServiceProxy,
        private _vehicleTypeService: VehicleTypesServiceProxy

    ) {
        super(injector);
    }

    show(): void {
        let maxcount = 1000;
        this.active = true;
        this.init();
        this.getVehicleType();
        this.modal.show();
    }

    onShown(): void {
        this.vehicle.acquisitionDate
        this.vehicle.name = null;
        this.vehicle.licenseNumber = null
        $('.kt-select2').select2();
    }

    init(): void {
        this.vehicle.color = "#000000";
        this._driverService.getUnassignedDrivers().subscribe((result) => {
            this.users = result;
        });
    }

    save(): void {
        let timeId = localStorage.getItem('timeZoneId');
        this.saving = true;
        this.vehicle.userId = Number((<HTMLInputElement>document.getElementById('driver')).value);
        this.vehicle.userId = this.vehicle.userId==0 ? null : this.vehicle.userId;
        this.vehicle.vehicleTypeId = Number((<HTMLInputElement>document.getElementById('vehicleType')).value);
        this.vehicle.vehicleTypeId = this.vehicle.vehicleTypeId==0 ? null : this.vehicle.vehicleTypeId;
        this.vehicle.acquisitionDate = moment.tz($("#acquisitionDate").val(), timeId);
        // console.log(this.vehicle);
        this._vehicleService.createVehicle(this.vehicle)
            .subscribe(() => {
                this.notify.info(this.l('SavedSuccessfully'));
                this.close();
                this.modalSave.emit(this.vehicle);
            });
        this.saving = false;
    }

    close(): void {
        this.modal.hide();
        this.active = false;
    }

    getVehicleType() {
        this._vehicleTypeService.getAll(undefined, undefined, undefined, undefined, undefined, undefined, undefined)
            .subscribe(result => {
                this.vehicleType = result.items;
            });
    }

}
