﻿import { Component, ViewChild, Injector, Output, EventEmitter } from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { GetVehicleChecklistForViewDto, VehicleChecklistDto } from '@shared/service-proxies/service-proxies';
import { AppComponentBase } from '@shared/common/app-component-base';

@Component({
    selector: 'viewVehicleChecklistModal',
    templateUrl: './view-vehicleChecklist-modal.component.html'
})
export class ViewVehicleChecklistModalComponent extends AppComponentBase {

    @ViewChild('createOrEditModal', { static: true }) modal: ModalDirective;
    @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();

    active = false;
    saving = false;

    item: GetVehicleChecklistForViewDto;


    constructor(
        injector: Injector
    ) {
        super(injector);
        this.item = new GetVehicleChecklistForViewDto();
        this.item.vehicleChecklist = new VehicleChecklistDto();
    }

    show(item: GetVehicleChecklistForViewDto): void {
        this.item = item;
        this.active = true;
        this.modal.show();
    }

    close(): void {
        this.active = false;
        this.modal.hide();
    }
}
