﻿import { Component, ViewChild, Injector, Output, EventEmitter } from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { GetVehicleTypeForViewDto, VehicleTypeDto } from '@shared/service-proxies/service-proxies';
import { AppComponentBase } from '@shared/common/app-component-base';

@Component({
    selector: 'viewVehicleTypeModal',
    templateUrl: './view-vehicleType-modal.component.html'
})
export class ViewVehicleTypeModalComponent extends AppComponentBase {

    @ViewChild('createOrEditModal', { static: true }) modal: ModalDirective;
    @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();

    active = false;
    saving = false;

    item: GetVehicleTypeForViewDto;


    constructor(
        injector: Injector
    ) {
        super(injector);
        this.item = new GetVehicleTypeForViewDto();
        this.item.vehicleType = new VehicleTypeDto();
    }

    show(item: GetVehicleTypeForViewDto): void {
        this.item = item;
        this.active = true;
        this.modal.show();
    }

    close(): void {
        this.active = false;
        this.modal.hide();
    }
}
