import { Component, ViewChild, Injector, ElementRef, Output, EventEmitter, OnInit } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { AppComponentBase } from '@shared/common/app-component-base';
import { IncidentListDto, IncidentServiceProxy } from '@shared/service-proxies/service-proxies';
import { IncidentImageListDto, IncidentImageServiceProxy } from '@shared/service-proxies/service-proxies';
import { ImageListDto, ImageServiceProxy } from '@shared/service-proxies/service-proxies';

import * as _ from 'lodash';
import { ModalDirective } from 'ngx-bootstrap';
import { finalize } from 'rxjs/operators';


@Component({
    selector: 'viewIncidentAttachment',
    templateUrl: './viewIncidentAttachment.component.html'
})
export class ViewIncidentAttachmentComponent extends AppComponentBase implements OnInit {

  @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();


  orderStatusPhotoId:number;
  active = false;
  saving= false;
  orderId:number;
  image:string;
  caption:string;
  @ViewChild('viewIncidentAttachment', {static: false}) modal: ModalDirective;

  constructor(
    injector: Injector,
    private id:ActivatedRoute,
    private _incidentAppService: IncidentServiceProxy,
    private _incidentImageService: IncidentImageServiceProxy,
    private _imageService: ImageServiceProxy

  ) {
    super(injector);
  }


  ngOnInit() {
    this.id.paramMap.subscribe(params => {
        this.orderId = Number(params.get('id'));
    });
    // this.timeId = localStorage.getItem('timeZoneId');
    // moment.tz.setDefault(this.timeId);
}

  show(image:string,caption:string,id:number):void {
      
      this.image = image;
      this.caption = caption;
      this.orderStatusPhotoId = id;
      this.active = true;
      this.modal.show();
    
  }

  onShown(): void {
   // this.nameInput.nativeElement.focus();
  }

  deletePhoto() : void {

    this.message.confirm(
        this.l("AreYouSure"),
        '',
        (isConfirmed) => {
            if (isConfirmed) {
                this.spinnerService.show();
                this.saving = true;
                
                if (isConfirmed) {
                  this._incidentAppService.deleteAttachment(this.orderStatusPhotoId)
                      .subscribe(() => {
                                document.getElementById("attachment-photo-id-" + this.orderStatusPhotoId).remove();
                                this.close();
                                this.spinnerService.hide();
                      });
                }

                // this._attachmentService.deleteOrderStatusPhoto(this.orderStatusPhotoId)
                //     .pipe(finalize(() => { this.saving = false; }))
                //     .subscribe(() => {
                //         document.getElementById("attachment-photo-id-" + this.orderStatusPhotoId).remove();
                //         this.close();
                //         this.spinnerService.hide();
                //     });
            }
        }
    );
}


  close(): void {
    this.modal.hide();
    this.active = false;
  }
}
