import { Component, ViewChild, Injector, Output, EventEmitter } from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { GetClientConnectionForViewDto, ClientConnectionDto } from '@shared/service-proxies/service-proxies';
import { AppComponentBase } from '@shared/common/app-component-base';

@Component({
    selector: 'viewClientConnectionModal',
    templateUrl: './view-clientConnection-modal.component.html'
})
export class ViewClientConnectionModalComponent extends AppComponentBase {

    @ViewChild('createOrEditModal' , { static: true }) modal: ModalDirective;
    @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();

    active = false;
    saving = false;

    item: GetClientConnectionForViewDto;


    constructor(
        injector: Injector
    ) {
        super(injector);
        this.item = new GetClientConnectionForViewDto();
        this.item.clientConnection = new ClientConnectionDto();
    }

    show(item: GetClientConnectionForViewDto): void {
        this.item = item;
        this.active = true;
        this.modal.show();
    }

    close(): void {
        this.active = false;
        this.modal.hide();
    }
}
