import { Component, ViewChild, Injector, Output, EventEmitter } from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { ClientOrderLogDto, GetOrderTypeForViewDto, OrderTypeDto } from '@shared/service-proxies/service-proxies';
import { AppComponentBase } from '@shared/common/app-component-base';

@Component({
    selector: 'ViewOrderLogModal',
    templateUrl: './view-order-logs.component.html'
})
export class ViewOrderLogsModalComponent extends AppComponentBase {

    @ViewChild('createOrEditModal', { static: true }) modal: ModalDirective;
    @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();
    active = false;
    saving = false;
    item: ClientOrderLogDto;
    constructor(
        injector: Injector
    ) {
        super(injector);
        this.item = new ClientOrderLogDto();
    }

    show(item: ClientOrderLogDto): void {
        this.item = item;
        this.active = true;
        this.modal.show();
    }

    close(): void {
        this.active = false;
        this.modal.hide();
    }
}
