import { NgModule } from '@angular/core';
import { RouterModule, Router, NavigationEnd } from '@angular/router';
import { LocatorComponent } from './locator.component';


@NgModule({
    imports: [
        RouterModule.forChild([
            {
                path: '',
                children: [

                    { path: '', component: LocatorComponent, data: {} },
                    { path: ':routeid/:oid', component: LocatorComponent, data: {} },
                    { path: ':id/:rid', component: LocatorComponent, data: {} },
                    ]
            }
        ])
    ],
    exports: [
        RouterModule
    ]
})
export class LocatorRoutingModule { 
    constructor(
        router: Router
    ) {
        router.events.subscribe((event) => {
            if (event instanceof NavigationEnd) {
                window.scroll(0, 0);
            }
      
        });
    }

}
