﻿import { Component, ViewChild, Injector, Output, EventEmitter } from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { GetOrderNotificationTemplateForViewDto, OrderNotificationTemplateDto } from '@shared/service-proxies/service-proxies';
import { AppComponentBase } from '@shared/common/app-component-base';

@Component({
    selector: 'viewOrderNotificationTemplateModal',
    templateUrl: './view-orderNotificationTemplate-modal.component.html'
})
export class ViewOrderNotificationTemplateModalComponent extends AppComponentBase {

    @ViewChild('createOrEditModal', { static: true }) modal: ModalDirective;
    @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();

    active = false;
    saving = false;

    item: GetOrderNotificationTemplateForViewDto;


    constructor(
        injector: Injector
    ) {
        super(injector);
        this.item = new GetOrderNotificationTemplateForViewDto();
        this.item.orderNotificationTemplate = new OrderNotificationTemplateDto();
    }

    show(item: GetOrderNotificationTemplateForViewDto): void {
        this.item = item;
        this.active = true;
        this.modal.show();
    }

    close(): void {
        this.active = false;
        this.modal.hide();
    }
}
