﻿import { Component, ViewChild, Injector, Output, EventEmitter } from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { GetOrderNotificationForViewDto, OrderNotificationDto } from '@shared/service-proxies/service-proxies';
import { AppComponentBase } from '@shared/common/app-component-base';

@Component({
    selector: 'viewOrderNotificationModal',
    templateUrl: './view-orderNotification-modal.component.html'
})
export class ViewOrderNotificationModalComponent extends AppComponentBase {

    @ViewChild('createOrEditModal', { static: true }) modal: ModalDirective;
    @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();

    active = false;
    saving = false;

    item: GetOrderNotificationForViewDto;


    constructor(
        injector: Injector
    ) {
        super(injector);
        this.item = new GetOrderNotificationForViewDto();
        this.item.orderNotification = new OrderNotificationDto();
    }

    show(item: GetOrderNotificationForViewDto): void {
        this.item = item;
        this.active = true;
        this.modal.show();
    }

    close(): void {
        this.active = false;
        this.modal.hide();
    }
}
