import { Component, ViewChild, Injector, Output, EventEmitter } from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { GetOrderStatusForViewDto, OrderStatusDto } from '@shared/service-proxies/service-proxies';
import { AppComponentBase } from '@shared/common/app-component-base';

@Component({
    selector: 'viewOrderStatusModal',
    templateUrl: './view-orderStatus-modal.component.html'
})
export class ViewOrderStatusModalComponent extends AppComponentBase {

    @ViewChild('createOrEditModal', { static: true }) modal: ModalDirective;
    @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();

    active = false;
    saving = false;

    item: GetOrderStatusForViewDto;


    constructor(
        injector: Injector
    ) {
        super(injector);
        this.item = new GetOrderStatusForViewDto();
        this.item.orderStatus = new OrderStatusDto();
    }

    show(item: GetOrderStatusForViewDto): void {
        this.item = item;
        this.active = true;
        this.modal.show();
    }

    close(): void {
        this.active = false;
        this.modal.hide();
    }
}
