import { AfterViewChecked, Component, ElementRef, EventEmitter, Injector, Output, ViewChild } from '@angular/core';
import { AppConsts } from '@shared/AppConsts';
import { AppComponentBase } from '@shared/common/app-component-base';
import { OrderStatusTypeServiceProxy, OrderStatusTypeListDto, CreateOrderStatusTypeInput, OrderStatusTypeDescriptionServiceProxy, CreateOrderStatusTypeDescriptionInput } from '@shared/service-proxies/service-proxies';
import { ModalDirective } from 'ngx-bootstrap';
import * as _ from 'lodash';
import { finalize } from 'rxjs/operators';
declare var $: any;


@Component({
    selector: 'createOrderStatuTypeModal',
    templateUrl: './create-order-status-types-modal.component.html'
})
export class CreateOrderStatuTypeModalComponent extends AppComponentBase {

    @ViewChild('createOrEditModal', {static: false}) modal: ModalDirective;

    @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();

    active = false;
    saving = false;
    inactiveStatus = false;
    visibleStatus = true;
    active_class: string;
    inactive_class: string;
    invisible_class: string;
    visible_class: string;
    icon_class: string;
    statusTypes: OrderStatusTypeListDto[] = []; 

    orderStatusTypeDescription: CreateOrderStatusTypeDescriptionInput = new CreateOrderStatusTypeDescriptionInput();

    constructor(
        injector: Injector,
        private _orderStatusTypeAppService: OrderStatusTypeServiceProxy,
        private _orderStatusTypeDescriptionService: OrderStatusTypeDescriptionServiceProxy
    ) {
        super(injector);
    }

    show(): void {
        this.getAllDropDown();
        this.active_class = "btn btn-primary";
        this.inactive_class = "btn btn-light";

        this.visible_class = "btn btn-primary";
        this.invisible_class = "btn btn-light";

        this.icon_class = "far fa-clock"

        this.orderStatusTypeDescription = new CreateOrderStatusTypeDescriptionInput();
        // console.log(this.orderStatusType);
        this.active = true;
        this.modal.show();
    }

    onShown(): void {
        // document.getElementById('Code').focus();
    }

    save(): void {
        let color = (<HTMLInputElement>document.getElementById('color')).value;
        let orderStatusTypeId =  (<HTMLInputElement>document.getElementById('statusType')).value;
        //console.log(color.value);
        this.orderStatusTypeDescription.orderStatusTypeId = Number(orderStatusTypeId);
        this.orderStatusTypeDescription.visible = this.visibleStatus;
        this.orderStatusTypeDescription.inactive = this.inactiveStatus;
        this.orderStatusTypeDescription.parentId = null;
        this.orderStatusTypeDescription.color = color;
        this.saving = true;
        this._orderStatusTypeDescriptionService.createOrderStatusTypeDescription(this.orderStatusTypeDescription)
            .pipe(finalize(() => { this.saving = false; }))
            .subscribe(() => {
                this.notify.info(this.l('SavedSuccessfully'));
                this.close();
                this.modalSave.emit(null);
        });

        
       
    }

    close(): void {
        this.active = false;
        this.modal.hide();
    }

    getactive($event): void {
            this.inactiveStatus = false;
            this.inactive_class = "btn btn-light";
            this.active_class = "btn btn-primary";
            
    }
    inactive($event): void {
            this.inactiveStatus = true;
            this.active_class = "btn btn-light";
            this.inactive_class = "btn btn-primary";
            
    }

    visible($event): void {
            this.visibleStatus = true;
            this.invisible_class = "btn btn-light";
            this.visible_class = "btn btn-primary";
            
    }
    invisible($event): void {
            this.visibleStatus = false;
            this.visible_class = "btn btn-light";
            this.invisible_class = "btn btn-primary";
            
    }

    iconChanged($event): void {
           let string = new String("fa fa-");
           let eventString = $event.srcElement.value
           let icon = string + eventString;
           //console.log(icon);
           this.icon_class = icon;
           this.orderStatusTypeDescription.icon = this.icon_class;
           //console.log($event.srcElement.value);
            
    }


    getAllDropDown() {
        jQuery(document).ready(function () { 
            $('.kt-select2').select2();
            $('.select2-container').css('width', '100%');

        });
        


        this._orderStatusTypeAppService.getOrderStatusTypeAll(
            
        ).pipe()
        .subscribe(result => {
            //this.parents = result.items;
            console.log(result);
            this.statusTypes = result.items;
        });

        
    }
}
