﻿import { Component, ViewChild, Injector, Output, EventEmitter } from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { GetOrderTypeForViewDto, OrderTypeDto } from '@shared/service-proxies/service-proxies';
import { AppComponentBase } from '@shared/common/app-component-base';

@Component({
    selector: 'viewOrderTypeModal',
    templateUrl: './view-orderType-modal.component.html'
})
export class ViewOrderTypeModalComponent extends AppComponentBase {

    @ViewChild('createOrEditModal', { static: true }) modal: ModalDirective;
    @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();

    active = false;
    saving = false;

    item: GetOrderTypeForViewDto;


    constructor(
        injector: Injector
    ) {
        super(injector);
        this.item = new GetOrderTypeForViewDto();
        this.item.orderType = new OrderTypeDto();
    }

    show(item: GetOrderTypeForViewDto): void {
        this.item = item;
        this.active = true;
        this.modal.show();
    }

    close(): void {
        this.active = false;
        this.modal.hide();
    }
}
