﻿import { Component, ViewChild, Injector, Output, EventEmitter, OnInit} from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { finalize } from 'rxjs/operators';
import { OrderStatusMappingsServiceProxy, CreateOrEditOrderStatusMappingDto ,OrderStatusMappingOrderStatusDescriptionLookupTableDto
					,OrderStatusMappingOrderSourceLookupTableDto
					} from '@shared/service-proxies/service-proxies';
import { AppComponentBase } from '@shared/common/app-component-base';
import * as moment from 'moment';

import { ActivatedRoute } from '@angular/router';

declare var $: any;
@Component({
    selector: 'createOrEditOrderStatusMappingModal',
    templateUrl: './create-or-edit-orderStatusMapping-modal.component.html'
})
export class CreateOrEditOrderStatusMappingModalComponent extends AppComponentBase implements OnInit{
   
    @ViewChild('createOrEditModal', { static: true }) modal: ModalDirective;

    @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();

    active = false;
    saving = false;
    id = null;
    orderStatusMapping: CreateOrEditOrderStatusMappingDto = new CreateOrEditOrderStatusMappingDto();

    orderStatusDescriptionName = '';
    orderSourceName = '';

	allOrderStatusDescriptions: OrderStatusMappingOrderStatusDescriptionLookupTableDto[];
						allOrderSources: OrderStatusMappingOrderSourceLookupTableDto[];
					

    constructor(
        injector: Injector,
        private _activatedRoute: ActivatedRoute,
        private _orderStatusMappingsServiceProxy: OrderStatusMappingsServiceProxy
    ) {
        super(injector);
    }
    
    ngOnInit(): void {
        this._activatedRoute.paramMap.subscribe(params => {
            this.id = params.get("id") ;    
        });
        jQuery(document).ready(function () { 
            $('.kt-select2').select2();
            $('.select2-container').css('width', '100%');

        });
    }

    show(orderStatusMappingId?: number): void {
    
       
        if (!orderStatusMappingId) {

            jQuery(document).ready(function () { 
                $('.kt-select2').select2();
                $('.select2-container').css('width', '100%');
    
            });

            this.orderStatusMapping = new CreateOrEditOrderStatusMappingDto();
            this.orderStatusMapping.id = orderStatusMappingId;
            this.orderStatusDescriptionName = '';
            this.orderSourceName = '';
            
            this.active = true;
            this.modal.show();
        } else {
          

            this._orderStatusMappingsServiceProxy.getOrderStatusMappingForEdit(orderStatusMappingId).subscribe(result => {

                jQuery(document).ready(function () { 
                    $('.kt-select2').select2();
                    $('.select2-container').css('width', '100%');
        
                });

                this.orderStatusMapping = result.orderStatusMapping;
                $('#statusType').val(result.orderStatusMapping.orderStatusDescriptionId);
                this.orderStatusDescriptionName = result.orderStatusDescriptionName;
                this.orderSourceName = result.orderSourceName;


                this.active = true;
                this.modal.show();
            });
        }
        this._orderStatusMappingsServiceProxy.getAllOrderStatusDescriptionForTableDropdown().subscribe(result => {		//this.id				
						this.allOrderStatusDescriptions = result;
					});
					// this._orderStatusMappingsServiceProxy.getAllOrderSourceForTableDropdown().subscribe(result => {						
					// 	this.allOrderSources = result;
					// });
					
        
    }

    save(): void {
            this.saving = true;
            
			this.orderStatusMapping.orderStatusDescriptionId = $('#statusType').val();
			this.orderStatusMapping.orderSourceId = this.id;
            this._orderStatusMappingsServiceProxy.createOrEdit(this.orderStatusMapping)
             .pipe(finalize(() => { this.saving = false;}))
             .subscribe(() => {
                this.notify.info(this.l('SavedSuccessfully'));
                this.close();
                this.modalSave.emit(null);
             });
    }













    close(): void {
        this.active = false;
        this.modal.hide();
    }
}
