﻿import {AppConsts} from "@shared/AppConsts";
import { Component, ViewChild, Injector, Output, EventEmitter } from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { GetOrderStatusMappingForViewDto, OrderStatusMappingDto } from '@shared/service-proxies/service-proxies';
import { AppComponentBase } from '@shared/common/app-component-base';

@Component({
    selector: 'viewOrderStatusMappingModal',
    templateUrl: './view-orderStatusMapping-modal.component.html'
})
export class ViewOrderStatusMappingModalComponent extends AppComponentBase {

    @ViewChild('createOrEditModal', { static: true }) modal: ModalDirective;
    @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();

    active = false;
    saving = false;

    item: GetOrderStatusMappingForViewDto;


    constructor(
        injector: Injector
    ) {
        super(injector);
        this.item = new GetOrderStatusMappingForViewDto();
        this.item.orderStatusMapping = new OrderStatusMappingDto();
    }

    show(item: GetOrderStatusMappingForViewDto): void {
        this.item = item;
        this.active = true;
        this.modal.show();
    }
    
    

    close(): void {
        this.active = false;
        this.modal.hide();
    }
}
