import {
    Component,
    Injector,
    ViewChild
 } from '@angular/core';
 import {
    AppComponentBase
 } from '@shared/common/app-component-base';
import { ModalDirective } from 'ngx-bootstrap';
 
 @Component({
    selector: 'importOrderTracking',
    templateUrl: './import-order-tracking.component.html'
 })
 export class ImportOrderTrackingComponent extends AppComponentBase {

   @ViewChild('trackingModal', {static: false}) modal: ModalDirective;

   importing = true;

   messages = [];
   
   constructor(
      injector: Injector
   ) {
      super(injector);
   }

   clearMessages() {
      this.messages = [];
   }

   logMessage(message: string, override = false) {

      if(override) {

         let lastIndex = this.messages.length - 1;

         this.messages[lastIndex] = message;
      }
      else {

         this.messages.push(message);
      }
   }

   complete () {
      
      this.importing = false;
   }
 }