﻿import { Component, ViewChild, Injector, Output, EventEmitter } from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { GetUserOrderTypeForViewDto, UserOrderTypeDto } from '@shared/service-proxies/service-proxies';
import { AppComponentBase } from '@shared/common/app-component-base';

@Component({
    selector: 'viewUserOrderTypeModal',
    templateUrl: './view-userOrderType-modal.component.html'
})
export class ViewUserOrderTypeModalComponent extends AppComponentBase {

    @ViewChild('createOrEditModal', { static: true }) modal: ModalDirective;
    @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();

    active = false;
    saving = false;

    item: GetUserOrderTypeForViewDto;


    constructor(
        injector: Injector
    ) {
        super(injector);
        this.item = new GetUserOrderTypeForViewDto();
        this.item.userOrderType = new UserOrderTypeDto();
    }

    show(item: GetUserOrderTypeForViewDto): void {
        this.item = item;
        this.active = true;
        this.modal.show();
    }

    close(): void {
        this.active = false;
        this.modal.hide();
    }
}
