import { Component, ViewChild, Injector, Output, EventEmitter } from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { GetTimeZoneForViewDto, TimeZoneDto, PackageOptionsServiceProxy } from '@shared/service-proxies/service-proxies';
import { AppComponentBase } from '@shared/common/app-component-base';

@Component({
    selector: 'viewPackageOptionModal',
    templateUrl: './view-package-option-modal.component.html'
})
export class ViewPackageOptionModalComponent extends AppComponentBase {

    @ViewChild('createOrEditModal', { static: true }) modal: ModalDirective;
    @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();

    active = false;
    saving = false;

    item: GetTimeZoneForViewDto;
    packageName: string
    code: string
    value: string
    key: string

    constructor(
        injector: Injector,
        private _packageOptionsServiceProxy: PackageOptionsServiceProxy
    ) {
        super(injector);
        // this.item = new GetTimeZoneForViewDto();
        // this.item.timeZone = new TimeZoneDto();
    }

    show(id: number): void {
        // this.item = item;
        this._packageOptionsServiceProxy.getAllPackageOptions(
            id,
            undefined,
            undefined,
            undefined,
            undefined,
            undefined,
            undefined,
            undefined,
            undefined
        ).subscribe(result => {
            this.code = result.items[0].code
            this.value = result.items[0].value
            this.key = result.items[0].key
            this.packageName = result.items[0].packageName
        });
        this.active = true;
        this.modal.show();
    }

    close(): void {
        this.active = false;
        this.modal.hide();
    }
}
