﻿import { Component, ViewChild, Injector, Output, EventEmitter } from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { GetRouteGeneratorLogForViewDto, RouteGeneratorLogDto } from '@shared/service-proxies/service-proxies';
import { AppComponentBase } from '@shared/common/app-component-base';
import * as moment from 'moment';

@Component({
    selector: 'viewRouteGeneratorLogModal',
    templateUrl: './view-routeGeneratorLog-modal.component.html'
})
export class ViewRouteGeneratorLogModalComponent extends AppComponentBase {

    @ViewChild('createOrEditModal', { static: true }) modal: ModalDirective;
    @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();

    active = false;
    saving = false;

    stats:any;
    item: GetRouteGeneratorLogForViewDto;


    constructor(
        injector: Injector
    ) {
        super(injector);
        this.item = new GetRouteGeneratorLogForViewDto();
        this.item.routeGeneratorLog = new RouteGeneratorLogDto();
    }

    show(item: GetRouteGeneratorLogForViewDto): void {
        this.item = item;
        this.active = true;
        let obj = JSON.parse(item.routeGeneratorLog.parameters);
        document.getElementById("parameters").textContent = JSON.stringify(obj, undefined, 2); 

        if(item.routeGeneratorLog.result.length > 0){
            var fresult = JSON.parse(item.routeGeneratorLog.result);
            this.stats = fresult;      
        }
        else{
            this.stats = null;   
        }
      
        this.modal.show();
    }

    close(): void {
        this.active = false;
        this.modal.hide();
    }
}
