import { Component, EventEmitter, Injector, ViewChild, Output, Input } from '@angular/core';
import { AppComponentBase } from '@shared/common/app-component-base';
import { RouteListDto, RouteServiceProxy } from '@shared/service-proxies/service-proxies';
import { ModalDirective } from 'ngx-bootstrap';
import { PrimengTableHelper } from 'shared/helpers/PrimengTableHelper';
import { finalize } from 'rxjs/operators';
import * as jquery from 'jquery';
import * as moment from 'moment';


@Component({
    templateUrl: './view-route-modal.component.html',
    selector: 'viewRouteModal',
 

})
export class ViewRouteModalComponent extends AppComponentBase {

   @ViewChild('viewRoute', {static: true }) modal: ModalDirective;

    active = false;
    hide: boolean = false;
    txtFilter: any;

    item: RouteListDto;

    loadDate : Date;
    routeName : string;
    vehicleName : string;
    driverName : string; 
    location: string;


    @Input('inputs') inputs: {
        locationId: number;
        loadDate: any;
    } = <any>{};

    constructor(
        injector: Injector,

    
    ) {
        super(injector);
   
    }

    ngOnInit(){


     
    }



    show(item: RouteListDto) {
        
        this.item = item;
        this.loadDate = moment.utc(this.item.loadDate).toDate();
        this.routeName = item.routeTemplateName;
        if(item.vehicleName != undefined) {
            this.vehicleName = item.vehicleName;
            this.driverName = item.driverName;
        }
        
        this.location = item.locationName;


        this.active = true;
        this.modal.show();

        
    }

 

    onShown(): void {
        $('.kt-select2').select2();
    }

   

    close(): void {
        this.active = false;
        this.modal.hide();
    }


    
}
