import { Component, ViewChild, Injector, Output, EventEmitter } from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { GetVersionForViewDto, VersionDto } from '@shared/service-proxies/service-proxies';
import { AppComponentBase } from '@shared/common/app-component-base';

@Component({
    selector: 'viewVersionModal',
    templateUrl: './view-version-modal.component.html'
})
export class ViewVersionModalComponent extends AppComponentBase {

    @ViewChild('createOrEditModal' , { static: false }) modal: ModalDirective;
    @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();

    active = false;
    saving = false;

    item: GetVersionForViewDto;


    constructor(
        injector: Injector
    ) {
        super(injector);
        this.item = new GetVersionForViewDto();
        this.item.version = new VersionDto();
    }

    show(item: GetVersionForViewDto): void {
        this.item = item;
        this.item.version.releasedDate
        this.active = true;
        this.modal.show();
    }

    close(): void {
        this.active = false;
        this.modal.hide();
    }
}
