﻿import { Component, ViewChild, Injector, Output, EventEmitter } from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { GetSmsAccountForViewDto, SmsAccountDto } from '@shared/service-proxies/service-proxies';
import { AppComponentBase } from '@shared/common/app-component-base';

@Component({
    selector: 'viewSmsAccountModal',
    templateUrl: './view-smsAccount-modal.component.html'
})
export class ViewSmsAccountModalComponent extends AppComponentBase {

    @ViewChild('createOrEditModal', { static: true }) modal: ModalDirective;
    @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();

    active = false;
    saving = false;

    item: GetSmsAccountForViewDto;


    constructor(
        injector: Injector
    ) {
        super(injector);
        this.item = new GetSmsAccountForViewDto();
        this.item.smsAccount = new SmsAccountDto();
    }

    show(item: GetSmsAccountForViewDto): void {
        this.item = item;
        this.active = true;
        this.modal.show();
    }

    close(): void {
        this.active = false;
        this.modal.hide();
    }
}
