import { NgModule } from '@angular/core';
import { RouterModule, Router, NavigationEnd } from '@angular/router';
import { RouteGenerationSettingsComponent } from './routeGenerationSettings/routeGenerationSettings.component';
import { OrderStatusTypeComponent } from './order-management/order-status-types/order-status-type.component';
import { TagTypeComponent } from './order-management/tag-types/tag-type.component';
import { OrderComponent } from './order-management/orders/order.component';
import { RoutesComponent } from './routes/routes.component';
import { RoutesTemplateComponent } from './routes-template/routestemplate.component';
import { RouteTemplateTypesComponent } from './route-template-types/route-template-types.component';
import { TimeZonesComponent } from './location-management/timezones/timezones.component';
import { ProximityComponent } from './location-management/proximity/proximity.component';
import { LocationsComponent } from './location-management/locations/location.component';
import { VehicleLocationComponent } from './location-management/vehicle-location/vehicle-location.component';
import { UserLocationComponent } from './location-management/user-location/user-location.component';
import { CreateUpdateLocationComponent } from './location-management/locations/create-update-location.component';
import { EditLocationComponent } from './location-management/locations/edit-location.component';
import { IncidentComponent } from './incident/incident.component';
// import { FleetsComponent } from './fleet-management/fleet/fleets.component';
import { FleetsComponent } from './fleet-management/fleets/fleets.component';
// import { AddressTypeComponent } from './contact-management/address-types/address-types.component';
import { ContactComponent } from './contact-management/contacts/contacts.component';
// import { PackageTypeComponent } from './package-management/package-types/package-type.component';
import { PackagesComponent } from './package-management/package-type/packages.component';
import { DriverIncidentsComponent } from './employees/driver-incident/driver-incidents.component';
import { EmployeeReviewComponent } from './employees/reviews/employee-review.component';
import { VehiclesComponent } from './fleet-management/vehicle/vehicles.component';
import { TimeSheetComponent } from './employees/timesheets/timesheet.component';
// import { AddressComponent } from './contact-management/addresses/address.component';
import { AddressesComponent } from './contact-management/addresses/addresses.component';
import { EmailComponent } from './contact-management/emails/email.component';
import { DriversComponent } from './fleet-management/drivers/drivers.component';
import { RatesComponent } from './fleet-management/drivers/rates/rates.component';
import { CreateOrEditRatesComponent } from './fleet-management/drivers/rates/create-or-edit-driver-rates.component';

import { BillingComponent } from './fleet-management/drivers/rates/billing.component';

import { VendorsComponent } from './vendor-management/vendors/vendors.component';
import { TagComponent } from './order-management/tags/tag.component';
import { OrderPackageComponent } from './order-management/order-package/order-package.component';
import { OrderStatusComponent } from './order-management/order-status/order-status.component';
import { CreateDriverComponent } from './fleet-management/drivers/create-driver.component';
import { EditDriverComponent } from './fleet-management/drivers/edit-driver.component';
import { UpdateOrderComponent } from './order-management/orders/update-order.component';
import { CreateOrderComponent } from './order-management/orders/create-order.component';
import { CreateVendorComponent } from './vendor-management/vendors/create-vendor.component';
import { EditVendorComponent } from './vendor-management/vendors/edit-vendor.component';
import { CreateContactComponent } from './contact-management/contacts/create-contact.component';
import { EditContactComponent } from './contact-management/contacts/edit-contact.component';
import { PostalCodesComponent } from './contact-management/postal-codes/postalCodes.component';
import { PostalCodeZonesComponent } from './location-management/locations/postal-code-zones.component';
import { CRoutesComponent } from './controller/routes/croutes.component';
import { NotAllowedComponent } from './controller/routes/notallowed.component';
import { RouteDetailComponent } from './controller/route-detail/route-detail.component';
import { CreateIncidentComponent } from './controller/create-incidents/create-incident.component';
import { LocatorComponent } from './locator/locator.component';
import { TagsComponent } from './order-management/tags-rad/tags.component';
import { OrderPackagesComponent } from './order-management/order-package-rad/orderPackages.component';
import { OrderStatusesComponent } from './order-management/order-status-rad/orderStatuses.component';
import { AddressTypesComponent } from './contact-management/address-types/addressTypes.component';

import { OrderStatusTypesComponent } from './order-management/order-status-types-rad/orderStatusTypes.component';
import { TagTypesComponent } from './order-management/tag-types-rad/tagTypes.component';
import { ViewOrderComponent } from './order-management/orders/view-order.component';
import { OrderDetailComponent } from './controller/order-detail/order-detail.component';
import { VehicleDetailComponent } from './controller/vehicles/vehicle-route-details.component';
import { ControllerOrderPackageDetailComponent } from './controller/order-packages/order-packages-detail.component';
import { DriverDetailComponent } from './controller/drivers/driver-details.component';
import { UnassignedPackagesComponent } from './controller/kpi-box/unassigned/unassigned.component';
import { DriverProximitiesComponent } from './fleet-management/driver-proximities/driver-proximities.component';
import { ViewDriverCompnent } from './fleet-management/drivers/view-driver.component';
import { ControllerOrderIncidentsComponent } from './controller/order-incident/order-incident-list.component';
import { RoutesListComponent } from './routes/route4me/route-list/route-list.component';
import { RoutesEditorComponent } from './routes/route4me/editor/editor.component';
import { RoutesMapComponent } from './routes/route4me/multiview/multiview.component';
import { RoutesOptimizationComponent } from './routes/route4me/optimization/optimization.component';
import { DriverEditComponent } from './fleet-management/drivers/driver-edit.component';
import { ViewVendorComponent } from './vendor-management/view-vendor.component';
import { OrderTypesComponent } from './order-management/order-types/orderTypes.component';
import { CreateOrEditOrderTypeModalComponent } from './order-management/order-types/create-or-edit-orderType-modal.component';
import { ViewUnassignedStopsComponent } from './controller/kpi-box/unassigned/view-unassigned-stops.component';
import { PrintRouteSheetLaboratoryComponent } from './controller/routes-laboratory/print-route-sheet-laboratory.component';
import { RouteSheetLaboratoryComponent } from './report/route-sheet-laboratory.component';
import { ReportPackagePerPostalCodeComponent } from './report/report-package-per-postal-code.component';
import { RouteReportComponent } from './report/route-report.component';
import { FleetsUnitComponent } from './fleet-management/fleets/fleets-unit.component';

import { SupportTicketsComponent } from './supportTicket/support-ticket.component';
import { CreateSupportTicketComponent } from './supportTicket/create-support-ticket.component';
import { EditSupportTicketComponent } from './supportTicket/edit-support-ticket.component';

import { TicketStatusComponent } from './supportTicket/support-ticket-status/support-ticket-status.component';

import { TicketTypeComponent } from './supportTicket/support-ticket-types/support-ticket-type.component';
import { TicketSettingComponent } from './supportTicket/support-ticket-settings/support-ticket-setting.component';


import { StatisticsComponent } from '@app/sprintship/statistics/statistics-component';
import { TrackingPageComponent } from './order-management/tracking-page/tracking-page-order.component';
import { VehicleTypesComponent } from './fleet-management/vehicleType/vehicleTypes.component';
// import { KpiLaboratoryComponent } from '@app/sprintship/dashboard/kpi-laboratory/kpi-laboratory.component.ts';
import { MileageReimbursementComponent } from './report/mileage-reimbursement/mileage-reimbursement.component';
import { RouteOptimizersComponent } from './optimizer/route-optimizer.component';
import { CreateUpdateRouteOptimizersComponent } from './optimizer/create-update-route-optimizer.component';
import { OrderNotificationTemplatesComponent } from './order-management/order-notification-template/orderNotificationTemplates.component';
import { OrderNotificationsComponent } from './order-management/order-notification/orderNotifications.component';
import { SmsAccountsComponent } from './smsAccounts/smsAccounts.component';
import { SmsTemplatesComponent } from './sms-templates/smsTemplates.component';
import { SupportTicketNotificationsComponent } from './supportTicket/support-ticket-notifications/supportTicketNotifications.component';
import { ContainerComponent } from './order-management/containers/container/container.component';

import { WillCallComponent } from './will-call/willcall.component';
import { CallInModalComponent } from '../sprintship/controller/modals/call_in_modal.component';
import { IncidentTypeComponent } from './incident/incident-type.component';
import { IncidentStatusComponent } from './incident/incident-status.component';
import { UpdateOrderIncidentComponent } from './incident/update-incident.component';
import { ViewIncidentComponent } from './incident/view-incident.component';
import { VehicleChecklistsComponent } from './fleet-management/vehicleChecklists/vehicleChecklists/vehicleChecklists.component';
import { EmployeesComponent } from './employees/employees/employees.component';
import { CreateEmployeeComponent } from './employees/employees/create-employee.component';
import { EditEmployeeComponent } from './employees/employees/edit-employee.component';
import { EmployeeIncidentTypesComponent } from './employees/employee-incident-types/employeeIncidentTypes.component';
import { EmployeeIncidentsComponent } from './employees/employee-incidents/employee-incidents.component';
import { DriverIncidentTypesComponent } from './fleet-management/drivers/driver-incident-types/driverIncidentTypes.component';
import { CreateOrEditDriverIncidentComponent } from './employees/driver-incident/create-driver-incident.component';
import { EditDriverIncidentComponent } from './employees/driver-incident/edit-driver-incident.component';
import { CreateEmployeeIncidentComponent } from './employees/employee-incidents/create-employee-incident.component';
import { EditEmployeeIncidentComponent } from './employees/employee-incidents/edit-employee-incident.component';
import { ViewDriverIncidentComponent } from './employees/driver-incident/view-driver-incident.component';
import { ViewEmployeeIncidentComponent } from './employees/employee-incidents/view-employee-incident.component';
import { PackageOptionsComponent } from './package-management/package-options/package-option.component';
import { ViewSupportTicketComponent } from './supportTicket/view-support-ticket.component';
import { SupportCategoryTypesComponent } from './supportTicket/supportCategoryTypes/supportCategoryTypes.component';
import { SupportDocumentationComponent } from './supportTicket/support-documentation/support-documentation.component';
import { SupportOnBoardingGuideComponent } from './supportTicket/support-documentation/support-OnBoardingGuide.component';
import { SupportTrainingVideoComponent } from './supportTicket/support-documentation/support-trainingVideo.component';
import { SupportFAQComponent } from './supportTicket/support-documentation/support-FAQUrl.component';

import { AppRouteGuard } from '@app/shared/common/auth/auth-route-guard';
import { RouteAnalyzerPickupComponent } from './routes/route-analyzer-pickup/route-analyzer.component';
import { RouteAnalyzerDeliveryComponent } from './routes/route-analyzer-delivery/route-analyzer.component';
import { RouteDefinitionsComponent } from '@app/main/laboratory/routeDefinitions/routeDefinitions.component';
import { RouteStopsComponent } from '@app/main/laboratory/routeStops/routeStops.component';
import { IncidentSourcesComponent } from './incident/incident-sources/incidentSources.component';
import { UserOrderTypesComponent } from './order-management/user-order-types/userOrderTypes.component';
import { VersionsComponent } from './settings/versions.component';
import { RouteGeneratorLogsComponent } from './routeGeneratorLogs/routeGeneratorLogs.component';
import { RouteGeneratorDashboardComponent } from './route-generator-dashboard/dashboard.component';
import { DataRetentionsComponent } from './data-retention/data-retention.component';
import { CustomerDashboardComponent } from './customer/customer-dashboard.component';
import { CustomerOrderComponent } from './customer/customer-order.component';
import { CustomerPortalComponent } from './customer/customer-portal.component';
import { CustomerTrackComponent } from './customer/customer-tracking.component';
import { ImageUrlComponent } from './image-url/image-url.component';
import { OrderStatusMappingsComponent } from './order-management/orderStatusMappings/orderStatusMappings.component';
import { PreferencesComponent } from '@app/main/preferences/preferences/preferences.component';
import { DispatchDetailsLineHaulComponents } from './controller/dispatch/dispatch-details-linehaul.component';
import { ClientConnectionsComponent } from './integration/client-connection/clientConnections.component';
import { ClientAccountsComponent } from './integration/client-account/client-account.component';
import { ClientOrdersComponent } from './integration/client-orders/client-orders.component';
import { OrderLogComponent } from './integration/client-order-logs/order-log.component';
import { RecurringOrderSchedulesComponent } from './order-management/recurring-order-schedules/recurringOrderSchedules.component';
import { ClientDriverComponent } from './integration/client-drivers/client-driver.component';

@NgModule({
    imports: [
        RouterModule.forChild([
            {
                path: '',
                children: [
                    { path: 'recurring-order-schedules', component: RecurringOrderSchedulesComponent, data: { permission: 'Pages.RecurringOrderSchedules' }  },
                    { path: 'preferences', component: PreferencesComponent, data: { permission: 'Pages.Preferences' }  },
                    { path: 'order-status-mappings/:id', component: OrderStatusMappingsComponent, data: { permission: 'Pages.Administration.OrderStatusMappings' }  },
                    { path: 'image/:id', component: ImageUrlComponent, data: {}  },
                    { path: 'route-generation-settings', component: RouteGenerationSettingsComponent, data: { permission: 'Pages.RouteGenerationSettings' }  },
                    { path: 'data-retention', component: DataRetentionsComponent, data: { permission: 'Pages.Administration.DataRetentions' }  },
                    { path: 'routeGeneratorLogs', component: RouteGeneratorLogsComponent, data: { permission: 'Pages.RouteGeneratorLogs' }  },
                    { path: 'versions', component: VersionsComponent, data: { permission: 'Pages.Versions' }  },
                    { path: 'user-order-types', component: UserOrderTypesComponent, data: { permission: 'Pages.Administration.UserOrderTypes' }  },
                     { path: 'status-workflow', component: OrderStatusTypeComponent, data: { permission: 'Pages.Orders.OrderStatusTypes' } },
                     { path: 'status-type', component: OrderStatusTypesComponent, data: { permission: 'Pages.Orders.OrderStatusTypes' } },
                     //{ path: 'tag-type', component: TagTypeComponent, data: { permission: 'Pages.Orders.TagTypes' } },
                     { path: 'tag-type', component: TagTypesComponent, data: { permission: 'Pages.Orders.TagTypes' } },
                     { path: 'order', component: OrderComponent, data: { permission: 'Pages.Orders' } },
                     { path: 'integration/orders', component: ClientOrdersComponent, data: { permission: 'Pages.Orders' } },
                     { path: 'order-create/:id', component: CreateOrderComponent, data: { permission: 'Pages.Orders' } },
                    //  { path: 'package-order', component: OrderPackageComponent, data: { permission: 'Pages.Orders.Package' } },
                    { path: 'package-order', component: OrderPackagesComponent, data: { permission: 'Pages.Orders.Package' } },
                    { path: 'status-order', component: OrderStatusesComponent, data: { permission: 'Pages.OrderStatuses' } },
                     { path: 'order-edit/:id', component: UpdateOrderComponent, data: { permission: 'Pages.Orders' } },
                     { path: 'order-create', component: CreateOrderComponent, data: { permission: 'Pages.Orders' } },
                     { path: 'type-order', component: OrderTypesComponent, data: { permission: 'Pages.OrderTypes' } },
                     { path: 'containers', component: ContainerComponent, data: {} },
                    //  { path: 'tags', component: TagComponent, data: { permission: 'Pages.Orders.Tags' } },
                     { path: 'tags', component: TagsComponent, data: { permission: 'Pages.Orders.Tags' } },
                     { path: 'routes', component: RoutesComponent, data: { permission: 'Pages.Shipping.PagesRoutes' } },
                     { path: 'route-definition', component: RouteDefinitionsComponent, data: { permission: 'Pages.RouteDefinitions' }  },
                    { path: 'routeStops', component: RouteStopsComponent, data: { permission: 'Pages.RouteStops' }  },
                    { path: 'routes-template', component: RoutesTemplateComponent, data: { permission: 'Pages.Shipping.RoutesTemplate' } },
                     { path: 'routes-template-types', component: RouteTemplateTypesComponent, data: { permission: 'Pages.Shipping.RouteTemplateTypes' } },
                     { path: 'route-analyzer-pickup', component: RouteAnalyzerPickupComponent, data: {  } },
                     { path: 'route-analyzer-delivery', component: RouteAnalyzerDeliveryComponent, data: {  } },
                     
                    //  { path: 'route4me/route-list', component: RoutesListComponent, data: {permission : 'Pages.Shipping.Routes.RouteForMe'} },
                    //  { path: 'route4me/editor', component: RoutesEditorComponent, data: {permission : 'Pages.Shipping.Routes.RouteForMe'} },
                    //  { path: 'route4me/multiview', component: RoutesMapComponent, data: {permission : 'Pages.Shipping.Routes.RouteForMe'} },
                    //  { path: 'route4me/optimization', component: RoutesOptimizationComponent, data: {permission : 'Pages.Shipping.Routes.RouteForMe'} },
                     
                     { path: 'will-call', component: WillCallComponent, data: { permission: 'Pages.Shipping.WillCall' } },
                   //{ path: 'will-call', component: CallInModalComponent, data: { permission: '' } },
                     
                     { path: 'fleets', component: FleetsUnitComponent, data: { permission: 'Pages.Shipping.Fleets' }  },
                     { path: 'drivers', component: DriversComponent, data: { permission: 'Pages.Administration.Drivers' } },
                     { path: 'vehicles', component: VehiclesComponent, data: { permission: 'Pages.Shipping.Vehicles' } },
                     { path: 'addresses', component: AddressesComponent, data: { permission: 'Pages.Shipping.Contacts.Address' }  },
                     { path: 'address-types', component: AddressTypesComponent, data: { permission: 'Pages.Shipping.Contacts.AddressTypes' }  },
                    //  { path: 'addresses', component: AddressComponent, data: { permission: 'Pages.Shipping.Contacts.Address' } },
                     { path: 'contacts', component: ContactComponent, data: { permission: 'Pages.Shipping.Contacts' } },
                     { path: 'timezones', component: TimeZonesComponent, data: { permission: 'Pages.Administration.TimeZones' } },
                    //  { path: 'timezones', component: TimeZonesComponent, data: { permission: 'Pages.TimeZones' }  },
                     { path: 'proximity', component: ProximityComponent, data: { permission: 'Pages.Administration.Proximities' } },
                     { path: 'locations-create/:id', component: CreateUpdateLocationComponent, data: { permission: 'Pages.Administration.Locations' } },
                     { path: 'locations-edit/:id', component: EditLocationComponent, data: { permission: 'Pages.Administration.Locations' } },
                     { path: 'locations', component: LocationsComponent, data: { permission: 'Pages.Administration.Locations' } },
                     { path: 'locationvehicle', component: VehicleLocationComponent, data: { permission: 'Pages.Administration.VehicleLocations' } },
                     { path: 'user-location', component: UserLocationComponent, data: { permission: 'Pages.Administration.UserLocations' } },
                     { path: 'package-types', component: PackagesComponent, data : { permission: 'Pages.Shipping.Package.PackageType'} },
                     { path: 'employees', component: EmployeesComponent, data: { permission: 'Pages.Administration.Employees' } },
                     { path: 'employee-incident-types', component: EmployeeIncidentTypesComponent, data: { permission: 'Pages.EmployeeIncidentTypes' } },
                     { path: 'employee-incidents', component: EmployeeIncidentsComponent, data: { permission: 'Pages.Administration.Employee.Incidents' } },
                     { path: 'employees-create', component: CreateEmployeeComponent, data: { permission: 'Pages.Administration.Employees.Create' } },
                     { path: 'employees-edit/:id', component: EditEmployeeComponent, data: { permission: 'Pages.Administration.Employees.Edit' } },
                     { path: 'employees/timesheets', component: TimeSheetComponent, data: { permission: 'Pages.Administration.Employees.TimeSheet' } },
                     { path: 'employees/reviews', component: EmployeeReviewComponent, data: { permission: 'Pages.Administration.Employees.EmployeeReview' } },
                     { path: 'driver-incidents', component: DriverIncidentsComponent, data: { permission: 'Pages.Administration.Employees.DriverIncidents' } },
                     { path: 'emails', component: EmailComponent, data: { permission: 'Pages.Shipping.Contacts.Emails' } },
                     { path: 'incidents', component: IncidentComponent, data: { permission: 'Pages.OrderIncidents' } },
                     { path: 'vendors', component: VendorsComponent, data: { permission: 'Pages.Administration.Users' } },
                     { path: 'drivers-create', component: CreateDriverComponent, data: { permission: 'Pages.Administration.Drivers' } },
                     { path: 'edit-driver/:id', component: EditDriverComponent, data: { permission: 'Pages.Administration.Drivers' } },
                     { path: 'drivers-edit/:id', component: DriverEditComponent, data: { permission: 'Pages.Administration.Drivers' } },
                     { path: 'drivers-view/:id', component: ViewDriverCompnent, data: { permission: 'Pages.Administration.Drivers' } },
                     { path: 'vendors-create', component: CreateVendorComponent, data: { permission: 'Pages.Administration.Users' } },
                     { path: 'vendors-view/:id', component: ViewVendorComponent, data: { permission: 'Pages.Administration.Users' } },

                     
                     { path: 'contacts-create', component: CreateContactComponent, data: { permission: 'Pages.Administration.Users' } },
                     { path: 'contacts-edit/:id', component: EditContactComponent, data: { permission: 'Pages.Administration.Users' } },
                     { path: 'vendors-edit/:id', component: EditVendorComponent, data: { permission: 'Pages.Administration.Users' } },
                     { path: 'postal-codes', component: PostalCodesComponent, data: { permission: 'Pages.Shipping.Contacts.PostalCodes' } },
                    //  { path: 'controller-routes', component: CRoutesComponent, data: {permission:'Pages.Shipping.Controller'} },
                     { path: 'dispatch', component: CRoutesComponent, data: {permission:'Pages.Shipping.Controller'} },
                     { path: 'dispatch-linehaul', component: DispatchDetailsLineHaulComponents, data: {permission:'Pages.Shipping.Controller'} },
                     { path: 'not-allowed', component: NotAllowedComponent, data: {} },

                     { path: 'controller-routes-details/:id', component: RouteDetailComponent, data: {} },
                     { path: 'controller-order-details/:id', component: OrderDetailComponent, data: {} },
                    //  { path: 'locator/:id/:rid', component: LocatorComponent, data: {} },
                    //  { path: 'locator/:routeid/:oid', component: LocatorComponent, data: {} },
                    //  { path: 'locator', component: LocatorComponent, data: {} },

                     { 
                        path: 'locator',
                        loadChildren: () => import( 'app/sprintship/locator/locator.module').then(m => m.LocatorModule), //Lazy load admin module
                        data: { preload: true },
                        canLoad: [AppRouteGuard]
                    },
                    {
                        path: 'route-builder',
                        loadChildren: () => import('app/sprintship/route-builder/route-builder.module').then(m => m.RouteBuilderModule), //Lazy load admin module
                        data: { preload: true },
                        canLoad: [AppRouteGuard]
                    },
                    //  { 
                    //     path: 'locator/:routeid/:oid',
                    //     loadChildren: () => import( 'app/sprintship/locator/locator.module').then(m => m.LocatorModule), //Lazy load admin module
                    //     data: { preload: true },
                    //     canLoad: [AppRouteGuard]},
                    //  { 
                    //     path: 'locator/:id/:rid',
                    //     loadChildren: () => import( 'app/sprintship/locator/locator.module').then(m => m.LocatorModule), //Lazy load admin module
                    //     data: { preload: true },
                    //     canLoad: [AppRouteGuard]},

                     { path: 'controller-vehicles/:vehicleid/:location', component: VehicleDetailComponent, data: {} },
                     { path: 'controller-order-package-detail/:id', component: ControllerOrderPackageDetailComponent, data: {} },
                     { path: 'controller-drivers/:userid/:location', component: DriverDetailComponent, data: {}},
                     { path: 'unassigned-packages', component: UnassignedPackagesComponent, data: {}},
                     { path: 'unassigned-packages', component: UnassignedPackagesComponent, data: {}},
                     { path: 'driver-proximity', component: DriverProximitiesComponent, data: {}},
                     { path: 'locations/postal-code-zones/:id', component: PostalCodeZonesComponent, data: {}},
                    //  { path: 'unassigned-packages/:location/:loadDate', component: UnassignedPackagesComponent, data: {}},
                     { path: 'view-unassigned-packages/:routeId', component: ViewUnassignedStopsComponent, data: {}},
                     { path: 'create-incidents/:id', component: CreateIncidentComponent, data: {}},
                     { path: 'create-incidents', component: CreateIncidentComponent, data: {}},
                     { path: 'print-route-sheet', component: RouteSheetLaboratoryComponent, data: {} },
                     { path: 'report-packages-per-postal-code', component: ReportPackagePerPostalCodeComponent, data: {} },
                     { path: 'route-print', component: RouteReportComponent, data: {} },
                     { path: 'statistics', component: StatisticsComponent, data: {} },
                     { path: 'tracking-page', component: TrackingPageComponent, data: {} },
                     { path: 'vehicle-types', component: VehicleTypesComponent, data: { permission: 'Pages.VehicleTypes' }  },
                     // { path: 'kpi-laboratory', component: KpiLaboratoryComponent, data: {permission:'Pages.Shipping.Controller'} },
                     { path: 'mileage-reimbursement', component: MileageReimbursementComponent, data: { permission: 'Pages.VehicleTypes' }  },
                     { path: 'order-notification-templates', component: OrderNotificationTemplatesComponent, data: { permission:'Pages.Orders.OrderNotificationTemplates'}  },
                     { path: 'order-notifications', component: OrderNotificationsComponent, data: { permission:'Pages.Orders.OrderNotifications'}},
                     { path: 'sms', component: SmsAccountsComponent, data: { permission: 'Pages.Administration.SmsAccounts' }  },
                     { path: 'sms-templates', component: SmsTemplatesComponent, data: { permission: 'Pages.Administration.SmsTemplates' }  },
                     { path: 'support-ticket', component: SupportTicketsComponent, data: { permission: '' }  },
                     { path: 'create-ticket', component: CreateSupportTicketComponent, data: { permission: '' } },
                     { path: 'incident-types', component: IncidentTypeComponent, data: {} },
                     { path: 'incident/incident-sources', component: IncidentSourcesComponent, data: { permission: 'Pages.Administration.IncidentSources' }  },
                     { path: 'incident-status', component: IncidentStatusComponent, data: {} },
                     { path: 'update-incidents/:id', component: UpdateOrderIncidentComponent, data: {}},
                     { path: 'view-incidents/:id', component: ViewIncidentComponent, data: {}},
                     
                     
                     { path: 'support-ticket', component: SupportTicketsComponent, data: { permission: 'Pages.SupportTicket' }  },
                     { path: 'create-ticket', component: CreateSupportTicketComponent, data: { permission: 'Pages.SupportTicket' } },
                     { path: 'open-ticket/:id/:open', component: EditSupportTicketComponent, data: { permission: 'Pages.SupportTicket' } },
                     { path: 'edit-ticket/:id', component: EditSupportTicketComponent, data: { permission: 'Pages.SupportTicket' } },
                     { path: 'view-ticket/:id', component: ViewSupportTicketComponent, data: { permission: 'Pages.SupportTicket' } },
                     { path: 'support-ticket-status', component: TicketStatusComponent, data: { permission: 'Pages.SupportTicket.Nav.Host' } },
                     { path: 'support-ticket-types', component: TicketTypeComponent, data: { permission: 'Pages.SupportTicket.Nav.Host' } },
                     { path: 'support-ticket-setting', component: TicketSettingComponent, data: { permission: 'Pages.SupportTicket.Nav.Host' } },

                     { 
                        path: 'route-optimizer',
                        loadChildren: () => import( 'app/sprintship/optimizer/optimizer.module').then(m => m.OptimizerModule), //Lazy load admin module
                        data: { preload: true },
                        canLoad: [AppRouteGuard]},

                     { path: 'support-ticket-notification', component: SupportTicketNotificationsComponent, data: { permission: 'Pages.SupportTicket.Nav.Host' }  },
                     { path: 'vehicleChecklists/vehicleChecklists', component: VehicleChecklistsComponent, data: { permission: 'Pages.VehicleChecklists' }  },

                     { path: 'drivers/driver-incident-types', component: DriverIncidentTypesComponent, data: { permission: 'Pages.DriverIncidentTypes' }  },
                     { path: 'driver-incident-create', component: CreateOrEditDriverIncidentComponent, data: { permission: 'Pages.Administration.Employees.DriverIncidents.Create' }  },
                     { path: 'driver-incident-create/:id', component: CreateOrEditDriverIncidentComponent, data: { permission: 'Pages.Administration.Employees.DriverIncidents.Create' }  },
                     { path: 'driver-incident-edit/:id', component: EditDriverIncidentComponent, data: {permission: 'Pages.Administration.Employees.DriverIncidents.Edit'}},
                     { path: 'driver-incident-view/:id', component: ViewDriverIncidentComponent, data: {permission: 'Pages.Administration.Employees.DriverIncidents'}},

                     { path: 'employee-incident-create', component: CreateEmployeeIncidentComponent, data: { permission: 'Pages.Administration.Employee.Create'}  },
                     { path: 'employee-incident-edit/:id', component: EditEmployeeIncidentComponent, data: {permission: 'Pages.Administration.Employee.Edit'}},
                     { path: 'employee-incident-view/:id', component: ViewEmployeeIncidentComponent, data: {permission: 'Pages.Administration.Employee.Edit'}},

                     { path: 'package-options', component: PackageOptionsComponent, data: {} },
                     { path: 'supportCategoryTypes', component: SupportCategoryTypesComponent, data: {}  },
                     { path: 'support-documentation', component: SupportDocumentationComponent, data: {}  },
                     { path: 'support-onBoardingGuide', component: SupportOnBoardingGuideComponent, data: {}  }, 
                     { path: 'support-trainingVideo', component: SupportTrainingVideoComponent, data: {}  } ,
                     { path: 'support-FAQUrl', component: SupportTrainingVideoComponent, data: {}  },
                     { path: 'customer-profile', component: CustomerPortalComponent, data: {permission: 'Pages.Customer.Profile'}},
                     { path: 'customer-track', component: CustomerTrackComponent, data: {permission: 'Pages.Customer.Track'}},
                     { path: 'customer-order', component: CustomerOrderComponent, data: {permission: 'Pages.Customer.Order'}},
                     { path: 'customer-dashboard', component: CustomerDashboardComponent, data: {permission: 'Pages.Customer.Dashboard'}},
                     { path: 'rates', component: RatesComponent, data: {permission: 'Pages.Administration.Rates'}},
                     { path: 'rates-edit/:id', component: CreateOrEditRatesComponent, data: {permission: 'Pages.Administration.Rates.Update'}},
                     { path: 'rates-create', component: CreateOrEditRatesComponent, data: {permission: 'Pages.Administration.Rates.Create'}},
                     { path: 'billing', component: BillingComponent, data: {permission: 'Pages.Administration.Rates'}},
                     { path: 'route-generator-dashboard', component: RouteGeneratorDashboardComponent, data: { permission: 'Pages.Administration.RouteGeneratorDashboard' } },
                     { path: 'integration/connections', component: ClientConnectionsComponent, data: { permission: 'Pages.ClientConnections' }  },
                     { path: 'integration/accounts', component: ClientAccountsComponent, data: { permission: 'Pages.ClientConnections' }  },
                     { path: 'integration/download-logs', component: OrderLogComponent, data: { permission: 'Pages.ClientConnections' }  },
                     { path: 'integration/drivers', component: ClientDriverComponent, data: { permission: 'Pages.ClientConnections' }  },
                    ]
            }
        ])
    ],
    exports: [
        RouterModule
    ]
})
export class SprintShipRoutingModule { 
    constructor(
        private router: Router
    ) {
        router.events.subscribe((event) => {
            if (event instanceof NavigationEnd) {
                window.scroll(0, 0);
            }
      
        });
    }

}
