import { CommonModule, DatePipe } from '@angular/common';
import { NgModule } from '@angular/core';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { AppCommonModule } from '@app/shared/common/app-common.module';
import { UtilsModule } from '@shared/utils/utils.module';
import { FileUploadModule } from 'ng2-file-upload';
import { ModalModule, PopoverModule, TabsModule, TooltipModule, BsDropdownModule, TimepickerModule } from 'ngx-bootstrap';
import { TimePickerModule } from '@progress/kendo-angular-dateinputs';
import { BsDatepickerModule, BsDatepickerConfig, BsDaterangepickerConfig, BsLocaleService } from 'ngx-bootstrap/datepicker';
import { AutoCompleteModule } from 'primeng/autocomplete';
import { EditorModule } from 'primeng/editor';
import { FileUploadModule as PrimeNgFileUploadModule } from 'primeng/fileupload';
import { InputMaskModule } from 'primeng/inputmask';
import { PaginatorModule } from 'primeng/paginator';
import { TableModule } from 'primeng/table';
import { TreeModule } from 'primeng/tree';
import { DragDropModule } from 'primeng/dragdrop';
import { TreeDragDropService } from 'primeng/api';
import { ContextMenuModule } from 'primeng/contextmenu';
import { NgxChartsModule } from '@swimlane/ngx-charts';
import { CountoModule } from 'angular2-counto';
import { TextMaskModule } from 'angular2-text-mask';
import { ImageCropperModule } from 'ngx-image-cropper';
import { AngularFontAwesomeModule } from 'angular-font-awesome';
import { NgxBootstrapDatePickerConfigService } from 'assets/ngx-bootstrap/ngx-bootstrap-datepicker-config.service';
import { SprintShipRoutingModule } from './sprintship-routing.module';
import { OrderStatusTypeComponent } from './order-management/order-status-types/order-status-type.component';
import { CreateOrderStatuTypeModalComponent } from './order-management/order-status-types/create-order-status-types-modal.component';
import { UpdateOrderStatuTypeModalComponent } from './order-management/order-status-types/update-order-status-types-modal.component';
import { TagTypeComponent } from './order-management/tag-types/tag-type.component';
import { CreateTagTypeModalComponent } from './order-management/tag-types/create-tag-types-modal.component';
import { UpdateTagTypeModalComponent } from './order-management/tag-types/update-tag-types-modal.component';
import { OrderComponent } from './order-management/orders/order.component';
// import { CreateFleetModalComponent } from './fleet-management/fleet/create-fleet-modal.component';
// import { EditFleetModalComponent } from './fleet-management/fleet/edit-fleet-modal.component';

import { VehiclesComponent } from './fleet-management/vehicle/vehicles.component';
import { CreateVehicleModalComponent } from './fleet-management/vehicle/create-vehicle-modal.component';
import { EditVehicleModalComponent } from './fleet-management/vehicle/edit-vehicle-modal.component';
import { ContactComponent } from './contact-management/contacts/contacts.component';
import { CreateContactModalComponent } from './contact-management/contacts/create-contact-modal.component';
import { EditContactModalComponent } from './contact-management/contacts/edit-contact-modal.component';
import { QRCodeModule } from 'angular2-qrcode';

// import { AddressTypeComponent } from './contact-management/address-types/address-types.component';
// import { CreateAddressTypeModalComponent } from './contact-management/address-types/create-address-type-modal.component';
// import { UpdateAddressTypeModalComponent } from './contact-management/address-types/edit-address-type-modal.component';

// import { TimeZonesComponent } from './location-management/timezones/timezones.component';
// import { CreateTimeZoneModalComponent } from './location-management/timezones/create-timezones-modal.component';
// import { EditTimeZoneModalComponent } from './location-management/timezones/edit-timezones-modal.component';
import { ProximityComponent } from './location-management/proximity/proximity.component';
import { CreateProximityModalComponent } from './location-management/proximity/create-proximity-modal.component';
import { EditProximityModalComponent } from './location-management/proximity/edit-proximity-modal.component';
import { LocationsComponent } from './location-management/locations/location.component';
import { CreateLocationModalComponent } from './location-management/locations/create-location-modal.component';
import { CreateUpdateLocationComponent } from './location-management/locations/create-update-location.component';
import { EditLocationComponent } from './location-management/locations/edit-location.component';
import { EditLocationModalComponent } from './location-management/locations/edit-location-modal.component';
import { VehicleLocationComponent } from './location-management/vehicle-location/vehicle-location.component';
import { CreateVehicleLocationModalComponent } from './location-management/vehicle-location/create-vehicle-location-modal.component';
import { EditVehicleLocationModalComponent } from './location-management/vehicle-location/edit-vehicle-location-modal.component';
import { UserLocationComponent } from './location-management/user-location/user-location.component';
import { CreateUserLocationModalComponent } from './location-management/user-location/create-user-location-modal.component';
import { EditUserLocationModalComponent } from './location-management/user-location/edit-user-location-modal.component';
import { IncidentComponent } from './incident/incident.component';
import { CreateIncidentModalComponent } from './incident/create-incident-modal.component';
import { EditIncidentModalComponent } from './incident/edit-incident-modal.component';
import { ViewIncidentImageModalComponent } from './incident/view-incident-image-modal.component';
import { CreateOrderModalComponent } from './order-management/orders/create-order-modal.component';
import { RoutesComponent } from './routes/routes.component';
import { CreateRouteModalComponent } from './routes/create-routes-modal.component';
import { EditRouteModalComponent } from './routes/edit-routes-modal.component';
import { RoutesTemplateComponent } from './routes-template/routestemplate.component';
import { RouteTemplateTypesComponent } from './route-template-types/route-template-types.component';
import { CreateRouteTemplateTypeModalComponent } from './route-template-types/create-route-template-types-modal.component';
import { EditRouteTemplateTypeModalComponent } from './route-template-types/edit-route-template-types-modal.component';
import { CreateOrEditRoutesTemplateModalComponent } from './routes-template/create-or-edit-routestemplate-modal.component';
import { PackageTypeComponent } from './package-management/package-types/package-type.component';
import { CreatePackageTypeModalComponent } from './package-management/package-types/create-packagetype-modal.component';
import { UpdatePackageTypeModalComponent } from './package-management/package-types/update-packagetype-modal.component';
import { TimeSheetComponent } from './employees/timesheets/timesheet.component';
import { CreateOrEditTimeSheetModalComponent } from './employees/timesheets/create-or-edit-timesheet.component';
import { EmployeeReviewComponent } from './employees/reviews/employee-review.component';
import { DriverIncidentsComponent } from './employees/driver-incident/driver-incidents.component';
import { CreateOrEditDriverIncidentComponent } from './employees/driver-incident/create-driver-incident.component';
import { CreateOrEditEmployeeReviewModalComponent } from './employees/reviews/create-or-edit-review.component';
import { AddressesComponent } from './contact-management/addresses/addresses.component';
import { SetOverridableAddressTypeModalComponent } from './contact-management/addresses/set-overridable-address-type-modal.component';
import { ViewAddressModalComponent } from './contact-management/addresses/view-address-modal.component';
import { CreateOrEditAddressModalComponent } from './contact-management/addresses/create-or-edit-address-modal.component';
import { EmailComponent } from './contact-management/emails/email.component';
import { CreateEmailModalComponent } from './contact-management/emails/create-email-modal.component';
import { DriversComponent } from './fleet-management/drivers/drivers.component';
import { RatesComponent } from './fleet-management/drivers/rates/rates.component';
import { BillingComponent } from './fleet-management/drivers/rates/billing.component';
import { RatesDescriptionModalComponent } from './fleet-management/drivers/rates/rates-description-modal.component';
import { CreateOrEditRatesComponent } from './fleet-management/drivers/rates/create-or-edit-driver-rates.component';
import { TagComponent } from './order-management/tags/tag.component';
import { CreateTagModalComponent } from './order-management/tags/create-tag-modal.component';
import { UpdateTagModalComponent } from './order-management/tags/update-tag-modal.component';
import { OrderPackageComponent } from './order-management/order-package/order-package.component';
import { CreateOrderPackageModalComponent } from './order-management/order-package/create-order-package-modal.component';
import { UpdateOrderPackageModalComponent } from './order-management/order-package/update-order-package-modal.component';
import { OrderStatusComponent } from './order-management/order-status/order-status.component';
import { CreateOrderStatusComponent } from './order-management/order-status/create-order-status.component';
import { VendorsComponent } from './vendor-management/vendors/vendors.component';
import { CreateDriverComponent } from './fleet-management/drivers/create-driver.component';
import { EditDriverComponent } from './fleet-management/drivers/edit-driver.component';
import { UpdateOrderComponent } from './order-management/orders/update-order.component';
import { CreateOrderComponent } from './order-management/orders/create-order.component';
import { CreateVendorComponent } from './vendor-management/vendors/create-vendor.component';
import { EditVendorComponent } from './vendor-management/vendors/edit-vendor.component';
import { AddressFormComponent } from '@app/shared/layout/form/address-form.component';
import { CreateContactComponent } from './contact-management/contacts/create-contact.component';
import { EditContactComponent } from './contact-management/contacts/edit-contact.component';
import { ContactFormComponent } from '@app/shared/layout/form/contact.form.component';
// import { PostalCodesComponent } from './contact-management/postal-codes/postal-codes.component';
// import { CreatePostalCodesModalComponent } from './contact-management/postal-codes/create-postal-codes-modal.component';
// import { EditPostalCodesModalComponent } from './contact-management/postal-codes/edit-postal-codes-modal.component';
import { CRoutesComponent } from './controller/routes/croutes.component';
import { NoDataComponent } from './controller/routes/nodata.component';
import { LoadingComponent } from './controller/routes/loading.component';
import { RouteDetailComponent } from './controller/route-detail/route-detail.component';
import { KPIBoxComponent } from './controller/kpi-box/kpi-box.component';
import { TableComponents } from './core-components/table-details.component';
import { AppConsts } from '@shared/AppConsts';
import { FlyOutComponent } from '@app/shared/layout/flyout/flyout.component';
import { MapFlyOutComponent } from '@app/shared/layout/flyout/map/map-flyout.component';

// import { TableRoutesComponents } from './controller/routes/table-routes-details.component';
import { AgmCoreModule, LAZY_MAPS_API_CONFIG } from '@agm/core';
import { DevicesComponent } from './controller/devices/devices.component';
import { StatusComponent } from './controller/status/status.component';
import { CheckBoxComponent } from './core-components/checkbox/checkbox.component';
import { LocatorComponent } from './locator/locator.component';
import { DriverListTabComponent } from './controller/drivers/driver-list.component';
import { NgSelectModule } from '@ng-select/ng-select';
// import { ColorPickerModule } from 'primeng/components/colorpicker/colorpicker';
import { ColorPickerModule } from 'ngx-color-picker';
import { ControllerShowHideComponent } from './controller/core-components/controller-show-hide-modal.component';
import { HFRouteDetailComponent } from './controller/route-detail/hf-route-detail.component';
import { LabRouteDetailComponent } from './controller/route-detail/lab-route-detail.component';
import { AgmOverlays } from "agm-overlays";
import { AgmJsMarkerClustererModule } from '@agm/js-marker-clusterer';
import { MoveOrderModalComponent } from './locator/move-order.component';
import { FleetsComponent } from './fleet-management/fleets/fleets.component';
import { ViewFleetModalComponent } from './fleet-management/fleets/view-fleet-modal.component';
import { CreateOrEditFleetModalComponent } from './fleet-management/fleets/create-or-edit-fleet-modal.component';
import { TimeZonesComponent } from './location-management/timezones/timezones.component';
import { ViewTimeZoneModalComponent } from './location-management/timezones/view-timeZone-modal.component';
import { CreateOrEditTimeZoneModalComponent } from './location-management/timezones/create-or-edit-timeZone-modal.component';
import { PackagesComponent } from './package-management/package-type/packages.component';
import { CreateOrEditPackageModalComponent } from './package-management/package-type/create-or-edit-package-modal.component';
import { ViewPackageModalComponent } from './package-management/package-type/view-package-modal.component';
import { TagsComponent } from './order-management/tags-rad/tags.component';
import { CreateOrEditTagModalComponent } from './order-management/tags-rad/create-or-edit-tag-modal.component';
import { ViewTagModalComponent } from './order-management/tags-rad/view-tag-modal.component';
import { OrderPackagesComponent } from './order-management/order-package-rad/orderPackages.component';
import { ViewOrderPackageModalComponent } from './order-management/order-package-rad/view-orderPackage-modal.component';
import { CreateOrEditOrderPackageModalComponent } from './order-management/order-package-rad/create-or-edit-orderPackage-modal.component';
import { CreateOrEditOrderStatusModalComponent } from './order-management/order-status-rad/create-or-edit-orderStatus-modal.component';
import { OrderStatusesComponent } from './order-management/order-status-rad/orderStatuses.component';
import { ViewOrderStatusModalComponent } from './order-management/order-status-rad/view-orderStatus-modal.component';
import { AddressTypesComponent } from './contact-management/address-types/addressTypes.component';
import { ViewAddressTypeModalComponent } from './contact-management/address-types/view-addressType-modal.component';
import { CreateOrEditAddressTypeModalComponent } from './contact-management/address-types/create-or-edit-addressType-modal.component';
import { ViewPostalCodeModalComponent } from './contact-management/postal-codes/view-postalCode-modal.component';
import { CreateOrEditPostalCodeModalComponent } from './contact-management/postal-codes/create-or-edit-postalCode-modal.component';
import { PostalCodesComponent } from './contact-management/postal-codes/postalCodes.component';
import { PostalCodeZonesComponent } from './location-management/locations/postal-code-zones.component';
import { VehicleListTabComponent } from './controller/vehicles/vehicle-list.component';
import { OrderListTabComponent } from './controller/orders/order-list.component';
import { GenerateRoutesTrackingComponent } from './controller/routes/generate-routes-tracking.component';
import { GenerateRoutesLaboratoryTrackingComponent } from './controller/routes-laboratory/generate-routes-laboratory-tracking.component';
import { OrderStatusTypesComponent } from './order-management/order-status-types-rad/orderStatusTypes.component';
import { ViewOrderStatusTypeModalComponent } from './order-management/order-status-types-rad/view-orderStatusType-modal.component';
import { CreateOrEditOrderStatusTypeModalComponent } from './order-management/order-status-types-rad/create-or-edit-orderStatusType-modal.component';
import { TagTypesComponent } from './order-management/tag-types-rad/tagTypes.component';
import { CreateOrEditTagTypeModalComponent } from './order-management/tag-types-rad/create-or-edit-tagType-modal.component';
import { ViewTagTypeModalComponent } from './order-management/tag-types-rad/view-tagType-modal.component';

import { RouteDetailModal } from './controller/route-detail/route-detail-modal.component';


import { UserPreferencesFlyoutComponent } from '@app/shared/layout/flyout/user-preferences/user-preferences-flyout.component';
import { LaboratoryMapFlyOutComponent } from '@app/shared/layout/flyout/map/laboratory/laboratory-map-flyout.component';
import { ViewOrderComponent } from './order-management/orders/view-order.component';
import { ControllerOrderPackagesComponent } from './controller/order-packages/order-packages-list.component';
import { OrderDetailComponent } from './controller/order-detail/order-detail.component';
import { EditOrderContactDetailModalComponent } from './controller/order-detail/edit-order-contact-detail-modal.component';
import { VehicleDetailComponent } from './controller/vehicles/vehicle-route-details.component';
import { ClinicNotes } from './controller/route-detail/clinic-notes.component';
import { EditCountNotes } from './controller/route-detail/edit-count-notes.component';
import { ControllerOrderPackageDetailComponent } from './controller/order-packages/order-packages-detail.component';
import { UpdateOrderAddressModalComponent } from './order-management/orders/update-address-modal.component';
import { DriverDetailComponent } from './controller/drivers/driver-details.component';
import { MovePendingOrder } from './controller/route-detail/move-order-modal.component';
import { ChangeEta } from './controller/route-detail/change-eta-modal.component';
import { CreateIncidentsModal } from './controller/route-detail/create-incidents-modal.component';

import { CreateRouteControllerModalComponent } from './controller/modals/create-routes-controller-modal.component';
import { UnassignedPackagesComponent } from './controller/kpi-box/unassigned/unassigned.component';
import { DriverProximitiesComponent } from './fleet-management/driver-proximities/driver-proximities.component';
import { AddOrderStatusComponent } from './controller/order-status/add-order-status.component';
import { ViewOrderStatusComponent } from './controller/order-status/view-order-status.component';
import { CalendarModule } from 'primeng/calendar';
import { AddOrderStatusModalComponent } from './controller/order-status/add-order-status-modal.component';
import { TimerComponent } from '@app/sprintship/core-components/timer/timer.component';
import { AccordionModule } from 'primeng/accordion';
import { OrderAttachment } from './controller/order-detail/order-attachments.component';
import { ImportOrderTrackingComponent } from './order-management/orders/import-order-tracking.component';
import { CallBackModalComponent } from './controller/modals/call_back_modal.component';
import { CallInModalComponent } from './controller/modals/call_in_modal.component';
import { ViewDriverCompnent } from './fleet-management/drivers/view-driver.component';
import { DriversPermissionsComponent } from './fleet-management/drivers/drivers-permissions.component';
import { AddBatchOrderStatusModalComponent } from './controller/order-status/add-batch-order-status-modal.component';
import { ToastModule } from 'primeng/toast';
import { ControllerOrderIncidentsComponent } from './controller/order-incident/order-incident-list.component';
import { ViewOrderIncidentComponent } from './controller/order-incident/view-order-incident-list.component';
import { CreateIncidentComponent } from './controller/create-incidents/create-incident.component';
import { IncidentNotesModalComponent } from './controller/create-incidents/incident-notes-modal.component';
import { ContainerComponent } from './order-management/containers/container/container.component';
import { CreateOrEditContainerModalComponent } from './order-management/containers/container/create-or-edit-container-modal.component';

import { RoutesListComponent } from './routes/route4me/route-list/route-list.component';
import { RoutesEditorComponent } from './routes/route4me/editor/editor.component';
import { RoutesMapComponent } from './routes/route4me/multiview/multiview.component';
import { RoutesOptimizationComponent } from './routes/route4me/optimization/optimization.component';
import { ControllerHeaderFlyoutComponent } from '@app/shared/layout/flyout/controller-header/controller-header-flyout.component';
import { DriverEditComponent } from './fleet-management/drivers/driver-edit.component';
import { RouteDetailAttachment } from './controller/route-detail/route-detail-attachment.component';
import { ViewVendorComponent } from './vendor-management/view-vendor.component';
import { ViewTimeSheetModalComponent } from './employees/timesheets/view-timesheet.component';
import { DriverProximityFlyOutComponent } from '@app/shared/layout/flyout/driver-proximity/driver-proximity-filter.component';
import { MarkAsCompleteModalComponent } from './controller/routes/mark-as-complete-modal.component';
import { ViewRouteModalComponent } from '@app/sprintship/routes/view-route-modal.component';
import { OrderTypesComponent } from './order-management/order-types/orderTypes.component';
import { CreateOrEditOrderTypeModalComponent } from './order-management/order-types/create-or-edit-orderType-modal.component';
import { ViewOrderTypeModalComponent } from './order-management/order-types/view-orderType-modal.component';
import { ViewContactModalComponent } from '@app/sprintship/contact-management/contacts/view-contact-modal.component';
import { CarouselModule } from 'primeng/carousel';
import { ViewVehicleModalComponent } from '@app/sprintship/fleet-management/vehicle/view-vehicle-modal.component';
import { AssignedToDriverModalComponent } from './controller/kpi-box/assigned-to-driver/assigned-to-driver-modal.component';
import { ViewUnassignedStopsComponent } from './controller/kpi-box/unassigned/view-unassigned-stops.component';
import { PrintRouteSheetLaboratoryComponent } from './controller/routes-laboratory/print-route-sheet-laboratory.component';
import { RouteSheetLaboratoryComponent } from './report/route-sheet-laboratory.component';
import { ReportPackagePerPostalCodeComponent } from './report/report-package-per-postal-code.component';
import { NotAllowedComponent } from './controller/routes/notallowed.component';
import { FBXRouteDetailComponent } from './controller/route-detail/fbx-route-detail.component';
import { CreateZoneModalComponent } from './location-management/locations/create-zone-modal.component';
import { RouteReportComponent } from './report/route-report.component';
import { TrackingPageComponent } from './order-management/tracking-page/tracking-page-order.component';
import { ChipsModule } from 'primeng/chips';
import { DispatchDetailsComponents } from './controller/dispatch/dispatch-details.component';
import { DispatchDetailsGroupComponents } from './controller/dispatch/dispatch-details.group.component';
import { DispatchProximityComponent } from './controller/dispatch/dispatch-proximity.component';
import { DeleteRoutesModalComponent } from './controller/dispatch/delete-routes.modal.component';
import { DeleteRoutesComponent } from './controller/dispatch/delete-routes.component';
import { DriverDevicesComponent } from './controller/devices/driver-devices.component';
import { FleetsUnitComponent } from './fleet-management/fleets/fleets-unit.component';
import { FleetUsersComponent } from './fleet-management/fleets/fleet-users.component';
import { FleetVehiclesComponent } from './fleet-management/fleets/fleet-vehicles.component';
import { FleetRatesComponent } from './fleet-management/fleets/fleet-rates.component';
import { FleetsTreeComponent } from './fleet-management/fleets/fleets-tree.component';
import { FleetAddRateComponent } from './fleet-management/fleets/fleet-add-rate.component';
import { FleetAddDriverComponent } from './fleet-management/fleets/fleet-add-driver.component';
import { FleetAddVehicleComponent } from './fleet-management/fleets/fleet-add-vehicle.component';
import { StatisticsComponent } from './statistics/statistics-component';
import { VehicleTypesComponent } from './fleet-management/vehicleType/vehicleTypes.component';
import { CreateOrEditVehicleTypeModalComponent } from './fleet-management/vehicleType/create-or-edit-vehicleType-modal.component';
import { ViewVehicleTypeModalComponent } from './fleet-management/vehicleType/view-vehicleType-modal.component';
import { ViewZoneModalComponent } from './location-management/locations/view-zone-modal.component';
import { EditZoneModalComponent } from './location-management/locations/edit-postal-code-zones-modal.component';
import { WillCallComponent } from './will-call/willcall.component';
import { MainModule } from '@app/main/main.module';
import { IncidentTypeComponent } from './incident/incident-type.component';
import { CreateUpdateIncidentTypeComponent } from './incident/create-update-incident-type.component';
import { SupportTicketsComponent } from './supportTicket/support-ticket.component';
import { CreateSupportTicketComponent } from './supportTicket/create-support-ticket.component';
import { EditSupportTicketComponent } from './supportTicket/edit-support-ticket.component';
import { SupportKPIBoxComponent } from '@app/sprintship/supportTicket/support-kpi-box/support-kpi-box.component';
import { TicketNotesModalComponent } from './supportTicket/ticket-notes-modal.component';
import { AssignModalComponent } from './supportTicket/assign-modal.component';
import { AssignTenantComponent } from './supportTicket/assign-tenant.component';
import { TicketStatusComponent } from './supportTicket/support-ticket-status/support-ticket-status.component';
import { TicketTypeComponent } from './supportTicket/support-ticket-types/support-ticket-type.component';
import { CreateOrEditTicketTypeModalComponent } from './supportTicket/support-ticket-types/create-or-edit-ticket-type.component';
import { CreateOrEditTicketStatusModalComponent } from './supportTicket/support-ticket-status/create-or-edit-status.component';
import { TicketSettingComponent } from './supportTicket/support-ticket-settings/support-ticket-setting.component';
import { CreateOrEditTicketSettingModalComponent } from './supportTicket/support-ticket-settings/create-or-edit-support-ticket-setting.component';
import { OrderNotificationTemplatesComponent } from './order-management/order-notification-template/orderNotificationTemplates.component';
import { ViewOrderNotificationTemplateModalComponent } from './order-management/order-notification-template/view-orderNotificationTemplate-modal.component';
import { CreateOrEditOrderNotificationTemplateModalComponent } from './order-management/order-notification-template/create-or-edit-orderNotificationTemplate-modal.component';

import { OrderNotificationsComponent } from './order-management/order-notification/orderNotifications.component';
import { ViewOrderNotificationModalComponent } from './order-management/order-notification/view-orderNotification-modal.component';
import { CreateOrEditOrderNotificationModalComponent } from './order-management/order-notification/create-or-edit-orderNotification-modal.component';
import { QuillModule } from 'ngx-quill';

import { SmsAccountsComponent } from './smsAccounts/smsAccounts.component';
import { ViewSmsAccountModalComponent } from './smsAccounts/view-smsAccount-modal.component';
import { CreateOrEditSmsAccountModalComponent } from './smsAccounts/create-or-edit-smsAccount-modal.component';

import { SmsTemplatesComponent } from './sms-templates/smsTemplates.component';
import { ViewSmsTemplateModalComponent } from './sms-templates/view-smsTemplate-modal.component';
import { CreateOrEditSmsTemplateModalComponent } from './sms-templates/create-or-edit-smsTemplate-modal.component';
import { TestNotificationComponent } from './order-management/order-notification/test-notification.component';

import { SupportTicketNotificationsComponent } from './supportTicket/support-ticket-notifications/supportTicketNotifications.component';
import { ViewSupportTicketNotificationModalComponent } from './supportTicket/support-ticket-notifications/view-supportTicketNotification-modal.component';
import { CreateOrEditSupportTicketNotificationModalComponent } from './supportTicket/support-ticket-notifications/create-or-edit-supportTicketNotification-modal.component';
import { KpiLaboratoryComponent } from '@app/sprintship/controller/kpi-box/kpi-laboratory/kpi-laboratory.component';
import { MileageReimbursementComponent } from './report/mileage-reimbursement/mileage-reimbursement.component';
import { NgxDropzoneModule } from 'ngx-dropzone';


import { IncidentStatusComponent } from './incident/incident-status.component';
import { CreateUpdateIncidentStatusComponent } from './incident/create-update-incidentstatus.component';
import { UpdateOrderIncidentComponent } from './incident/update-incident.component';
import { ViewIncidentComponent } from './incident/view-incident.component';

import { CreateIncidentNotesModalComponent } from './incident/create-incidentnote-modal';
import { CreateOrEditVehicleChecklistModalComponent } from './fleet-management/vehicleChecklists/vehicleChecklists/create-or-edit-vehicleChecklist-modal.component';
import { ViewVehicleChecklistModalComponent } from './fleet-management/vehicleChecklists/vehicleChecklists/view-vehicleChecklist-modal.component';
import { VehicleChecklistsComponent } from './fleet-management/vehicleChecklists/vehicleChecklists/vehicleChecklists.component';
import { UpdateGeoCodeModalComponent } from './locator/update-geocode.component';
import { EmployeesComponent } from './employees/employees/employees.component';
import { CreateEmployeeComponent } from './employees/employees/create-employee.component';
import { EditEmployeeComponent } from './employees/employees/edit-employee.component';
import { EmployeeIncidentTypesComponent } from './employees/employee-incident-types/employeeIncidentTypes.component';
import { CreateOrEditEmployeeIncidentTypeModalComponent } from './employees/employee-incident-types/create-or-edit-employeeIncidentType-modal.component';
import { ViewEmployeeIncidentTypeModalComponent } from './employees/employee-incident-types/view-employeeIncidentType-modal.component';
import { EmployeeIncidentsComponent } from './employees/employee-incidents/employee-incidents.component';
import { DriverIncidentTypesComponent } from './fleet-management/drivers/driver-incident-types/driverIncidentTypes.component';
import { ViewDriverIncidentTypeModalComponent } from './fleet-management/drivers/driver-incident-types/view-driverIncidentType-modal.component';
import { CreateOrEditDriverIncidentTypeModalComponent } from './fleet-management/drivers/driver-incident-types/create-or-edit-driverIncidentType-modal.component';
import { EditDriverIncidentComponent } from './employees/driver-incident/edit-driver-incident.component';
import { CreateEmployeeIncidentComponent } from './employees/employee-incidents/create-employee-incident.component';
import { EditEmployeeIncidentComponent } from './employees/employee-incidents/edit-employee-incident.component';
import { ViewDriverIncidentComponent } from './employees/driver-incident/view-driver-incident.component';
import { ViewEmployeeIncidentComponent } from './employees/employee-incidents/view-employee-incident.component';
import { ViewIncidentImagesModalComponent } from './employees/driver-incident/view-incident-images.component';
import { PackageOptionsComponent } from './package-management/package-options/package-option.component';
import { CreateOrEditPackageOptionModalComponent } from './package-management/package-options/create-or-edit-package-option-modal.component';
import { ViewPackageOptionModalComponent } from './package-management/package-options/view-package-option-modal.component';
import { ViewDriverProximitiesMapComponent } from './fleet-management/driver-proximities/view-driver-proximities-map.component';
import { DirectionsMapDirective } from './fleet-management/driver-proximities/driver-proximities.directive';
import { OrderNotes } from './controller/route-detail/order-notes.component';
import { ViewSupportTicketComponent } from './supportTicket/view-support-ticket.component';
import { SupportCategoryTypesComponent } from './supportTicket/supportCategoryTypes/supportCategoryTypes.component';
import { ViewSupportCategoryTypesModalComponent } from './supportTicket/supportCategoryTypes/view-supportCategoryTypes-modal.component';
import { CreateOrEditSupportCategoryTypesModalComponent } from './supportTicket/supportCategoryTypes/create-or-edit-supportCategoryTypes-modal.component';
import { ViewNotesModalComponent } from './controller/order-status/view-notes-modal.component';

import { SupportDocumentationComponent } from './supportTicket/support-documentation/support-documentation.component';
import { SupportOnBoardingGuideComponent } from './supportTicket/support-documentation/support-OnBoardingGuide.component';
import { SupportTrainingVideoComponent } from './supportTicket/support-documentation/support-trainingVideo.component';
import { SupportFAQComponent } from './supportTicket/support-documentation/support-FAQUrl.component';
import { GooglePlaceModule } from "ngx-google-places-autocomplete";
// import { ImportRouteScheduleTracking } from '@app/main/laboratory/clinics/route-schedule-import-tracking';

import { FreezeModalComponent } from './controller/modals/freeze-modal.component';
import { UnfreezeModalComponent } from './controller/modals/unfreeze-modal.component';
import { UnlockModalComponent } from './controller/modals/unlock-modal.component';
import { LockModalComponent } from './controller/modals/lock-modal.component';
import { RouteAnalyzerPickupComponent } from './routes/route-analyzer-pickup/route-analyzer.component';
import { RouteAnalyzerDeliveryComponent } from './routes/route-analyzer-delivery/route-analyzer.component';
import { PickupRouteAnalyzerFlyoutComponent } from '@app/shared/layout/flyout/pickup-route-analyzer-flyout/route-analyzer-flyout.component';
import { DeliveryRouteAnalyzerFlyoutComponent } from '@app/shared/layout/flyout/delivery-route-analyzer-flyout/route-analyzer-flyout.component';
import { CreateOrEditIncidentSourceModalComponent } from './incident/incident-sources/create-or-edit-incidentSource-modal.component';
import { IncidentSourcesComponent } from './incident/incident-sources/incidentSources.component';
import { ViewIncidentSourceModalComponent } from './incident/incident-sources/view-incidentSource-modal.component';
import { CreateNewRouteModalComponent } from './controller/routes/create-route-modal.component';
import { OrderGroupListTabComponent } from './controller/orders/order-list-group.component';
import { ControllerOrderPackagesGroupComponent } from './controller/order-packages/order-packages-group.component';
import { ControllerOrderIncidentsGroupComponent } from './controller/order-incident/order-incident-list-group.component';

import { UserOrderTypesComponent } from './order-management/user-order-types/userOrderTypes.component';
import { ViewUserOrderTypeModalComponent } from './order-management/user-order-types/view-userOrderType-modal.component';
import { CreateOrEditUserOrderTypeModalComponent } from './order-management/user-order-types/create-or-edit-userOrderType-modal.component';
import { CreateOrEditVersionModalComponent } from './settings/create-or-edit-version-modal.component';
import { VersionsComponent } from './settings/versions.component';
import { ViewVersionModalComponent } from './settings/view-version-modal.component';
import { UpdateOrderDetailAddressModalComponent } from './controller/order-detail/update-order-address-modal.component';
import { BreadcrumbModule } from 'primeng/primeng';

import { RouteGeneratorLogsComponent } from './routeGeneratorLogs/routeGeneratorLogs.component';
import { RouteGeneratorDashboardComponent } from './route-generator-dashboard/dashboard.component';
import { ViewRouteGeneratorLogModalComponent } from './routeGeneratorLogs/view-routeGeneratorLog-modal.component';
import { DataRetentionsComponent } from './data-retention/data-retention.component';
import { ViewDataRetentionModalComponent } from './data-retention/view-dataRetention-modal.component';
import { CreateOrEditDataRetentionModalComponent } from './data-retention/create-or-edit-dataRetention-modal.component';
import { ViewDataretentionLogModalComponent } from './data-retention/view-dataretention-log-modal.component';
import { UpdateCustomerAddressModalComponent } from './customer/edit-customer-address.component';
import { EditCustomerProfileModalComponent } from './customer/edit-customer-profile.component';
import { EditBusinessHoursModal } from './customer/edit-business-hours.component';
import { CustomerPortalComponent } from './customer/customer-portal.component';
import { CustomerTrackComponent } from './customer/customer-tracking.component';
import { CustomerOrderComponent } from './customer/customer-order.component';
import { CustomerDashboardComponent } from './customer/customer-dashboard.component';
import { CustomerMapModalComponent } from './customer/customer-map.component';
import { CustomerCallInModalComponent } from './customer/customer-callin.component';
import { EditContactPersonModal } from './customer/edit-contact-person.component';
import { CustomerDirectionsMapDirective } from './customer/customer-map.directive';
import { UpdateDeliveryNotesModalComponent } from './controller/order-detail/update-delivery-notes.component';
import { GanttComponent } from  './supportTicket/gantt-chart/gantt-chart.component';
import { RouteGenerationSettingsComponent } from './routeGenerationSettings/routeGenerationSettings.component';

import { ImageUrlComponent } from './image-url/image-url.component';
import { OrderStatusMappingsComponent } from './order-management/orderStatusMappings/orderStatusMappings.component';
import { ViewOrderStatusMappingModalComponent } from './order-management/orderStatusMappings/view-orderStatusMapping-modal.component';
import { CreateOrEditOrderStatusMappingModalComponent } from './order-management/orderStatusMappings/create-or-edit-orderStatusMapping-modal.component';
import { EditCPersonModalComponent } from './customer/edit-cperson.component';
import { DispatchDetailsLineHaulComponents } from './controller/dispatch/dispatch-details-linehaul.component';
import { GoogleMapsConfig } from 'AppPreBootstrap';
import { ContactPersonPermissionsModalComponent } from './customer/contact-person-permission.component';
import { PermissionTreeComponent } from '@app/admin/shared/permission-tree.component';
import { ContactPersonPermissionTreeComponent } from './customer/contact-person-permission-tree.component';
import { ClientConnectionsComponent } from './integration/client-connection/clientConnections.component';
import { CreateOrEditClientConnectionModalComponent } from './integration/client-connection/create-or-edit-clientConnection-modal.component';
import { ViewClientConnectionModalComponent } from './integration/client-connection/view-clientConnection-modal.component';
import { ClientAccountsComponent } from './integration/client-account/client-account.component';
import { CreateOrEditClientAccountModalComponent } from './integration/client-account/create-or-edit-client-account-modal.component';
import { DownloadOrdersModalComponent } from './integration/client-account/download-orders-modal.component';
import { ClientOrdersComponent } from './integration/client-orders/client-orders.component';
import { OrderLogComponent } from './integration/client-order-logs/order-log.component';
import { ViewOrderLogsModalComponent } from './integration/client-order-logs/view-order-logs.component';
import { CreateOrEditRecurringOrderScheduleModalComponent } from './order-management/recurring-order-schedules/create-or-edit-recurringOrderSchedule-modal.component';
import { RecurringOrderSchedulesComponent } from './order-management/recurring-order-schedules/recurringOrderSchedules.component';
import { ViewRecurringOrderScheduleModalComponent } from './order-management/recurring-order-schedules/view-recurringOrderSchedule-modal.component';
import { ClientDriverComponent } from './integration/client-drivers/client-driver.component';
import { ViewIncidentAttachmentComponent } from './incident/viewIncidentAttachment.component';
import { NgbModule } from "@ng-bootstrap/ng-bootstrap";
@NgModule({
    imports: [

        FormsModule,
        ReactiveFormsModule,
        CommonModule,
        FileUploadModule,
        ModalModule.forRoot(),
        TabsModule.forRoot(),
        TooltipModule.forRoot(),
        PopoverModule.forRoot(),
        BsDropdownModule.forRoot(),
        BsDatepickerModule.forRoot(),
        TimepickerModule.forRoot(),
        QuillModule.forRoot(),
        TimePickerModule,
        QRCodeModule,
        UtilsModule,
        AppCommonModule,
        TableModule,
        TreeModule,
        DragDropModule,
        ContextMenuModule,
        PaginatorModule,
        PrimeNgFileUploadModule,
        AutoCompleteModule,
        EditorModule,
        InputMaskModule,
        NgxChartsModule,
        CountoModule,
        TextMaskModule,
        ImageCropperModule,
        SprintShipRoutingModule,
        AngularFontAwesomeModule,
        AgmOverlays,
        BreadcrumbModule,
        AgmCoreModule.forRoot(),
        AgmJsMarkerClustererModule,
        NgSelectModule,
        ColorPickerModule,
        CalendarModule,
        AccordionModule,
        ToastModule,
        CarouselModule,
        ChipsModule,
        NgxDropzoneModule,
        MainModule,
        GooglePlaceModule,
        NgbModule
    ],
    declarations: [
        RecurringOrderSchedulesComponent,

		ViewRecurringOrderScheduleModalComponent,
		CreateOrEditRecurringOrderScheduleModalComponent,

        DispatchDetailsLineHaulComponents,
        RouteGenerationSettingsComponent,
        ViewDataretentionLogModalComponent,
        DataRetentionsComponent,
		ViewDataRetentionModalComponent,
		CreateOrEditDataRetentionModalComponent,
        RouteGeneratorLogsComponent,
        RouteGeneratorDashboardComponent,
        ViewRouteGeneratorLogModalComponent,
        ContainerComponent,
        CreateOrEditContainerModalComponent,
        CreateOrEditUserOrderTypeModalComponent,
        ViewUserOrderTypeModalComponent,
        UserOrderTypesComponent,
        IncidentSourcesComponent,
        ViewIncidentSourceModalComponent,
        CreateOrEditIncidentSourceModalComponent,
        OrderStatusTypeComponent,
        CreateOrderStatuTypeModalComponent,
        UpdateOrderStatuTypeModalComponent,
        OrderStatusTypesComponent,
        ViewOrderStatusTypeModalComponent,
        CreateOrEditOrderStatusTypeModalComponent,
        TagTypeComponent,
        CreateTagTypeModalComponent,
        UpdateTagTypeModalComponent,
        TagTypesComponent,
        CreateOrEditTagTypeModalComponent,
        ViewTagTypeModalComponent,
        OrderComponent,
        ClientOrdersComponent,
        TagComponent,
        CreateTagModalComponent,
        UpdateTagModalComponent,
        TagsComponent,
        CreateOrEditTagModalComponent,
        ViewTagModalComponent,
        CreateOrderModalComponent,
        UpdateOrderComponent,
        UpdateOrderAddressModalComponent,
        ViewOrderComponent,
        CreateOrderComponent,
        OrderPackageComponent,
        CreateOrderPackageModalComponent,
        UpdateOrderPackageModalComponent,
        OrderPackagesComponent,
        ViewOrderPackageModalComponent,
        CreateOrEditOrderPackageModalComponent,
        OrderStatusComponent,
        CreateOrderStatusComponent,
        CreateOrEditOrderStatusModalComponent,
        OrderStatusesComponent,
        ViewOrderStatusModalComponent,
        // FleetsComponent,
        // CreateFleetModalComponent,
        // EditFleetModalComponent,
        FleetsComponent,
        ViewFleetModalComponent,
        CreateOrEditFleetModalComponent,
        DriversComponent,
        CreateDriverComponent,
        EditDriverComponent,
        DriverEditComponent,
        ViewDriverCompnent,
        DriversPermissionsComponent,
        VendorsComponent,
        CreateVendorComponent,
        EditVendorComponent,
        VehiclesComponent,
        CreateVehicleModalComponent,
        EditVehicleModalComponent,
        RoutesComponent,
        CreateRouteModalComponent,
        EditRouteModalComponent,
        RoutesTemplateComponent,
        RouteTemplateTypesComponent,
        CreateRouteTemplateTypeModalComponent,
        EditRouteTemplateTypeModalComponent,
        CreateOrEditRoutesTemplateModalComponent,
        EditContactModalComponent,
        CreateUpdateLocationComponent,
        EditLocationComponent,
        ContactComponent,
        CreateContactModalComponent,
        CreateContactComponent,
        EditContactComponent,
        // AddressTypeComponent,
        // CreateAddressTypeModalComponent,
        // UpdateAddressTypeModalComponent,
        AddressesComponent,
        AddressTypesComponent,
        ViewAddressTypeModalComponent,
        CreateOrEditAddressTypeModalComponent,
        // TimeZonesComponent,
        // CreateTimeZoneModalComponent,
        // EditTimeZoneModalComponent,
        TimeZonesComponent,
        ViewTimeZoneModalComponent,
        CreateOrEditTimeZoneModalComponent,
        ProximityComponent,
        EditProximityModalComponent,
        CreateProximityModalComponent,
        LocationsComponent,
        CreateLocationModalComponent,
        EditLocationModalComponent,
        DriverProximitiesComponent,
        VehicleLocationComponent,
        CreateVehicleLocationModalComponent,
        EditVehicleLocationModalComponent,
        UserLocationComponent,
        CreateUserLocationModalComponent,
        EditUserLocationModalComponent,
        IncidentComponent,
        CreateIncidentModalComponent,
        EditIncidentModalComponent,
        ViewIncidentImageModalComponent,
        PackagesComponent,
        CreateOrEditPackageModalComponent,
        ViewPackageModalComponent,
        PackageTypeComponent,
        CreatePackageTypeModalComponent,
        UpdatePackageTypeModalComponent,
        TimeSheetComponent,
        CreateOrEditTimeSheetModalComponent,
        ViewTimeSheetModalComponent,
        EmployeeReviewComponent,
        CreateOrEditEmployeeReviewModalComponent,
        DriverIncidentsComponent,
        CreateOrEditDriverIncidentComponent,
        ViewAddressModalComponent,
        SetOverridableAddressTypeModalComponent,
        CreateOrEditAddressModalComponent,
        EmailComponent,
        CreateEmailModalComponent,
        ContactFormComponent,
        PostalCodesComponent,
        PostalCodeZonesComponent,
        ViewPostalCodeModalComponent,
        CreateOrEditPostalCodeModalComponent,
        CRoutesComponent,
        GenerateRoutesTrackingComponent,
        GenerateRoutesLaboratoryTrackingComponent,
        KPIBoxComponent,
        TableComponents,
        RouteDetailComponent,
        //MapFlyOutComponent,
        //LaboratoryMapFlyOutComponent,
        // TableRoutesComponents,
        DevicesComponent,
        StatusComponent,
        CheckBoxComponent,
        //LocatorComponent,
        DriverListTabComponent,
        VehicleListTabComponent,
        OrderListTabComponent,
        ControllerShowHideComponent,
        HFRouteDetailComponent,
        LabRouteDetailComponent,
        //MoveOrderModalComponent,
        RouteDetailModal,
        UserPreferencesFlyoutComponent,
        ControllerOrderPackagesComponent,
        OrderDetailComponent,
        VehicleDetailComponent,
        ClinicNotes,
        EditCountNotes,
        ControllerOrderPackageDetailComponent,
        DriverDetailComponent,
        CreateRouteControllerModalComponent,
        MovePendingOrder,
        ChangeEta,
        DriverDetailComponent,
        UnassignedPackagesComponent,
        AddOrderStatusComponent,
        ViewOrderStatusComponent,
        TimerComponent,
        OrderAttachment,
        AddOrderStatusModalComponent,
        TimerComponent,
        ImportOrderTrackingComponent,

        AddBatchOrderStatusModalComponent,
        CreateIncidentsModal,
        ControllerOrderIncidentsComponent,
        ViewOrderIncidentComponent,
        RoutesListComponent,
        RoutesEditorComponent,
        RoutesMapComponent,
        RoutesOptimizationComponent,
        ViewOrderIncidentComponent,
        CreateIncidentsModal,
        CreateIncidentComponent,
        IncidentNotesModalComponent,
        ControllerHeaderFlyoutComponent,
        RouteDetailAttachment,
        ViewVendorComponent,
        DriverProximityFlyOutComponent,


        ViewRouteModalComponent,
        MarkAsCompleteModalComponent,
        OrderTypesComponent,
        CreateOrEditOrderTypeModalComponent,
        ViewOrderTypeModalComponent,
        ViewContactModalComponent,
        ViewVehicleModalComponent,
        AssignedToDriverModalComponent,
        ViewUnassignedStopsComponent,
        PrintRouteSheetLaboratoryComponent,
        RouteSheetLaboratoryComponent,
        NotAllowedComponent,
        FBXRouteDetailComponent,
        ReportPackagePerPostalCodeComponent,
        NotAllowedComponent,
        EditOrderContactDetailModalComponent,
        CreateZoneModalComponent,
        RouteReportComponent,
        DriverDevicesComponent,
        FleetsUnitComponent,
        FleetUsersComponent,
        FleetVehiclesComponent,
        FleetRatesComponent,
        FleetsTreeComponent,
        FleetAddRateComponent,
        FleetAddDriverComponent,
        FleetAddVehicleComponent,
        TrackingPageComponent,
        DispatchDetailsComponents,
        DispatchDetailsGroupComponents,
        DeleteRoutesModalComponent,
        DeleteRoutesComponent,
        DriverDevicesComponent,
        StatisticsComponent,
        VehicleTypesComponent,
        CreateOrEditVehicleTypeModalComponent,
        ViewVehicleTypeModalComponent,
        //DriverDevicesComponent,
        ViewZoneModalComponent,
        EditZoneModalComponent,
        MileageReimbursementComponent,
        OrderNotificationTemplatesComponent,
        ViewOrderNotificationTemplateModalComponent,
        CreateOrEditOrderNotificationTemplateModalComponent,
        OrderNotificationsComponent,
        ViewOrderNotificationModalComponent,
        CreateOrEditOrderNotificationModalComponent,
        SmsAccountsComponent,
        ViewSmsAccountModalComponent,
        CreateOrEditSmsAccountModalComponent,
        SmsTemplatesComponent,
        ViewSmsTemplateModalComponent,
        CreateOrEditSmsTemplateModalComponent,
        TestNotificationComponent,
        SupportTicketsComponent,
        SupportKPIBoxComponent,
        CreateSupportTicketComponent,
        TicketNotesModalComponent,
        EditSupportTicketComponent,
        AssignModalComponent,
        AssignTenantComponent,
        TicketStatusComponent,
        TicketTypeComponent,
        CreateOrEditTicketTypeModalComponent,
        CreateOrEditTicketStatusModalComponent,
        KpiLaboratoryComponent,
        MileageReimbursementComponent,
        TicketSettingComponent,
        CreateOrEditTicketSettingModalComponent,
        SupportTicketNotificationsComponent,
        ViewSupportTicketNotificationModalComponent,
        CreateOrEditSupportTicketNotificationModalComponent,
        WillCallComponent,
        IncidentTypeComponent,
        CreateUpdateIncidentTypeComponent,
        IncidentStatusComponent,
        CreateUpdateIncidentStatusComponent,
        CreateIncidentComponent,
        UpdateOrderIncidentComponent,
        ViewIncidentComponent,
        CreateIncidentNotesModalComponent,
        VehicleChecklistsComponent,
        ViewVehicleChecklistModalComponent,
        CreateOrEditVehicleChecklistModalComponent,
        NoDataComponent,
        LoadingComponent,
        //UpdateGeoCodeModalComponent,
        EmployeesComponent,
        CreateEmployeeComponent,
        EditEmployeeComponent,
        EmployeeIncidentTypesComponent,
        CreateOrEditEmployeeIncidentTypeModalComponent,
        ViewEmployeeIncidentTypeModalComponent,
        EmployeeIncidentsComponent,
        DispatchProximityComponent,
        DriverIncidentTypesComponent,
        ViewDriverIncidentTypeModalComponent,		
        CreateOrEditDriverIncidentTypeModalComponent,
        EditDriverIncidentComponent,
        CreateEmployeeIncidentComponent,
        EditEmployeeIncidentComponent,
        ViewDriverIncidentComponent,
        ViewEmployeeIncidentComponent,
        ViewIncidentImagesModalComponent,
        PackageOptionsComponent,
        CreateOrEditPackageOptionModalComponent,
        ViewPackageOptionModalComponent,
        ViewDriverProximitiesMapComponent,
        DirectionsMapDirective,
        OrderNotes,
        ViewSupportTicketComponent,
        SupportCategoryTypesComponent,
        SupportDocumentationComponent,
        SupportOnBoardingGuideComponent,
        SupportTrainingVideoComponent,
        SupportFAQComponent,
        ViewSupportCategoryTypesModalComponent,		
        CreateOrEditSupportCategoryTypesModalComponent,
        ViewNotesModalComponent,
        RouteAnalyzerPickupComponent,
        RouteAnalyzerDeliveryComponent,
        DeliveryRouteAnalyzerFlyoutComponent,
        PickupRouteAnalyzerFlyoutComponent,
        FreezeModalComponent,
        UnfreezeModalComponent,
        UnlockModalComponent,
        LockModalComponent,
        CreateNewRouteModalComponent,
        OrderGroupListTabComponent,
        ControllerOrderPackagesGroupComponent,
        ControllerOrderIncidentsGroupComponent,
        CreateOrEditVersionModalComponent,
        VersionsComponent,
        ViewVersionModalComponent,
        UpdateOrderDetailAddressModalComponent,
        EditCustomerProfileModalComponent,
        UpdateCustomerAddressModalComponent,
        EditBusinessHoursModal,
        CustomerPortalComponent,
        CustomerTrackComponent,
        CustomerOrderComponent,
        CustomerDashboardComponent,
        CustomerMapModalComponent,
        CustomerCallInModalComponent,
        EditContactPersonModal,
        CustomerDirectionsMapDirective,
        UpdateDeliveryNotesModalComponent,
        GanttComponent,
        ImageUrlComponent,
		OrderStatusMappingsComponent,
		ViewOrderStatusMappingModalComponent,
		CreateOrEditOrderStatusMappingModalComponent,
		RatesComponent,
    BillingComponent,
		CreateOrEditRatesComponent,
        RatesDescriptionModalComponent,
        EditCPersonModalComponent,
        ContactPersonPermissionsModalComponent,
        ContactPersonPermissionTreeComponent,
        ClientConnectionsComponent,
		ViewClientConnectionModalComponent,		
        CreateOrEditClientConnectionModalComponent,
        ClientAccountsComponent,
        CreateOrEditClientAccountModalComponent,
        DownloadOrdersModalComponent,
        OrderLogComponent,
        ViewOrderLogsModalComponent,
        ClientDriverComponent,
        ViewIncidentAttachmentComponent
    ],
    exports: [
        OrderDetailComponent,
        DirectionsMapDirective,
        CustomerDirectionsMapDirective,
        OrderAttachment,
        GenerateRoutesTrackingComponent,
        MovePendingOrder
        // ImportRouteScheduleTracking
    ],
    providers: [
        TreeDragDropService,
        { provide: BsDatepickerConfig, useFactory: NgxBootstrapDatePickerConfigService.getDatepickerConfig },
        { provide: BsDaterangepickerConfig, useFactory: NgxBootstrapDatePickerConfigService.getDaterangepickerConfig },
        { provide: BsLocaleService, useFactory: NgxBootstrapDatePickerConfigService.getDatepickerLocale },
        { provide: LAZY_MAPS_API_CONFIG, useClass: GoogleMapsConfig},
        DatePipe
    ]
    // ,
    // entryComponents: [EditDriverComponent]
})
export class SprintShipModule { }
function Injectable() {
    throw new Error('Function not implemented.');
}

