﻿import { Component, ViewChild, Injector, Output, EventEmitter } from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { GetSupportTicketNotificationForViewDto, SupportTicketNotificationDto } from '@shared/service-proxies/service-proxies';
import { AppComponentBase } from '@shared/common/app-component-base';

@Component({
    selector: 'viewSupportTicketNotificationModal',
    templateUrl: './view-supportTicketNotification-modal.component.html'
})
export class ViewSupportTicketNotificationModalComponent extends AppComponentBase {

    @ViewChild('createOrEditModal', { static: true }) modal: ModalDirective;
    @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();

    active = false;
    saving = false;

    item: GetSupportTicketNotificationForViewDto;


    constructor(
        injector: Injector
    ) {
        super(injector);
        this.item = new GetSupportTicketNotificationForViewDto();
        this.item.supportTicketNotification = new SupportTicketNotificationDto();
    }

    show(item: GetSupportTicketNotificationForViewDto): void {
        this.item = item;
        this.active = true;
        this.modal.show();
    }

    close(): void {
        this.active = false;
        this.modal.hide();
    }
}
