import { Component, ViewChild, Injector, Output, EventEmitter} from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { finalize } from 'rxjs/operators';
import { SupportTicketTypeServiceProxy, TicketTypeList, CreateTicketTypeDto, UpdateTicketTypeDto } from '@shared/service-proxies/service-proxies';
import { AppComponentBase } from '@shared/common/app-component-base';
import * as moment from 'moment';
declare var $: any;

@Component({
    selector: 'createOrEditTicketTypeModal',
    templateUrl: './create-or-edit-ticket-type.component.html'
})
export class CreateOrEditTicketTypeModalComponent extends AppComponentBase {

    @ViewChild('createOrEditModal', { static: true }) modal: ModalDirective;


    @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();

    active = false;
    saving = false;

    isActive = false;    
    selectedStartDay:string;
    selectedEndDay:string;
    //createTicketType: CreateTicketTypeDto = new CreateTicketTypeDto();
    ticketType: UpdateTicketTypeDto = new UpdateTicketTypeDto();



    constructor(
        injector: Injector,
        private _typesServiceProxy: SupportTicketTypeServiceProxy
    ) {
        super(injector);
    }

    show(ticketType?: any): void {

        if (!ticketType) {
            this.ticketType = new CreateTicketTypeDto();
            //this.routeType.id = routeTypeId;
            this.ticketType.color = '#000000';
            this.active = true;
            this.modal.show();
        } else {

            this.ticketType = ticketType;
            if(this.ticketType.inactive == false) {
                this.isActive = true;
            }
            this.active = true;
            this.modal.show();

        }
    }

    save(): void {
            this.saving = true;
            if(this.isActive == true) {
                this.ticketType.inactive = false;
            }
            else {
                this.ticketType.inactive = true;
            }

            if(this.ticketType.id) {
                this._typesServiceProxy.updateTicketType(this.ticketType)
                 .pipe(finalize(() => { this.saving = false;}))
                 .subscribe(() => {
                    this.notify.info(this.l('SavedSuccessfully'));
                    this.close();
                    this.modalSave.emit(null);
                 });
            }
            else {
                this._typesServiceProxy.createTicketType(this.ticketType)
                 .pipe(finalize(() => { this.saving = false;}))
                 .subscribe(() => {
                    this.notify.info(this.l('SavedSuccessfully'));
                    this.close();
                    this.modalSave.emit(null);
                 });
            }

            
    }







    close(): void {

        this.active = false;
        this.isActive = false;
        this.modal.hide();
    }
}
