﻿import { Component, ViewChild, Injector, Output, EventEmitter } from '@angular/core';
import { ModalDirective } from 'ngx-bootstrap';
import { GetSupportCategoryTypesForViewDto, SupportCategoryTypesDto } from '@shared/service-proxies/service-proxies';
import { AppComponentBase } from '@shared/common/app-component-base';

@Component({
    selector: 'viewSupportCategoryTypesModal',
    templateUrl: './view-supportCategoryTypes-modal.component.html'
})
export class ViewSupportCategoryTypesModalComponent extends AppComponentBase {

    @ViewChild('createOrEditModal', { static: true }) modal: ModalDirective;
    @Output() modalSave: EventEmitter<any> = new EventEmitter<any>();

    active = false;
    saving = false;

    item: GetSupportCategoryTypesForViewDto;


    constructor(
        injector: Injector
    ) {
        super(injector);
        this.item = new GetSupportCategoryTypesForViewDto();
        this.item.supportCategoryTypes = new SupportCategoryTypesDto();
    }

    show(item: GetSupportCategoryTypesForViewDto): void {
        this.item = item;
        this.active = true;
        this.modal.show();
    }

    close(): void {
        this.active = false;
        this.modal.hide();
    }
}
