import { Component, Injector, OnInit, ViewChild, ViewEncapsulation, AfterViewInit } from '@angular/core';
import { ActivatedRoute } from '@angular/router';
import { TokenAuthServiceProxy } from '@shared/service-proxies/service-proxies';
import { AppConsts } from '@shared/AppConsts';
import { appModuleAnimation } from '@shared/animations/routerTransition';
import { AppComponentBase } from '@shared/common/app-component-base';
import { CallInModalComponent } from '../controller/modals/call_in_modal.component';

import * as _ from 'lodash';

@Component({
    templateUrl: './willcall.component.html',
    encapsulation: ViewEncapsulation.None,
    animations: [appModuleAnimation()],
})
export class WillCallComponent extends AppComponentBase implements AfterViewInit {    
    @ViewChild('callInModal', { static: false }) viewCallInModal: CallInModalComponent;
    showModal: any

    constructor(
        injector: Injector,    
        private _tokenAuth: TokenAuthServiceProxy,
        private _activatedRoute: ActivatedRoute,    
    ) {
        super(injector);
    }
    ngOnInit(): void {
      
    }
    ngAfterViewInit() {
        this.viewCallInModal.show();
      }
}
