import { Pipe, PipeTransform } from '@angular/core';
import { parsePhoneNumber } from 'libphonenumber-js';

@Pipe({
  name: 'phoneFormat'
})
export class PhoneFormatPipe implements PipeTransform {
  transform(phoneValue: number | string): string {
    if(phoneValue != "")
    {
        const stringPhone = phoneValue + '';
        const phoneNumber = parsePhoneNumber(stringPhone, 'US');
        const formatted = phoneNumber.formatNational();
        return formatted;
    }
    return null;
  }
}