﻿import { AbpHttpInterceptor, RefreshTokenService } from '@abp/abpHttpInterceptor';
import { HTTP_INTERCEPTORS } from '@angular/common/http';
import { NgModule } from '@angular/core';
import * as ApiServiceProxies from './service-proxies';
import { ZeroRefreshTokenService } from '@account/auth/zero-refresh-token.service';

@NgModule({
    providers: [
        ApiServiceProxies.RouteTemplateOrderExtrasServiceProxy,        
        ApiServiceProxies.RecurringOrderSchedulesServiceProxy,        
        ApiServiceProxies.ClientConnectionsServiceProxy,
        ApiServiceProxies.ClientAccountsServiceProxy,  
        ApiServiceProxies.OrderStatusMappingsServiceProxy,        
        ApiServiceProxies.RouteGenerationSettingsServiceProxy,        
        ApiServiceProxies.RouteGeneratorLogsServiceProxy,
        ApiServiceProxies.DataRetentionsServiceProxy,        
        ApiServiceProxies.ContainersServiceProxy,
        ApiServiceProxies.RouteHandOffDefinitionsServiceProxy,
        ApiServiceProxies.RouteHandOffScheduleDetailsServiceProxy,
        ApiServiceProxies.VersionsServiceProxy,        
        ApiServiceProxies.OrderSourceConnectionsServiceProxy,        
        ApiServiceProxies.OrderSourcesServiceProxy,        
        ApiServiceProxies.UserOrderTypesServiceProxy,        
        ApiServiceProxies.ImportLogMessagesServiceProxy,
        ApiServiceProxies.ImportLogsServiceProxy,
        ApiServiceProxies.ImportMappingsServiceProxy,
        ApiServiceProxies.ExportMappingsServiceProxy,
        ApiServiceProxies.SupportCategoryTypesServiceProxy,        
        ApiServiceProxies.DriverIncidentTypesServiceProxy,         
        ApiServiceProxies.HolidaysServiceProxy,
        ApiServiceProxies.SupportTicketNotificationsServiceProxy, 
        ApiServiceProxies.SupportTicketNotificationRecipientsServiceProxy, 
        ApiServiceProxies.SmsTemplatesServiceProxy,
        ApiServiceProxies.SmsAccountsServiceProxy,
        ApiServiceProxies.OrganizationUnitOrderNotificationsServiceProxy,
        ApiServiceProxies.OrderNotificationsServiceProxy,        
        ApiServiceProxies.OrderNotificationTemplatesServiceProxy,   
        ApiServiceProxies.VehicleChecklistsServiceProxy,  
        ApiServiceProxies.VehicleTypesServiceProxy,        
        ApiServiceProxies.Route4MeSettingsServiceProxy,        
        ApiServiceProxies.BackgroundProcessesServiceProxy,        
        ApiServiceProxies.OrderTypesServiceProxy,        
        ApiServiceProxies.ImportMapsServiceProxy,        
        ApiServiceProxies.ImportFieldsServiceProxy,        
        ApiServiceProxies.ImportTablesServiceProxy,        
        ApiServiceProxies.UserPreferencesServiceProxy,        
        ApiServiceProxies.ClientPreferencesServiceProxy,        
        ApiServiceProxies.PreferencesServiceProxy,        
        ApiServiceProxies.TagTypesServiceProxy,        
        ApiServiceProxies.OrderStatusTypesServiceProxy,
        ApiServiceProxies.RouteDefinitionsServiceProxy,        
        ApiServiceProxies.OrderStatusesServiceProxy,        
        ApiServiceProxies.OrderPackagesServiceProxy,        
        ApiServiceProxies.TagsServiceProxy,        
        ApiServiceProxies.PackagesServiceProxy,        
        ApiServiceProxies.AddressesServiceProxy,        
        ApiServiceProxies.PostalCodesServiceProxy,        
        ApiServiceProxies.AddressTypesServiceProxy,        
        ApiServiceProxies.TimeZonesServiceProxy,        
        ApiServiceProxies.FleetsServiceProxy,        
        ApiServiceProxies.RouteTypesServiceProxy,        
        ApiServiceProxies.RouteScheduleDetailsServiceProxy,        
        ApiServiceProxies.RouteSchedulesServiceProxy,        
        ApiServiceProxies.RouteStopsServiceProxy,        
        ApiServiceProxies.ClinicsServiceProxy,        
        ApiServiceProxies.AuditLogServiceProxy,
        ApiServiceProxies.CachingServiceProxy,
        ApiServiceProxies.ChatServiceProxy,
        ApiServiceProxies.CommonLookupServiceProxy,
        ApiServiceProxies.EditionServiceProxy,
        ApiServiceProxies.FriendshipServiceProxy,
        ApiServiceProxies.HostSettingsServiceProxy,
        ApiServiceProxies.InstallServiceProxy,
        ApiServiceProxies.LanguageServiceProxy,
        ApiServiceProxies.NotificationServiceProxy,
        ApiServiceProxies.OrganizationUnitServiceProxy,
        ApiServiceProxies.PermissionServiceProxy,
        ApiServiceProxies.ProfileServiceProxy,
        ApiServiceProxies.RoleServiceProxy,
        ApiServiceProxies.SessionServiceProxy,
        ApiServiceProxies.TenantServiceProxy,
        ApiServiceProxies.TenantDashboardServiceProxy,
        ApiServiceProxies.TenantSettingsServiceProxy,
        ApiServiceProxies.TimingServiceProxy,
        ApiServiceProxies.UserServiceProxy,
        ApiServiceProxies.UserLinkServiceProxy,
        ApiServiceProxies.UserLoginServiceProxy,
        ApiServiceProxies.WebLogServiceProxy,
        ApiServiceProxies.AccountServiceProxy,
        ApiServiceProxies.TokenAuthServiceProxy,
        ApiServiceProxies.TenantRegistrationServiceProxy,
        ApiServiceProxies.HostDashboardServiceProxy,
        ApiServiceProxies.PaymentServiceProxy,
        ApiServiceProxies.DemoUiComponentsServiceProxy,
        ApiServiceProxies.InvoiceServiceProxy,
        ApiServiceProxies.SubscriptionServiceProxy,
        ApiServiceProxies.InstallServiceProxy,
        ApiServiceProxies.UiCustomizationSettingsServiceProxy,
        ApiServiceProxies.PayPalPaymentServiceProxy,
        ApiServiceProxies.StripePaymentServiceProxy,
        
        //for shipping
        
        ApiServiceProxies.TimeZoneServiceProxy,
        ApiServiceProxies.ProximityServiceProxy,
        ApiServiceProxies.VehicleLocationServiceProxy,
        ApiServiceProxies.UserLocationServiceProxy,

        //for shipping

        ApiServiceProxies.VehicleServiceProxy,
        ApiServiceProxies.FleetServiceProxy,
        ApiServiceProxies.FleetUserServiceProxy,
        ApiServiceProxies.FleetVehicleServiceProxy,
        ApiServiceProxies.FleetRateServiceProxy,
       
        ApiServiceProxies.OrderStatusTypeServiceProxy,
        ApiServiceProxies.OrderStatusTypeDescriptionServiceProxy,
        ApiServiceProxies.TagTypeServiceProxy,
        ApiServiceProxies.TagServiceProxy,
        ApiServiceProxies.OrderServiceProxy,
        ApiServiceProxies.LocationServiceProxy,

        // ApiServiceProxies.LocationPackageServiceProxy,
        // ApiServiceProxies.CurrencyServiceProxy,

        ApiServiceProxies.RouteServiceProxy,
        ApiServiceProxies.LocationServiceProxy,
        ApiServiceProxies.VehicleServiceProxy,
        ApiServiceProxies.RouteTemplateServiceProxy,
        ApiServiceProxies.RouteTemplateTypeServiceProxy,
        ApiServiceProxies.AddressTypeServiceProxy,
        ApiServiceProxies.ContactServiceProxy,
        ApiServiceProxies.AddressServiceProxy,
        ApiServiceProxies.OrderPackageServiceProxy,
        ApiServiceProxies.OrderStatusServiceProxy,
        ApiServiceProxies.PhoneServiceProxy,
        ApiServiceProxies.EmailServiceProxy,
        ApiServiceProxies.CompanyServiceProxy,
        
        ApiServiceProxies.PostalCodeServiceProxy,
        ApiServiceProxies.PostalCodeZoneServiceProxy,

        ApiServiceProxies.RouteTemplateTypeServiceProxy,
        ApiServiceProxies.ShippingPackageServiceProxy,

        ApiServiceProxies.EmployeeReviewServiceProxy,
        ApiServiceProxies.TimeSheetServiceProxy,
        ApiServiceProxies.DriverIncidentServiceProxy,
        ApiServiceProxies.IncidentServiceProxy,
        ApiServiceProxies.IncidentImageServiceProxy,
        ApiServiceProxies.ImageServiceProxy,
        ApiServiceProxies.GeocodeServiceProxy,
        ApiServiceProxies.ReviewServiceProxy,
        ApiServiceProxies.DriversServiceProxy,
        ApiServiceProxies.DriverClientServiceProxy,
        ApiServiceProxies.VendorsServiceProxy,
        ApiServiceProxies.ControllerRouteDetailServiceProxy,
        ApiServiceProxies.ControllerKpiCountServiceProxy,

        ApiServiceProxies.NoteServiceProxy,
        ApiServiceProxies.ZoneServiceProxy,
        ApiServiceProxies.RouteTemplateZoneServiceProxy,
        ApiServiceProxies.OrderIncidentsServiceProxy,
        ApiServiceProxies.IncidentTypesServiceProxy,
        ApiServiceProxies.OrderIncidentsServiceProxy,


        ApiServiceProxies.ControllerRouteServiceProxy,
        ApiServiceProxies.LocatorServiceProxy,
        ApiServiceProxies.OrderStatusAttachmentServiceProxy,
        ApiServiceProxies.ControllerOrderPackagesListServiceProxy,
        ApiServiceProxies.Route4MeServiceProxy,
        ApiServiceProxies.MobileThemeServiceProxy,
        ApiServiceProxies.MobileAppVersionServiceProxy,
        ApiServiceProxies.MobileClientServiceProxy,
        ApiServiceProxies.CachedRequestSettingServiceProxy,
        ApiServiceProxies.TextToSpeechSettingsServiceProxy,
        ApiServiceProxies.DestinationDetailServiceProxy,
        ApiServiceProxies.SupportTicketServiceProxy,
        ApiServiceProxies.SupportTicketTypeServiceProxy,
        ApiServiceProxies.SupportTicketStatusServiceProxy,
        ApiServiceProxies.SupportTicketSettingServiceProxy,

        ApiServiceProxies.WillCallServiceServiceProxy,
        ApiServiceProxies.IncidentTypesServiceProxy,
        ApiServiceProxies.IncidentStatusServiceProxy,

        ApiServiceProxies.EmployeesServiceProxy,
        ApiServiceProxies.EmployeeIncidentTypesServiceProxy,
        ApiServiceProxies.EmployeeIncidentsServiceProxy,
        ApiServiceProxies.RouteOptimizationServiceProxy,
        ApiServiceProxies.DriverIncidentsServiceProxy,

        ApiServiceProxies.DriverProximityServiceProxy,
        ApiServiceProxies.GoogleDirectionOptimizationServiceProxy, 
        ApiServiceProxies.RouteOptimizersServiceProxy,
        ApiServiceProxies.RouteAnalyzerServiceProxy,
        ApiServiceProxies.ReportServiceProxy,
        ApiServiceProxies.DashboardServiceProxy,
        ApiServiceProxies.DashboardCustomizationServiceProxy,
        ApiServiceProxies.RouteBuilderServiceProxy,
        ApiServiceProxies.ControllerPrintRouteSheetServiceProxy,
        ApiServiceProxies.StatisticsServiceProxy,
        ApiServiceProxies.CustomerServiceProxy,
        ApiServiceProxies.BusinessHoursServiceProxy,
        ApiServiceProxies.ContactPersonsServiceProxy,
        ApiServiceProxies.WebhookSubscriptionServiceProxy,
        ApiServiceProxies.WebhookSendAttemptServiceProxy,
        ApiServiceProxies.WebhookEventServiceProxy,
        
        ApiServiceProxies.RouteGeneratorDashboardServiceProxy,
        ApiServiceProxies.SecondaryConnectionServiceProxy,
        ApiServiceProxies.RateServiceProxy,
        ApiServiceProxies.ShippingRoleActionServiceProxy,
        ApiServiceProxies.ClientLogsServiceProxy,
        ApiServiceProxies.SprintTekDbLoggingServiceProxy,
        ApiServiceProxies.ContactGroupServiceProxy,
        ApiServiceProxies.ClientDriverServiceProxy,
        ApiServiceProxies.GoogleApiServiceServiceProxy,
        ApiServiceProxies.DriverRatingServiceProxy,
        { provide: RefreshTokenService, useClass: ZeroRefreshTokenService },
        { provide: HTTP_INTERCEPTORS, useClass: AbpHttpInterceptor, multi: true }
    ]
})
export class ServiceProxyModule { }
